/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author, the holder of the
economic rights, and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading, using, modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate, and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and, more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
/* **********************preprocessor options:
* not replacable
-DUNIX_PARAL -DWAITNOINCL -DNEEDISINF
* luxury (runtime settings may do):
-DKRIGITNBR=<n> -DPAC -DPACanc -DPCG -DPROCESSORNBR
* Not sure:
-DENDFILE -DCLUSTERSPY
// machines reconnues :(#ifdef) sun,sgi,IBM
*/
// THIS IS THE MAIN FILE
#include <limits>   //std::isinf ?
#include <cstdio>
#include <iostream> // cout...
#include <fstream> // ofstream
#include <sstream> //stringstream
#include <cstdlib>
#include <unistd.h> //pas de cunistd
#include <vector>
#include <string>
#if (defined(linux))
#include <sys/time.h>
#include <sys/resource.h>
#endif
//utilisation des float ou double dans dg.h
//pour d['e]buggage : (sert que si DEBUG est d['e]fini dans migraine.h, d['e]finir aussi cinGetOnError=true ci dessous dans main)
//voir aussi bool inputCheckBool=false; dans genepop.cpp
bool DebugHypercube=false;//divers affichages pour le latin hypercube sampling et design des points
bool DebugPiSample=false;//affiche tous les Pis avec debugPi=true sur echantillon de d['e]part (avant de lancer un vrai run)
bool DebugGpSample=false;//affichages divers pour debuggage lecture fichier genepop
bool DebugNexusSample=false;//affichages divers pour debuggage lecture fichier nexus
bool DebugSplit=false;//affiche tous changements dus a split pendant les runs
bool DebugPopVarSize=false;//affiche tous changements dus a la variation de taille de pop pendant les runs, aussi pour FounderFlush
bool DebugBisection=false;//affiche les calculs de fonction utilis['e]e par la bisection serach (exp ou logistique piour PopVarSize)
bool DebugSD=false;//affiche tout pour calcul des PI onepop=SD, mais pas la matrice MatriceSD
bool DebugSD2=false;//affiche calculs de la matrice MatriceSD
bool DebugPi=false;//affichage des Pis autres que OnePop=SD (= que 2popDG et twopop PIM)
bool DebugSigmaPi=false;//pour trouver le premier instance de non-cumul des Pi à 1
bool DebugPiSMM=false;//affichage des calculs interm['e]diaires pour les Pis SMM 2pop et OnePOp non SD
bool DebugProposal=false;//affiche les proposals avant chaque evenement en mettant random=1.2 et donc en consid['e]rant tous les evenements
bool DebugPAC=false;//affiche les calculs intermédiaires de PAC et PACanc
bool DebugDGISM=false;//affichage des chanements trouv['e]s dans change() (le Pi, Change et Weight) pour ISM dans DIG'04a,b  et Hobolth et al. (2008)
bool DebugDG=false;//affichage des changements trouv['e]s dans change() (Pi, Change et Weight) pour debuggage de DG2002 et Eigen (exFRRL)
bool DebugDG2=false;//affichage des random et cumul dans Change()
bool DebugChoosePopType=false;//debuggage de ChoosePopType()
bool DebugIIS=false; // debuggage des procedures de calculs de proba de paires de genes, juste commence, a completer
bool gaussdebug=false;//debugage de la procedure d'elimination gausienne de griffiths (sur run)
bool PrintLikelihood=false;//affiche le point, l'['e]chantillon, les vraisemblance de chaque run (= chaque arbre) et la matrice de mutation (= debug level 1)
bool PrintSuiviLikelihood=false;//imprime dans un fichier es likelihood a chaque run pour 1 point pour v['e]rifications

#ifdef UNIX_PARAL // compiler -DUNIX_PARAL
int AvailableProcessors=1;
int MaxSimultJobs;
#ifndef NOWAITINCL  // and if not compiler -DWAITNOINCL
#include <wait.h>
#endif //NOWAITINCL
#else
int MaxSimultJobs=1; //const mais doit avoir le meme type en paral ou non
#endif //UNI_PARAL
// http://lists.freebsd.org/pipermail/freebsd-bugs/2003-June/001440.html ?
#ifdef NEEDISINF // compiler option -DNEEDISINF pour station IFR et SGI
#include <float.h>
#define std::isinf(x) (( (x) > FLT_MAX ) || ( (x) < -FLT_MAX ))
#endif //NEEDISINF
#include "MersenneTwister.h"
#include "genepop.h"
#include "myutils.h" //show vectors, show time...
#include "latin.h"
#include "hypercube.h"
#include "migraine.h"
#include "mainDG.h"
#include "nexus.h"

//#define NO_MODULES
#ifdef NO_MODULES
#include "genepop.cpp"
#include "dg.cpp"
#include "mainDG.cpp"
#include "hypercube.cpp"
#include "migraine.cpp"
#include "computeId.cpp"
#include "nexus.cpp"
#include "genetIS.cpp"
#include "PCL_SISR.cpp"
#endif //NO_MODULES


using namespace std;
//convenience constants
MTRand aleah,alea;
string version="0.6 (Built on "+datestring+" at "+timestring+")";
int PointNumber=512;//512 2401;//512; //2197;  //<<<<<<<<<<<<<<<
int _pointmin=-1; //signal pour appliquer valeurs par d['e]faut si pas modifi['e]
int _pointmax=numeric_limits<int>::max(); //idem
int JobMax=0; // numbered from 0
int JobMin=0; // numbered from 0
unsigned long int _ptSamplingSeed=67144630;
unsigned long int _EstimationSeed=67144630;
string settingsfilename="migraine.txt";
bool randCmdFileBool=false;
string cmdlinefilename="cmdline.txt";
string VarSizeFunction="";
bool asymptoBool=false,AsymptoPerMutRateBool=false,AsymptoPerDispRateBool=false,AlternativeIS_AncPopSizebool=false,
	AlternativeIS_FRExpMixAncActPopSizebool=false,HobolthISM=false,promptHyperSegSites=false,
	pacancbool=false,pacbool=false,genepopBool=false,genepopRootBool=false,nexusBool=false,nexusRootBool=false,
	nexusNumberLabels=true,sameGpNexusLabels=false, outlierGeneFileBool = false,
	pauseFinal=false,
	piOnePopSDbool=false,piOnePopEigenbool=false,PopSizeScaleForTimebool=true,
	allowsEmptyColumns=false, TMRCABool=false;
int pointmin,pointmax;
string ptlname,resolveForPerfectPhylogeny="manual";
float *lb, *ub; //new dans migraine.cpp (apply_final_settings...)
///////////////// Implementation of precompiler options PAC, PCG
#ifdef PAC
pacbool=true;
#endif
#ifdef PACanc
pacancbool=true
#endif
#ifdef PCG
pcgbool=true;
#endif
#ifdef PROCESSORNBR  //-DPROCESSORNBR=<n> preprocessor option (4 pr IFR, 30 pr CINES)
// this may be controlled at runtine by the settings.
AvailableProcessors=PROCESSORNBR;
#endif

using namespace std;

COptions::COptions() {
liste.reserve(0);
ost.setf(std::ios_base::boolalpha); //displays booleans as text
};

int COptions::Oappend(std::string st) {
liste.push_back(st);
return 0;}

CProcessedLocus::CProcessedLocus(CFichier_genepop *gp,int iLoc) {
//std::cout<<gp->fileName<<" "<<iLoc;getchar();
   locus=iLoc;
   fileName=gp->fileName;
   locusName = gp->loci[iLoc - 1]->locusName;
   //	when the individual labels in the Genepop file should necessarily correspond to the specified Nexus taxon labels
   if (sameGpNexusLabels && !nexusNumberLabels) {
	   // CBR (30.08.2013) maps every individuals genepop label to its allelic state index
	   for (size_t i = 0; i < fichier_genepop->pops.size(); i++)
		   for (size_t j = 0; j < fichier_genepop->pops[i]->inds.size(); j++) {
			   map<string, int>::iterator it = mapIndLab2State.find(gp->pops[i]->inds[j]->indName());
			   if (it == mapIndLab2State.end())
				   mapIndLab2State[gp->pops[i]->inds[j]->indName()] = gp->pops[i]->inds[j]->getTypage(iLoc - 1,1);
		   }
   }
}

int CProcessedLocus::copyTable(std::vector<std::vector<int> >counts) {
std::vector<int>ligne;
   alleleCounts.resize(0);
   for (std::vector<std::vector<int> >::iterator ii=counts.begin();ii!=counts.end();ii++) {
        ligne.resize(0);
        for (std::vector<int>::iterator jj=ii->begin();jj!=ii->end();jj++) ligne.push_back(*jj);
        alleleCounts.push_back(ligne);
   }
return 0;
}

int CProcessedLocus::copyTable(std::vector<std::vector<std::vector<int> > >counts) { //2D habitat
std::vector<int>ligne;
   alleleCounts.resize(0);
   for (std::vector<std::vector<std::vector<int> > >::iterator ii=counts.begin();ii!=counts.end();ii++) {// loop on x bins
      for (std::vector<std::vector<int> >::iterator jj=ii->begin();jj!=ii->end();jj++) {//loop on y bins
        ligne.resize(0);
        for (std::vector<int>::iterator kk=jj->begin();kk!=jj->end();kk++) ligne.push_back(*kk);
//ostream_vector(ligne,std::cout);getchar();
        alleleCounts.push_back(ligne);
      }
   }
return 0;
}


int CProcessedLocus::writeAdHocFile(std::ofstream& stream) {

	std::ostream_iterator<int> locout(stream," ");
    if(mutationModel=="PIM") {
      for(std::vector<std::vector<int> >::iterator it=alleleCounts.begin();it!=alleleCounts.end();it++) {
    	copy((*it).begin(),(*it).end(),locout);
    	stream <<";"<< std::endl;
      }
    } else /*SMM*/ {
		for(std::vector<std::vector<int> >::iterator it=alleleCounts.begin();it!=alleleCounts.end();it++) {
			int PopSampleEffectif=0;
			for(std::vector<int>::iterator it1=(*it).begin();it1!=(*it).end();it1++) PopSampleEffectif+=(*it1);
			stream << PopSampleEffectif << " ";
		}
		int minAll=sequenceGivenK[std::min(args.locus-1,int(sequenceGivenK.size())-1)]; //hhhh voir args.locus?
		//on doit chercher le min pour ['e]crire les tailles relatives
		for(std::vector<int >::iterator it2=alleleIndices.begin();it2!=alleleIndices.end();it2++) {
			if((*it2)<minAll && (*it2)>0) minAll=(*it2);

		}
		stream << std::endl;
		for(std::vector<std::vector<int> >::iterator it=alleleCounts.begin();it!=alleleCounts.end();it++) {
			stream << "pop" << std::endl;
			unsigned int AlleleIndiceIt=0;
			for(std::vector<int >::iterator it2=alleleIndices.begin();it2!=alleleIndices.end();it2++) {
				if(AlleleIndiceIt<(*it).size()) stream << (*it2) - minAll << " " << (*it)[AlleleIndiceIt] << std::endl;
				else if((*it2)>0) {//RL->FR : message a virer a terme, mais je prefere mettre un peu de s['e]curit['e] pour l'instant.
					cout << "Problem in writeAdHocFile() : Allele Indices Iterator (" << AlleleIndiceIt << ") larger than AlleleCounts table size." << std::endl;
					cout << "Contact the developer for correcting this bug. I must exit." << std::endl;
					if(cinGetOnError) cin.get();
					exit(-1);
				}
				AlleleIndiceIt++;
			}
		}
	} // fin SMM
return 0;
}



int CProcessedLocus::fillTable(CFichier_genepop *gp) {
// each line is one pop
int allele;
const int locusfromzero=locus-1;
std::vector<int>ligne;
    alleleCounts.resize(0);
    for(std::vector<CPopulation *>::iterator ii=gp->pops.begin();ii!=fichier_genepop->pops.end();ii++) {
        ligne.resize(0);
        if (fichier_genepop->coding[locusfromzero]>=4) {
           gp->loci[locusfromzero]->resetgIterator();
           while ((allele = gp->loci[locusfromzero]->getgNext()) >= 0) {
//cout<<alleleCounts.size()<<" "<<locusfromzero<<" "<<allele<<" "<<(*ii)->loci[locusfromzero]->getgEffective(allele);getchar();
// addition of ghost alleles must come later (as explained in crunchLocTable)
              ligne.push_back((*ii)->loci[locusfromzero]->getggEffective(allele));
           }
        } else {
           gp->loci[locusfromzero]->resetIterator();
           while ((allele = gp->loci[locusfromzero]->getNext()) >= 0) {
//cout<<alleleCounts.size()<<" "<<locusfromzero<<" "<<allele<<" "<<(*ii)->loci[locusfromzero]->getgEffective(allele);getchar();
// addition of ghost alleles must come later (as explained in crunchLocTable)
              ligne.push_back((*ii)->loci[locusfromzero]->getEffective(allele));
           }
        }
        alleleCounts.push_back(ligne);
    }
return 0;
}

int CProcessedLocus::fillGrid(CFichier_genepop *gp,unsigned int latticeSize,vector<unsigned int> samPos) {
// each line is one pop or a vector of zero; same code as for file output
int allele;
unsigned int sP=0;
const int locusfromzero=locus-1;
std::vector<int>ligne;
    alleleCounts.resize(0);
    for(unsigned int ii=0;ii<latticeSize;ii++) {
        ligne.resize(0);
        if (fichier_genepop->coding[locusfromzero]>=4) {
           gp->loci[locusfromzero]->resetgIterator();
           if (sP<samPos.size() && samPos[sP]==ii+1) {
//cerr<<sP<<" "<<ii+1;getchar();
               while ((allele = gp->loci[locusfromzero]->getgNext()) >= 0) {
//cout<<alleleCounts.size()<<" "<<locusfromzero<<" "<<allele<<" "<<gp->pops[sP]->loci[locusfromzero]->getgEffective(allele);getchar();
// addition of ghost alleles must come later (as explained in crunchLocTable)
                  ligne.push_back(gp->pops[sP]->loci[locusfromzero]->getggEffective(allele));
               }
               sP++;
           } else { //position not occupied on lattice
//    cerr<<ii;getchar();
               while ((allele = gp->loci[locusfromzero]->getgNext()) >= 0)
                  ligne.push_back(0);
           }
        } else {
           gp->loci[locusfromzero]->resetIterator();
           if (sP<samPos.size() && samPos[sP]==ii+1) {
//cerr<<sP<<" "<<ii+1;getchar();
               while ((allele = gp->loci[locusfromzero]->getNext()) >= 0) {
//cout<<alleleCounts.size()<<" "<<locusfromzero<<" "<<allele<<" "<<gp->pops[sP]->loci[locusfromzero]->getgEffective(allele);getchar();
// addition of ghost alleles must come later (as explained in crunchLocTable)
                  ligne.push_back(gp->pops[sP]->loci[locusfromzero]->getEffective(allele));
               }
               sP++;
           } else { //position not occupied on lattice
//    cerr<<ii;getchar();
               while ((allele = gp->loci[locusfromzero]->getNext()) >= 0)
                  ligne.push_back(0);
           }
        }
        alleleCounts.push_back(ligne);
    }
return 0;
}




/*================================= MAIN =================================*/
/*
first seeks a cmdlinefilename as first argument of command line
then writes remainder of command line in (cmdlinefilename) file
this may itself contain a settingsfile name
(cmdlinefilename) file is read and then (settingsfile) file is read
*/
int main(int argc, char *argv[]) {
std::cout.setf(std::ios_base::boolalpha); //displays booleans as text
time_t GlobalStartTime,GlobalEndTime;
time(&GlobalStartTime);
int mls;
bool increasingMinMax=true; // pas impl['e]ment['e]e sur tranche
cinGetOnError=false; //overrides genepop.cpp default !
vector<int>reversible;
#ifdef UNIX_PARAL
bool paral_samples=true;
int ProcId,status;
#endif
   // remove("output.txt"); // parce qu'on append dedans [`a] la fin des krigIterations // sauf qu'['e]criture supprim['e]e aussi
//runtime options come last so as to override previous settings
// first writes command line to file
    if (argc>1) {
    // to give inline the name of the file in which command line is written
    	string buf(argv[1]);
    	string::size_type pos=std::min(buf.find('='),std::min(buf.find('\t'),buf.length()));
    	string var=buf.substr(0,pos).c_str();
    	if(cmp_nocase(var,"CmdlineFileName")==0) cmdlinefilename=buf.substr(pos+1);
    	//else it has some othe argument in command line that it writes in default file
    	ofstream cmdline(cmdlinefilename.c_str(),ios::out);
        for (int it=1;it<argc;it++) cmdline<<argv[it]<<endl;
    	cmdline<<endl;
    	cmdline.close();
    // seeks optional SettingsFile in cmdline
    	seeks_settings_file_name(cmdlinefilename,settingsfilename);
    }
    read_settings_file(settingsfilename); //cf migraine.cpp... READS and SETS...
    if (argc>1) read_settings_file(cmdlinefilename);
    remove(cmdlinefilename.c_str());
    apply_final_settings();
#ifdef DEBUG
    
    if (PrintSuiviLikelihood) remove("SuiviL.txt");
#endif
#ifdef UNIX_PARAL
	/*(total number of jobs to run */ //<<<<<<<<<<<<<<<<<<
	MaxSimultJobs=std::max(1,std::min(JobMax-JobMin+1,AvailableProcessors));
	/* this should be the number of processors requested:
				one for the parent process and remainder for child processes */
	if (paral_samples) {
//       pointmin=max(_pointmin,0);pointmax=min(_pointmax,PointNumber);
	} else {
		mls=0;
	}
#else // si pas unix paral
//       pointmin=max(_pointmin,0);pointmax=min(_pointmax,PointNumber);
#endif
    COptions options;
    options.Ocollect(); // Compilation des options choisies dans un texte [`a] afficher
    options.Oinspect(cout);
    ofstream settout("settings.out.txt");
    options.Oinspect(settout);
    settout.close();
//    DesignPoints=CSampling(ParameterNumber,PointNumber); //allocation (resize)
    reversible.resize((unsigned int)(JobMax-JobMin+1));
//cout<<JobMin<<" "<<JobMax;getchar();
    if (increasingMinMax)
       for (unsigned int ii=0;ii<reversible.size();ii++) reversible[ii]=JobMin+ii;
    else
       for (unsigned int ii=0;ii<reversible.size();ii++) {reversible[ii]=JobMax-ii;}
//if (unix_paral) {
#ifdef UNIX_PARAL // otherwise compiler complains for missing fork, wait
//	if (paral_samples) {
	// first starts MaxSimultJobs-1 child processes
	// PAS int mls car ce doit etre une variable externe de calclogl
	//si 10 proc fils simultan['e]s: mls = 0  < 0+11-1
//	  for (mls=JobMin;mls<JobMin+MaxSimultJobs-1;mls++) {
///////////////////////////////////////////// BOUCLE SUR ECHANTILLONS MULTILOCUS
	for (int ii=0;ii<reversible.size();ii++) {
            firstCountPSON=true;
            ProcessedLoci.resize(0);
			mls=reversible[ii];
			if (ii==reversible.size()-1) {
                if (genepopBool && dataFileNeededBool) crunchGenepopFile(mls,ancestralSuffixes); //noter que l'argument sera ignor['e] si !genepopRootBool
                // define points
                DesignPoints.firstfill(mls,sequenceWrite[0],lb,ub); // will call either read_points_from_R or hypercube_sampling
                DesignPoints.analyse(mls);//dernier echantillon; pas besoin de fork
			} else {
			// waits for free machine:
			if (ii>=MaxSimultJobs-1) wait(&status);
			ProcId=fork();
			if(ProcId==0) {//child
                if (genepopBool && dataFileNeededBool) {
                    crunchGenepopFile(mls,ancestralSuffixes); //noter que l'argument sera ignor['e] si !genepopRootBool
                } else {
                    //otherwise data are read only through the appropriate GetSample call in analyse->externalfunction->calclogl!
                    // but the R file is written before the call to external function, anf then we need:
                    if(geoBinWidth==0) geoBinWidth=1; // if readAdhocFiles and not set before
                }
                // define points
                DesignPoints.firstfill(mls,sequenceWrite[0],lb,ub); // will call either read_points_from_R or hypercube_sampling
	  			DesignPoints.analyse(mls);
	  			exit(0);
			}; //else parent process
			if (ProcId==-1) {cout <<"fork failed"<<endl;}
			} //else
	}//for
	while(wait(&status)!=-1); //quand il a fini le dernier echant. dans le parent il attends que les fils soient finis
  	cout <<"All child processes finished.";
//	}
/* version paral points [`a] revoir
else {//SI PAS PARAL_SAMPLES
	// first starts MaxSimultJobs-1 child processes
	// PAS int mls car ce doit etre une variable externe de calclogl
	//si 10 proc fils simultan['e]s: mls = 0  < 0+11-1
		for (int tranche=JobMin;tranche<JobMax+1;tranche++) {
			if (tranche>=JobMin+MaxSimultJobs-1) wait(&status);
			ProcId=fork();
			if(ProcId==0) {//child
		  		pointmin=tranche*(int)(PointNumber/(JobMax+1));
		  		pointmax=(tranche+1)*(int)(PointNumber/(JobMax+1));
		  		analyse(mls,tranche);
		  	exit(0);
			}; //else parent process
			if (ProcId==-1) {cout <<"fork failed"<<endl<<flush;}
	  	}//for
	  	while(wait(&status)!=-1);
	  	cout <<"All child processes finished.";
	} //if (paral_samples)... else...
*/
#else // SI PAS UNIX_PARAL
//	if (JobMax>0) 	cout << "This will *overwrite* previous output files. OK?";
//	else cout << "This will *append* previous output files. OK?";
//	getchar();
//for (mls=JobMin;mls<JobMax+1;mls++) {
///////////////////////////////////////////// BOUCLE SUR ECHANTILLONS MULTILOCUS

	for (unsigned int ii=0;ii<reversible.size();ii++) {
        firstCountPSON=true;
        ProcessedLoci.resize(0);
    	mls=reversible[ii];
//cout<<"mls="<<reversible[ii];getchar();
#ifdef CLUSTERSPY
		cerr<<"("<<mls<<","<<pointmin<<"):"<<args.nruns<<" sampled tree per locus "<<endl;
#endif
//cout<<genepopBool<<" "<<dataFileNeededBool;getchar();
        if (genepopBool && dataFileNeededBool) {
           crunchGenepopFile(mls,ancestralSuffixes); //noter que l'argument sera ignor['e] si !genepopRootBool
        } else {
            //otherwise data are read only through the appropriate GetSample call in analyse->externalfunction->calclogl!
            // but the R file is written before the call to external function, anf then we need:
            if(geoBinWidth==0) geoBinWidth=1; // if readAdhocFiles and not set before
        }
        DesignPoints.firstfill(mls,sequenceWrite[0],lb,ub); // will call either read_points_from_R or hypercube_sampling
        DesignPoints.analyse(mls);
	}
#endif	//ifdef UNIX_PARAL else
    cout<< '\a'; //alert sound !
    delete[] ub;delete[] lb;
   time(&GlobalEndTime);
   float secs=(float) (GlobalEndTime- GlobalStartTime);
   cout<<"Total ('wall-clock') time: "<<secs<<" s."<<endl;
#if (defined(linux))
	  struct rusage usage;
      getrusage(RUSAGE_SELF,&usage);
      // ru_utime for 'user' time, not including system calls (which are in ru_stime), nor 'real' (clock) time
      // see http://rabbit.eng.miami.edu/info/functions/time.html#getrusage for example?
      // _sec as a numer of seconds and _usec an additional number of microseconds
      {double t=(double)usage.ru_utime.tv_sec + (double)usage.ru_utime.tv_usec / 1000000.0;
          cout<<"  C++ process time: "<<t<<" s.  ('user's time' in Unix sense, i.e. excluding R call and other system calls)"<<endl;
      }
#endif
    if (pauseFinal) {cout<<"\nNormal ending"; cin.get();}
return(0);
}//main
