/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
#ifndef H_MIGRAINE
#define H_MIGRAINE
#include <csignal>
#include <string>
#include <vector>
#include <fstream> // ofstream..
#include <sstream>
#include <cmath>
#include "latin.h"
#include "myutils.h"
#include "genepop.h"
#include "dg.h"
#include "dgCMigCMut.h"
#include "nexus.h"
// QUICK PATCH: always define: (for PCG)
#include "dgCSample.h"
#define SPARSIFY_THRESHOLD 0.000001
#define GRADIENT_CONV_THRESHOLD 0.0001

/////////////////// essayer de pas mettre de nouveau defines plus loin
//#define DEBUG //RL : This should be commented except when debugging. I let it here because I often use it.

//#define GLOBALSCALING
#ifndef GLOBALSCALING
#define LOCALSCALING
#endif
// Signif exacte theta utilisateur
//#define PIMDIG //(FR correction 29/01/08 suite message RL)
#define PIMtrue

// #define PicalcPIM PicalcPIMChol  // Cholesky factorization of *sym* pos def matrices
//
// approx using LDL' factorization of *sym* pentadiag pos def matrices (optimized code):
//#define PicalcPIM PicalcPIMLDLpentasym
//#define PicalcPIM PicalcPIMLDLpentasymCG
//#define PicalcPIM test //pas de pr['e]conditioning
//const int diagiters=2;


#ifdef ASYMPTO_PAR_DISP_RATE
#define ASYMPTO
#define ASYMPTO_PAR_SCALED_RATE
const float disp_rate_control_param=__disp_rate_control_param;
#endif

#ifdef ASYMPTO_PAR_MUT_RATE
#define ASYMPTO
#define ASYMPTO_PAR_SCALED_RATE
//compares mut_rate_control_param/_Theta to scaled_generation
//scaled_generation is in units of 2\Ntot(haploid) gener
//_Theta is args.pars[0] * \nmodel => 2\Ntot\mu
// Hence the rule is to switch after mut_rate_control_param/\mu generations.
const float mut_rate_control_param=__mut_rate_control_param;
#endif


/***** asympto that give bad results *****/
//#define ASYMPTO_PAR_TAUX_COAL
//#define ASYMPTO_PAR_CPU
//===
//#define ASYMPTO_PAR_EVENTS
#ifdef ASYMPTO_PAR_EVENTS
#define ASYMPTO
const int max_nbr_events=400;
#endif

//#define ASYMPTO_PAR_DISP_EVENTS
#ifdef ASYMPTO_PAR_DISP_EVENTS
#define ASYMPTO
const float disp_events_control_param=30.;
#endif


//#define ASYMPTO_PAR_FST
#ifdef ASYMPTO_PAR_FST
#define ASYMPTO
#define NGIVEN
#endif

//#define ASYMPTO_PAR_SIGMA //existe mais deprecated
#ifdef ASYMPTO_PAR_SIGMA
#define ASYMPTO
#endif

#ifdef NGIVEN
#define NhaploidGiven 400
#endif

//===
//#define LINEAR_ABSORBING
//	CBR -> RL,FR: #define PIM seems obsolete
//#define PIM // essaye de garder Change() compatible non PIM

//#define ITERATORS  // semble gagner 20 % de temps de calcul - non: en perd !



// C O N S T
const int __ParameterNumber=3;
const int __nloci=0;
const int __coreNbr=1;
const int __NrunsPerPoint=10; //<<30<<10<<<<<<<<<<<<
const float __disp_rate_control_param= (float) 3.;
const float __mut_rate_control_param= (float) 2.;
const float disp_rate_control_param=__disp_rate_control_param;
const parstype epsilonPijGSMMut=1E-15;
const parstype epsilonPiGSM=1E-15;
const parstype epsilonOPVSChange=1E-6;
//compares mut_rate_control_param/_Theta to scaled_generation
//scaled_generation is in units of 2\Ntot(haploid) gener
//_Theta is args.pars[0] * \nmodel => 2\Ntot\mu
// Hence the rule is to switch after mut_rate_control_param/\mu generations.
const float mut_rate_control_param=__mut_rate_control_param;
extern std::string mutationModel;
extern std::vector<std::string> mutationModelVector;
extern std::map<int, CStoreNexus> storeSeqCSamples;
extern std::vector<std::string> piOnePopSolverVector;
extern std::vector<int> lociPerMarker;
enum {PIM, SMM, GSM, ISM, SNP};
extern std::vector<bool> mutModelBool;
enum {DG, SD, Eigen};
extern std::vector<bool> piOnePopSolverBool;
extern int markerCount;
extern int totalLociCount;
extern bool multipleMarkersBool;
extern std::string DemographicModel;
extern std::string subsetPointls;
extern std::string geoUnit;
extern std::string glob_gp_filename;
extern std::string globalNexusFilename; // CBR: imitating Genepop filename setup
extern std::vector<std::string>testParName;
extern std::vector<std::string>ancestralSuffixes;
extern std::vector<long double>ancestralScaledTimes;
extern std::vector<float>testParValue;
extern std::vector<float>CovFnParam;
extern std::vector<float>LRTmin;
extern std::vector<float>LRTmax;
extern std::vector<unsigned int>KrigLoci;
extern std::vector<std::string>standardParamNames;
extern std::vector<std::string>standardDModelNames;
extern std::vector<std::string>oneDimCIvars;
extern std::vector<std::string>spec1DProfiles;
extern std::vector<std::string>spec2DProfiles;
extern std::vector<std::string>sequenceStat;
extern std::vector<std::string>sequenceWrite;
extern std::vector<int>sequenceGridSteps;
extern std::vector<std::string>CanonicalNames;
extern std::vector<int>sequenceNrunsPerPoint;
extern std::vector<int>sequencePointNumber;
extern std::vector<int>sequenceAddRepl;
extern std::vector<int>sequenceGivenK;
extern std::vector<int>SMMstepSizes;
extern std::vector<int>alleleNbrVec;
extern std::vector<std::string>BoundsDefs;
extern std::vector<std::string>KrigSpace;
extern std::vector<std::string>extraNames;
extern std::vector<std::string>extraScale;
extern std::map<std::string,std::vector<float> > plotRange;
extern std::map<std::string,std::vector<float> > graphicPars;
extern std::vector<std::string>Rarguments;
extern std::vector<std::string>PlotOptions;
extern std::vector<std::string>boundsSource;
extern std::vector<std::string>KrigScale;
extern std::vector<std::string>samplingScale;
extern std::vector<double>geoAreaMin;
extern std::vector<double>geoAreaMax;
extern bool useCbool;
extern bool linabsbool,geoAreaMinBool,C_c_bool,IBDbool,D1IBDbool,D2IBDbool,timeNeededBool,alleleNbrChecked;
//pour d['e]buggage : (sert que si DEBUG est d['e]fini ci dessus)
extern bool DebugHypercube;//divers affichages pour le latin hypercube sampling et design des points
extern bool DebugPiSample;//affiche tous les Pis avec debugPi=true sur echantillon de d['e]part (avant de lancer un vrai run)
extern bool DebugGpSample;//affichages divers pour debuggage lecture fichier genepop
extern bool DebugNexusSample;//affichages divers pour debuggage lecture fichier nexus
extern bool DebugSplit;//affiche tous changements dus a split pendant les runs
extern bool DebugPopVarSize;//affiche tous changements dus a la vriation de taille de pop pendant les runs, et pour founderflush
extern bool DebugBisection;//affiche les calculs de fonction utilis['e]e par la bisection serach (exp ou logistique piour PopVarSize)
extern bool DebugSD;//affiche tout pour calcul des PI onepop=SD, mais pas la matrice MatriceSD
extern bool DebugSD2;//affiche calcul de la matrice MatriceSD
extern bool DebugPi;//affichage des Pis autres que OnePop=SD
extern bool DebugSigmaPi;//pour trouver le premier instance de non-cumul des Pi à 1
extern bool DebugPiSMM;//affichage des clalculs intermediaires pour les Pis SMM two pops
extern bool DebugProposal;//affiche les proposals sur l'['e]chantillon de d['e]part (avant de lancer un vrai run)
extern bool DebugDG;//affichage des chanements trouv['e]s danzs change() (le Pi, Change et Weight) pour debuggage des procedures issues de DG2002
extern bool DebugDG2;//affichage des random et cumul dans Change()
extern bool DebugDGISM;//affichage des chanements trouv['e]s danzs change() (le Pi, Change et Weight) pour ISM dans DIG'04a,b
extern bool DebugChoosePopType;//debuggage de ChoosePopTYpe()
extern bool DebugIIS;//debuggage IIS paire de genes
extern bool gaussdebug;//debugage de la procedure d'elimination gausienne de griffiths (sur run)
extern bool PrintLikelihood;//affiche les vraisemblance de chaque run (= chaque arbre) et la matrice de mutation (= debug level 1)
extern bool PrintSuiviLikelihood;//imprime dans un fichier es likelihood a chaque run pour 1 point pour v['e]rifications
extern bool readAdHocFileBool;// whether to read ad hoc file or use ProcessedLoci
extern bool writeAdHocFileBool;// whether to write ad hoc files from Genepop files
extern bool dataFileNeededBool;
extern int  thisMessage1;
extern bool perLocusBool;  //whether per locus likelihoods will be in the pointls file
extern int geoBinNbr;
extern int nloci,coreNbr,mloglikdim,krigmax,kriglength,krigoverlap,_replicatedPoints; //maxKrigedReplicatedPoints; //RL->FR 092016 : a enlever définitivement
extern int minKrigPtNbr,maxKrigPtNbr,GCVptnbr,GCVoptimSteps,trendOrder,meanNeighbor;
extern bool PCL_SISR_UseIndivNbResamplingbool;  // CM 25.03.14
extern int PCL_SISR_IndivNbResampling; // CM 25.03.14
extern int PCL_SISR_MaxEventNbInPopAnc;//CM 13.02.14
extern int PCL_SISR_ESSMinFall; //CM 13.02.14
extern int PCL_SISR_StartESSAtEvent;
extern float PCL_SISR_Alpha,PCL_SISR_Beta;
extern std::vector<unsigned int> samplesPos;
extern std::string gp_file,gp_fileRoot,illConditioningMethod,problem;
extern double geoBinWidth,CILevel,NextBoundsLevel,designRetain,GCVdesignRetain,hullExpandFactor,scalefactor;
extern double anyTwoNmuMin,anyTwoNmuMax,anyTwoNmMin,anyTwoNmMax,anyTimeMin,anyTimeMax;
extern std::string Rtermfullpath;
extern std::string PiSolverFromSettingsInfo;
extern std::string profileType; // standard 1st order profile or higher order modified profile
extern std::stringstream RcodeStString;
//#define ASYMPTO_PAR_DISP_RATE
//#define ASYMPTO_PAR_MUT_RATE
//#define LDLsymTRUE
//#define lin_abs_spTRUE // precond'ed conjugate grad. for sparsified matrix attention au seuil pr['e]cision ...


int apply_final_settings();
int crunchGenepopFile(const int mls,std::string optst="");
int crunchGenepopFile(const int mls,std::vector<std::string> optStrings);


/////////////////////// structures
struct Arguments {
	int nalls;
//	int seed1,seed2,seed3,seed4; //FR: semble obsolete
	long int nruns;
	std::string SampleFileName;//,_MutFileName,_MigFileName,_SizeFileName;
	int locus; //>0 ; for GetSample() variant using ProcessedLoci
	std::vector<float> pars;
	int point; // index du param point: used only for temp file name
	Arguments();
};


struct Cparvals {    // vecteur habill['e] de constructeurs
	std::vector<float> pars;
	Cparvals();
//Cparvals(double *);
	Cparvals(Cparvals *);
	Cparvals(std::vector<float> v);
};


extern Arguments args;

int StandardizeName(std::string Name,std::vector<std::string> StandardNames);
int seeks_settings_file_name(const std::string cmdlinefilename,std::string& settingsfilename);
int read_settings_file(const std::string filename);
std::vector<float> externalfn(const std::vector<double> pars,const int *mlsp);

template <typename Type> // et ceci est pour pouvoir detourner l'output ailleurs que dans le fichier de sortie
int crunchLocTable(int iLoc,Type& fichier_out,CgeoInfo geoInfo) {
//suppose genepop.
// preferred habitatPars method + other methods as previously described:
//Stores data in global structure ProcessedLoci; and optionally writes to ad hoc files

// IMPORTANT: ProcessedLoci must contain minimal info only (typically a r * c matrix)
//        (but this is not so for the SMM: cf alleleIndices)
// the number of alleles can then be easily manipulated (in this fn)
// Finally auxiliary variables are computed by GetSample(CProcessedLocus*... ) called in calclogl
// Recall: GetSample(string FileName...) will be obsolete

// args are: iLoc locus iterator, stream info, vector of coordinates of extreme pop, and geo width of each bin.
/* If binWidth>0 this bins data in bins
|position(extremepop)-0.5binWidth,position(extremepop)+0.5binWidth|,
|position(extremepop)+0.5binWidth,position(extremepop)+1.5binWidth|,
...
|position(extremepop)+(GeoBinNbr-1.5)binWidth,position(extremepop)+(GeoBinNbr-0.5)binWidth|,
//ex 4 bins, 4 pops aux pos 0,1,2,3 =>extremepop= en 0,width=1
|-0.5,0.5| |0.5,1.5| |1.5,2.5| |2.5,3.5|
Note that total span (i.e |-0.5, 3.5|) equals max distance over (pops, areaMin,Max) pairs *(bin nbr)/(bin nbr-1)

Otherwise this fits the data to a grid or else simply fill a table.
*/
    static bool alreadyWrong=false; // keep its value over loci...
    unsigned int localstateNbr,tmp;
	int nb_sam=(int)fichier_genepop->pops.size(); //CM->RL 23.01.14
    //int allelecoding=2+std::max(fichier_genepop->coding[iLoc]/2,fichier_genepop->coding[iLoc]%4);   // 2 3 4 6 => 4 5 4 5
    std::vector<int>dummyvec;
    int allele/*,binidx*/,jj;
//    double euclidian;
    ProcessedLoci.push_back(CProcessedLocus(fichier_genepop,iLoc+1)); //iLoc >= 0, CProcessedLocus.locus >= 1
    // first fill tables with counts of observed alleles
    float BinWidth=geoInfo.BinWidth;
//std::cout<<BinWidth;getchar();
    if (sequenceGivenK.size()>0) {
       localstateNbr=sequenceGivenK[std::min(iLoc,int(sequenceGivenK.size())-1)];
    } else
       localstateNbr=0; // will be overridden by observed # of alleles
    if (fichier_genepop->coding[iLoc]>=4) {
         tmp=(int)fichier_genepop->loci[iLoc]->galleles.size();  //CM->RL 23.01.14
    } else
         tmp=(int)fichier_genepop->loci[iLoc]->alleles.size();  //CM->RL 23.01.14
    if (tmp>localstateNbr) {//StateNbr < observed number of alleles !
        if (localstateNbr>0 && !(mutModelBool[SMM || mutModelBool[GSM]])) {
            std::cerr<<"\n(!) First processing of Genepop file :" << std::endl;
            std::cerr << "Given # of alleles < observed # of alleles for locus "<<iLoc+1<<".\n";
            std::cerr<<"    Given # of alleles ignored, default numbers will be used.\n";
        }
        localstateNbr=tmp;
    }
    // at this point unobserved ('ghost') alleles have been added.
    // However, beware of CSample::GetSample(CProcessedLocus* locptr,const int locAlleleNbr) if !pim


    if (samplesPos.size()>0) { /*D1IBD, positions given in settings file;
        no binning, direct conversion from pops to ad hoc file and fill
      empty grid positions with zero's*/
        ProcessedLoci.back().fillGrid(fichier_genepop,geoBinNbr,samplesPos); // same logic as file output
    } else if (BinWidth>0) { //doit etre tjrs vrai si D2IBD
       float llx=geoInfo.llx;
       float lly=geoInfo.lly;
       //float ddx=geoInfo.dx;
       //float ddy=geoInfo.dy;
       float dx,dy;
       int xbin,ybin;
       float cosrot=geoInfo.cosrot;
       float sinrot=geoInfo.sinrot;
       float flat_x,flat_y;
       std::vector<std::vector<std::vector<int> > >binnedcount(geoInfo.xBins);
//std::cout<<iLoc<<" "<<localstateNbr;getchar();
       for (std::vector<std::vector<std::vector<int> > >::iterator ii=binnedcount.begin();ii!=binnedcount.end();ii++) {
          ii->resize(geoInfo.yBins);
          for (std::vector<std::vector<int> >::iterator jj=ii->begin();jj!=ii->end();jj++) {
           jj->resize(localstateNbr,0);
          }
       }
       for (int ii=0;ii<nb_sam;ii++) {
           dx= (float) fichier_genepop->coord_pop[ii][0];
           dy= (float) fichier_genepop->coord_pop[ii][1];
/* ancien  code tres bizarre en 2D, should have been OK in 1D
           flat_x=dx*cosrot+dy*sinrot-llx; // projection on rotated axis... THEN shift (clear in 1D...)
           flat_y=dy*cosrot-dx*sinrot-lly;
 ce qui est clair en 1D, c'est que si un vecteur x, y est bien sur l'axe de projection il doit etre de forme
 r cos, r sin
si bien que r cos cos + r sin sin =r
On s'attendrait donc a ce que (r cos,r sin)=(dx-llx),(dy-lly). le code serait
*/
           flat_x=(dx-llx)*cosrot+(dy-lly)*sinrot; // projection on rotated axis with origin (llx,lly)
           flat_y=(dy-lly)*cosrot-(dx-llx)*sinrot;
           xbin=int(flat_x/BinWidth);
           ybin=int(flat_y/BinWidth);
//std::cout<<BinWidth<<" "<<flat_x<<" "<<flat_y<<" "<<xbin<<" "<<ybin<<" "<<geoInfo.xBins<<" "<<geoInfo.yBins;getchar();
//std::cout<<BinWidth<<" "<<flat_x<<" "<<flat_y<<" "<<xbin<<" "<<ybin<<" "<<geoInfo.llx<<" "<<geoInfo.lly;getchar();
           bool wrongx =(xbin<0 || xbin+1>geoInfo.xBins );
           bool wrongy=(ybin<0 || ybin+1>geoInfo.yBins );
           if (wrongx || wrongy) {
               if ( not alreadyWrong ) {
                   std::cerr<<"Some sample coordinates do not fit in bounding box."<<std::endl;
                   std::cerr<<"Extremal possible values are (0,0) and ("<<geoInfo.xBins-1<<","<<geoInfo.yBins-1<<")"<<std::endl;
                   std::cerr<<"Coordinates => inferred bin:"<<std::endl;
                   if ( D2IBDbool) {
                       std::cerr<<"[("<<fichier_genepop->coord_pop[ii][0]<<","<<fichier_genepop->coord_pop[ii][1]<<") => ("<<xbin<<","<<ybin<<")]";
                   }
                   if( ( not wrongx) && D1IBDbool ) {
                        // we got the warning but we project on axis
                        std::cerr<<"Linear habitat: the projection on the (rotated) x axis will be used.\n";
                    }
                    alreadyWrong=true; // true when the next individual or next locus is encountered
                } else {
                   std::cerr<<"[("<<fichier_genepop->coord_pop[ii][0]<<","<<fichier_genepop->coord_pop[ii][1]<<") => ("<<xbin<<","<<ybin<<")]";
                }
                if( ( not wrongx) && D1IBDbool ) {
                    ybin=0;
                } else {
                        std::cerr<<"Check settings.\n I exit.";
                        if (cinGetOnError) std::cin.get();
                        exit(-1);
                }
           } //ELSE
           //fills the (first cols of the) table with observed allele counts
           jj=0;
           if (fichier_genepop->coding[iLoc]>=4) {
              fichier_genepop->loci[iLoc]->resetgIterator();
              while ((allele = fichier_genepop->loci[iLoc]->getgNext()) >= 0) {
                 //cerr<<jj<<endl;
                  binnedcount[xbin][ybin][jj]+=fichier_genepop->pops[ii]->loci[iLoc]->getggEffective(allele);
//std::cout<<allele<<" : "<<binnedcount[xbin][ybin][jj]<<";";
                  jj++;
              }
//getchar();
           } else {
              fichier_genepop->loci[iLoc]->resetIterator();
              while ((allele = fichier_genepop->loci[iLoc]->getNext()) >= 0) {
                 //cerr<<jj<<endl;
                  binnedcount[xbin][ybin][jj]+=fichier_genepop->pops[ii]->loci[iLoc]->getEffective(allele);
                  //cout<<allele<<" ";
                  jj++;
              }
           }
       }
       ProcessedLoci.back().copyTable(binnedcount);
    } else { //D1 IBD Ni binning automatique ni positionnement des echantillons dans la lattice=> 1 lattice node par sample
        ProcessedLoci.back().fillTable(fichier_genepop); // same logic as file output
    }
    // to make sure that this act on all three subcases above, we resize here:
    if(ProcessedLoci.back().alleleCounts.begin()->size()<localstateNbr)  // FR 09/12/10 givenK was not operating with SamplesPosOnArray!
        for (std::vector<std::vector<int> >::iterator jj=ProcessedLoci.back().alleleCounts.begin();jj!=ProcessedLoci.back().alleleCounts.end();jj++) {
            jj->resize(localstateNbr,0);
        }
    // note that this was already resized in this way in one case, which was convenient. Not ideal code.
    ProcessedLoci.back().alleleIndices.resize(localstateNbr);
//std::cerr<<ProcessedLoci.back().alleleIndices.size();getchar();
    //copy allelic types (map keys) to vector
    //FR for my KAM 'allele' is the allele label in the genepop input file
#ifdef DEBUG
	if(DebugGpSample) {
		std::cout<< "AlleleCounts.size()=" << ProcessedLoci.back().alleleCounts[0].size() << std::endl;
		std::cout << "AlleleCounts=";
		int iii=0;
		for(std::vector<std::vector<int> >::iterator it=ProcessedLoci.back().alleleCounts.begin();it!=ProcessedLoci.back().alleleCounts.end();it++) {
			int jjj=0;
			for(std::vector<int>::iterator it1=(*it).begin();it1!=(*it).end();it1++) {std::cout << /*"AlleleIndiceIt=" << jjj << "->" <<*/ (*it1) << " ";jjj++;}
			std::cout << "; (pop=" << iii << ")" << std::endl;
			iii++;
		}
		if(cinGetOnError) std::cin.get();
	}
#endif

    jj=0;
    if (fichier_genepop->coding[iLoc]>=4) {
        fichier_genepop->loci[iLoc]->resetgIterator();
        while ((allele = fichier_genepop->loci[iLoc]->getgNext()) >= 0) {
          ProcessedLoci.back().alleleIndices[jj]=allele;
          jj++;
        }
    } else {
        fichier_genepop->loci[iLoc]->resetIterator();
        while ((allele = fichier_genepop->loci[iLoc]->getNext()) >= 0) {
          ProcessedLoci.back().alleleIndices[jj]=allele;
          jj++;
        }
    }
#ifdef DEBUG
	if(DebugGpSample) {
		std::cout<< "alleleIndices.size()=" << ProcessedLoci.back().alleleIndices.size() << std::endl;
		std::cout << "alleleIndices=";
		for(std::vector<int >::iterator it2=ProcessedLoci.back().alleleIndices.begin();it2!=ProcessedLoci.back().alleleIndices.end();it2++) std::cout << (*it2) << " ";
		std::cout << std::endl << std::endl;
		if(cinGetOnError) std::cin.get();
	}
#endif
    //there is no ghost allele to add here since the table has already been resized to givenK
    // however, beware of CSample::GetSample(CProcessedLocus* locptr,const int locAlleleNbr) if !pim

    if (writeAdHocFileBool) {
    //ecriture dans le fichier gp_dg<n> (*DIG* ad hoc format, not smm ad hoc format)
       std::ofstream gp_dg(fichier_out.c_str());
           if(!gp_dg.is_open()) {
            	std::cout << "Unable to open file "<<fichier_out.c_str() << " in crunchLocTable()" << std::endl;
            	std::cerr << "Unable to open file "<<fichier_out.c_str() << " in crunchLocTable()" << std::endl;
            	if (cinGetOnError) std::cin.get();
                exit(-1);
           }
       ProcessedLoci.back().writeAdHocFile(gp_dg);
       gp_dg.close();
    }

#ifdef DEBUG
	if(DebugGpSample) std::cout<<"end of crunchLocTable()";//getchar();
#endif
return 0;
}


#endif
