// dans getsample modif FER: plus d'arret quand m*nombre d'alleles<Mut_AlleleNbr
//refaire tous les iterateurs dans les vector
// afaire: pourquoi j'ai un Disp_Pars et un DispPars tous deux utilis['e]s dans MakeMatrixSS

/***************************************************************************
© F. Rousset, R. Leblois 2007

francois.rousset@univ-montp2.fr
raphael.leblois@mnhn.fr

This file is part of Migraine. This software is a computer program
whose purpose is to perform statistical analyses.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author, the holder of the
economic rights, and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading, using, modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate, and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and, more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/

#include <iomanip>
#include <string>
#include <cstdlib>
#include <list>
#include <map>
#include <fstream>
#include <cctype>
#include <cstdio>
#include <iostream>
#include <ctime>
#include <fstream>
#include "mainDG.h" //golubbool
#include "hypercube.h" //CalculQused, RL a deplacer
#include "dg.h"
#include "dgCMigCMut.h"
#include "dgCSample.h"
#include "migraine.h"
#include "nr3.h"


using namespace std;

bool firstCountPSON; // indicates that nbr of pops has not been counted before
int firstPSON=-1; // this variable will only serve to check that all loci havethe same # of samples
vector<bool> firstCallOfLocus;	//	this vector is only for determining the first call to each ISM locus in calclogl()
extern bool calcQibdtableDoneBool;

#ifdef BUG_NOT_MINE
	vector<vector<pirestype> >PIs;
	vector<pirestype> bvec; // that should become obselete as a class member ?
    vector<vector<picalctype> > L_;  // new une fois par calclogl (new_L_...) et delete idem
	vector<picalctype> D_;
	vector<picalctype> v_;
    vector<vector<picalctype> > Mmat;
    vector<vector<vector<picalctype> > > MatriceSD;
	vector<vector<pirestype> >altPIs;

#else
//==== variable for Pi calculation
	pirestype** PIs;
	pirestype* bvec; // that should become obselete as a class member ?
    picalctype** L_;  // new une fois par calclogl (new_L_...) et delete idem
	picalctype* D_;
	picalctype* v_;
    picalctype** Mmat;
    picalctype*** MatriceSD;
	picalctype* SDpivec;
	picalctype** MatA;
	pirestype** altPIs;
	int chosenPop;	//	used for accessing the chosen pop by CSample::PiCalcISM
#endif
vector<int>finalSMMstepSizes;
//int Nhaploid=400; // deme size

using namespace std;
//-------------------------------------------------------
//--------------- implementation DG2002.h ---------------
//-------------------------------------------------------

//class CMutMod

//constructeur
CMutMod::CMutMod(){
Mut_AlleleNbr=0;
pGSM=0;
Pij.reserve(0);
Station.reserve(0);
}

// FER 16/03/2005; StateNum is the number of columns in the input file
// #ifdef PIMtrue : here we assume there is no mutation from j to j. This amounts to consider
// #ifdef PIMtrue : th'=th K/(K-1) and th' Pij=th/(K-1)=th'/K for j<>i
/**/int CMutMod::MakeMatrixPIM(int StateNum,parstype Thetatrue){
int i,j;
if(StateNum==1) {
    cout<<endl<<"Encountered an invalid attempt to fit a monomorphic locus under a 1-allele model.";
    cout<<endl<<"Cf 'Loci=Polymorphic' or 'GivenK' settings to handle monomorphic loci. I exit.";
    if (cinGetOnError) cin.get();exit(-1);
}
Mut_AlleleNbr=StateNum;
//_Thetatrue:=th is the true mut rate
#ifdef PIMDIG
ThetaDIG=_Thetatrue; // DIG setting
#endif
#ifdef PIMtrue
//cout<<"ICI: "<<_Thetatrue<<" "<<StateNum;getchar();
ThetaDIG=Thetatrue*StateNum/(StateNum-1); // th'=th K/(K-1) is the appropriate theta for the algo... th is 2 *N_T* mu
#endif

//... including the Denominator variable...
Pij.resize(StateNum);
for(i=0;i<StateNum;i++) {
	Pij[i].resize(StateNum);
	for(j=0;j<StateNum;j++){
		//if (j==i) Pij[i][j]=0; else  //Modif 012008 car incoh['e]rent avec les calculs analytiques de PiPim de DG2004b
        Pij[i][j]=1.0/(StateNum); //so that th' Pij=th'/K for j<>i
// th' sum_{j\neq i} Pij =th' (K-1)/K= th
		}
	} // for i ...Statenumber

Station.reserve(StateNum);
return(0);
}/**/

int CMutMod::MakeMatrixSMM(int locAlleleNbr,parstype locTheta){
int i,j;
if(locAlleleNbr==1) {
    cout<<endl<<"Encountered an invalid attempt to fit a monomorphic locus under a 1-allele model.";
    cout<<endl<<"Cf 'Loci=Polymorphic' or 'GivenK' settings to handle monomorphic loci. I exit.";
    if (cinGetOnError) cin.get();exit(-1);
}
Mut_AlleleNbr=locAlleleNbr;//asign the value to the class member
ThetaDIG=locTheta;
Pij.resize(Mut_AlleleNbr);
for(i=0;i<Mut_AlleleNbr;i++) {
	Pij[i].resize(Mut_AlleleNbr);
	for(j=0;j<Mut_AlleleNbr;j++){
		if(/*false or*/ !(piOnePopSDbool || piOnePopEigenbool)){//circular SMM
			if( (i==0) && (j==(Mut_AlleleNbr-1)) ) Pij[i][j]=0.5;
			 else if( (j==(i+1)) || (j==(i-1)) ) Pij[i][j]=0.5;
			  else if( (i==(Mut_AlleleNbr-1)) && (j==0) ) Pij[i][j]=0.5;
			   else Pij[i][j]=0.0;
		} else { //absorbing boundaries SMM
			if((i==0)&&(j==1)) Pij[i][j]=1.0;
			 else if( (i==(Mut_AlleleNbr-1)) && (j==(Mut_AlleleNbr-2)) ) Pij[i][j]=1.0;
			  else if( (i!=(Mut_AlleleNbr-1)) && ( (j==(i+1)) || (j==(i-1)) ) ) Pij[i][j]=0.5;
			   else Pij[i][j]=0.0;
		}
	}
} // for i ...Mut_AlleleNbr

if(piOnePopSDbool || piOnePopEigenbool) ComputeEigensystems();

Station.reserve(Mut_AlleleNbr);
return(0);
}

int CMutMod::MakeMatrixGSM(int locAlleleNbr,parstype locTheta, parstype locpGSM){
int i,j;
long double Sum;
//    static time_t _StartTime;
//    time_t _EndTime;
//    float _secs;
//static bool firsttime=true;
if(locAlleleNbr==1) {
    cout<<endl<<"Encountered an invalid attempt to fit a monomorphic locus under a 1-allele model.";
    cout<<endl<<"Cf 'Loci=Polymorphic' or 'GivenK' settings to handle monomorphic loci. I exit.";
    if (cinGetOnError) cin.get();exit(-1);
}
Mut_AlleleNbr=locAlleleNbr;
ThetaDIG=locTheta;
pGSM=locpGSM;
Pij.resize(Mut_AlleleNbr);

for(i=0;i<Mut_AlleleNbr;i++) {
	Pij[i].resize(Mut_AlleleNbr);
	Sum=0.0;
	for(j=0;j<Mut_AlleleNbr;j++){
		if(pGSM<1E-2) {//SMM
			if(false or !(piOnePopSDbool || piOnePopEigenbool)){//circular SMM
				if( (i==0) && (j==(Mut_AlleleNbr-1)) ) Pij[i][j]=0.5;
			 	 else if( (j==(i+1)) || (j==(i-1)) ) Pij[i][j]=0.5;
			  	  else if( (i==(Mut_AlleleNbr-1)) && (j==0) ) Pij[i][j]=0.5;
			   		else Pij[i][j]=0.0;
			} else { //absorbing boundaries SMM
				if((i==0)&&(j==1)) Pij[i][j]=1.0;
			 	 else if( (i==(Mut_AlleleNbr-1)) && (j==(Mut_AlleleNbr-2)) ) Pij[i][j]=1.0;
			  	  else if( (i!=(Mut_AlleleNbr-1)) && ( (j==(i+1)) || (j==(i-1)) ) ) Pij[i][j]=0.5;
			   	   else Pij[i][j]=0.0;
			}
		} else if(pGSM>0.99) {//KAM
			if(i!=j) Pij[i][j]=1.0/(Mut_AlleleNbr-1);
			 else Pij[i][j]=0.0;
		} else {//real GSM
			if(false or !(piOnePopSDbool || piOnePopEigenbool)){//circular GSM
				if( ((i==0)&&(j==Mut_AlleleNbr-1)) or ((i==Mut_AlleleNbr-1)&&(j==0))) Pij[i][j]=powl(pGSM,abs(1));
				else if(((i-j)==0)) Pij[i][j]=0.0;
				else Pij[i][j]=powl(pGSM,abs(i-j));
			} else { // non circular GSM
				if(((i-j)==0)) Pij[i][j]=0.0;
				else Pij[i][j]=powl(pGSM,abs(i-j));
			}
		}
		Sum+=Pij[i][j];
	}//j
	for(j=0;j<Mut_AlleleNbr;j++) Pij[i][j]/=Sum;
	for(j=0;j<Mut_AlleleNbr;j++) if( (i!=j) and (Pij[i][j]<epsilonPijGSMMut)) Pij[i][j]=0.0;
	Sum=0;
	for(j=0;j<Mut_AlleleNbr;j++) Sum+=Pij[i][j];
	for(j=0;j<Mut_AlleleNbr;j++) Pij[i][j]/=Sum;
	Sum=0;
	for(j=0;j<Mut_AlleleNbr;j++) Sum+=Pij[i][j];
#ifdef DEBUG
	for(j=0;j<Mut_AlleleNbr;j++) if(Pij[i][j]<0.0 || std::isnan(Pij[i][j])) {
		cerr << "problem in the computation of the mutation probility Matrix for the GSM with pGSM=" << pGSM << " : " << endl;
		cerr << "After second correction for sum!=1.0 but (Sum-1.0)=" << fabs(Sum-1.0) << endl;
		cerr << "Pij[ " << i << "][" << j << " is <0 =" << Pij[i][j] << endl;
		if(cinGetOnError) cin.get();
	}
	if(fabs(Sum-1.0)>5*numeric_limits<parstype>::epsilon() || std::isnan(Sum)) {
		cerr << "problem in the computation of the mutation probility Matrix for the GSM with pGSM=" << pGSM << " : " << endl;
		cerr << "Sum of line " << i << " is not 1.0 but " << Sum << "; fabs(Sum-1.0)=" << fabs(Sum-1.0) << endl;
		PrintMut();
		if(cinGetOnError) cin.get();
		//exit(-1);
	}
#endif



} // for i ...Mut_AlleleNbr

    //cout << "numeric_limits<long double>::epsilon()=" << numeric_limits<long double>::epsilon() << "numeric_limits<long double>::min()=" << numeric_limits<long double>::min() << endl;
    //cout << "numeric_limits<double>::epsilon()=" << numeric_limits<double>::epsilon() << "numeric_limits<double>::min()=" << numeric_limits<double>::min() << endl;
    //cout << "numeric_limits<float>::epsilon()=" << numeric_limits<float>::epsilon() << "numeric_limits<float>::min()=" << numeric_limits<float>::min() << endl;

if(piOnePopSDbool || piOnePopEigenbool) ComputeEigensystems();


Station.reserve(Mut_AlleleNbr);
return(0);
}



int CMutMod::PrintMut(){
if(Mut_AlleleNbr<40){
	cout << "\nMutation Matrix is :" << endl;
	ostream_vec_vector(Pij,cout);cout << endl;
} else cout << "Too many allelic states to print mutation matrix;" << endl;
return(0);
}


//calcul la distribution stationnaire necessaire pour calcul des Pi de Stephens et Donnelly pour une Onepop
// adapte de cornu2cw.c du projet griffiths_CW
parstype CMutMod::CalculStation() {
int i,j,rep;
parstype diff,s,Sum;
vector<parstype> ps;

//calcul de la distribution stationnaire des etats alleliques
Station.resize(Mut_AlleleNbr);
for(i=0;i<Mut_AlleleNbr;i++) Station[i]=1.0/Mut_AlleleNbr;
ps.resize(Mut_AlleleNbr);
diff=1.0;
for(rep=1;diff>=numeric_limits<parstype>::epsilon();rep++) {
  s=0.0;
  for(i=0;i<Mut_AlleleNbr;i++)
	{ps[i]=0.0;
	 for(j=0;j<Mut_AlleleNbr;j++)
	 {ps[i]+=Pij[i][j]*Station[j];
	  /*printf("\n pour i=%d,j=%d, ps=%f",i,j,ps[i]);
	  getchar();*/
	 }
	 s+=ps[i];
	}
  diff=0.0;
  for(i=0;i<Mut_AlleleNbr;i++)
  {diff+=pow(((ps[i]/s)-Station[i]),2);
	Station[i]=ps[i]/s;
  }
  //cout << "error on allelic state stationnary distribution is equal to " << diff << " for i=" << rep << endl;
  //if (cinGetOnError) cin.get();
  /*printf("\n      erreur sur pistation =%f a la rep %d",diff,rep);
  getchar();*/
	//cout << "After " << rep << " iterations, the stationnary distribution is :\n" << endl;
	//for(i=0;i<Mut_AlleleNbr;i++) cout << "\nStationnary distribution p[" << i << "]=" << Station[i] << endl;
	//cin.get();
 }

 /*printf("rep %d",rep);
 for(i=minal;i<=maxal;i++)
 {printf("\n distrib stationnaire p[%d]=%f",i,Station[i]);
  getchar();
 }*/
Sum=0.0;
for(i=0;i<Mut_AlleleNbr;i++) Sum+=Station[i];
//cout << "Sum of the stationnary distribution is : " << Sum << endl;
return (parstype) Sum;
}


int CMutMod::ComputeEigensystems() {

	REigenVectors.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) 	REigenVectors[i].resize(Mut_AlleleNbr);
	LEigenVectors.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) 	LEigenVectors[i].resize(Mut_AlleleNbr);
	EigenValues.resize(Mut_AlleleNbr);

	MatDoub PijMat(Mut_AlleleNbr,Mut_AlleleNbr);

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			PijMat[i][j]=Pij[i][j];

	Unsymmeig r(PijMat,true,false);

	for(int i=0;i<Mut_AlleleNbr;i++) for(int j=0;j<Mut_AlleleNbr;j++) REigenVectors[i][j]=r.zz[i][j];
	for(int i=0;i<Mut_AlleleNbr;i++) EigenValues[i]=real(r.wri[i]);

	//transposition de la matrice pour calculer les vecteurs propres a gauche.
	vector< vector<parstype> > Temp;
	vector<parstype> Temp1;
	Temp.resize(Mut_AlleleNbr);
	Temp1.resize(Mut_AlleleNbr,0.0);
	for(int i=0;i<Mut_AlleleNbr;i++) Temp[i].resize(Mut_AlleleNbr,0.0);

	for(int i=0;i<Mut_AlleleNbr;i++) for(int j=0;j<Mut_AlleleNbr;j++) Temp[i][j]=PijMat[j][i];
	for(int i=0;i<Mut_AlleleNbr;i++) for(int j=0;j<Mut_AlleleNbr;j++) PijMat[i][j]=Temp[i][j];

	Unsymmeig l(PijMat,true,false);

	for(int i=0;i<Mut_AlleleNbr;i++) for(int j=0;j<Mut_AlleleNbr;j++) LEigenVectors[i][j]=l.zz[i][j];
	for(int i=0;i<Mut_AlleleNbr;i++) Temp1[i]=real(l.wri[i]);

	//cout << "\n (\"R\") Eigen values :" << endl;
	//ostream_vector(EigenValues,cout);cout << endl;
	//cin.get();
	//cout << "\n Un-normalized Right eigen vectors (in columns)" << endl;
	//ostream_vec_vector(REigenVectors,cout);cout << endl;
	//cin.get();
	//cout << "\n (\"L\") Eigen values :" << endl;
	//ostream_vector(Temp1,cout);cout << endl;
	//cin.get();
	//cout << "\n Un-normalized Left eigen vectors  (in columns)" << endl;
	//ostream_vec_vector(LEigenVectors,cout);cout << endl;
	//cin.get();


	//Normalization of the left eigenvector (as in CalculsMatricielPourGSMborné_PiFRRL2012+PiSD2000.nb)
	//we first compute the normalization matrix as L.R
	//allocate memory because the inversion procedure needs pointers
	picalctype** Norm;
	Norm=new picalctype*[Mut_AlleleNbr];
	for(int i=0;i<Mut_AlleleNbr;i++) Norm[i]=new picalctype[Mut_AlleleNbr];

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) Norm[i][j]=0.0;

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) Norm[i][j]+=LEigenVectors[i][k]*REigenVectors[k][j];




	//we then compute the normalized Left eigenvectir matrix Inv(Norm).L
	vector< vector<picalctype> > LNorm;
	LNorm.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) LNorm[i].resize(Mut_AlleleNbr,0.0);

	inversion(Norm, Mut_AlleleNbr);

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) LNorm[i][j]+=Norm[i][k]*LEigenVectors[k][j];


	//Check if the normalization was correct by computing Lnorm.R, should be Identity matrix
	vector< vector<picalctype> > Check;
	Check.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) Check[i].resize(Mut_AlleleNbr,0.0);
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) Check[i][j]+=LNorm[i][k]*REigenVectors[k][j];

	//cout << "\n Check matrix :" << endl;
	//ostream_vec_vector(Check,cout);cout << endl;
	//cin.get();

	//Check
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) {
			if(i==j) {
				if(fabs(Check[i][j]-1.0)>epsilonPijGSMMut) {
					cerr << "Pbl1 in normalizing mutation LeftEigenVectors check[" << i << "][" << j << "] = " << Check[i][j] << endl;
					if(cinGetOnError) cin.get();
				}
			} else {
				if(fabs(Check[i][j])>epsilonPijGSMMut) {
					cerr << "Pbl2 in normalizing mutation LeftEigenVectors check[" << i << "][" << j << "] = " << Check[i][j] << endl;
					if(cinGetOnError) cin.get();
				}
			}

		}

	//we take the normalized matrix as the left eigenvector matrix for further computations
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) LEigenVectors[i][j]=LNorm[i][j];



	//Free memory
	for(int i=0;i<Mut_AlleleNbr;i++) delete[] Norm[i];
	delete[] Norm;

	if(DebugDG or DebugPiSMM) {
		PrintMut();
		cout << "\n REigenVectors matrix :" << endl;
		ostream_vec_vector(REigenVectors,cout);cout << endl;
		cout << "\n LEigenVectors matrix :" << endl;
		ostream_vec_vector(LEigenVectors,cout);cout << endl;
		cout << "\n EigenValues matrix :" << endl;
		ostream_vector(EigenValues,cout);cout << endl;
		//cin.get();
	}

	return 0;
}

//trry using Jama_eig...
int CMutMod::ComputeEigensystems2() {

	REigenVectors.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) 	REigenVectors[i].resize(Mut_AlleleNbr);
	LEigenVectors.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) 	LEigenVectors[i].resize(Mut_AlleleNbr);
	EigenValues.resize(Mut_AlleleNbr);

	CEigensystem<picalctype,picalctype> rrr(Pij,false); // 'true' means symmetric matrix
	EigenValues=rrr.getdvec(); // eigenvalues
	REigenVectors=rrr.getV(); // (transpos'es //t mathematica) = dans le bon sens... = vectors in columns


	//transposition de la matrice pour calculer les vecteurs propres a gauche.
	vector< vector<parstype> > Temp;
	vector<parstype> Temp1;
	Temp.resize(Mut_AlleleNbr);
	Temp1.resize(Mut_AlleleNbr,0.0);
	for(int i=0;i<Mut_AlleleNbr;i++) Temp[i].resize(Mut_AlleleNbr,0.0);

	for(int i=0;i<Mut_AlleleNbr;i++) for(int j=0;j<Mut_AlleleNbr;j++) Temp[i][j]=Pij[j][i];

	CEigensystem<picalctype,picalctype> lll(Pij,false); // 'true' means symmetric matrix
	LEigenVectors=lll.getV(); // (transpos'es //t mathematica) = dans le bon sens... = vectors in columns


	/*cout << "\n (\"R\") Eigen values :" << endl;
	 ostream_vector(EigenValues,cout);cout << endl;
	 cin.get();
	 cout << "\n Un-normalized Right eigen vectors (in columns)" << endl;
	 ostream_vec_vector(REigenVectors,cout);cout << endl;
	 cin.get();
	 cout << "\n (\"L\") Eigen values :" << endl;
	 ostream_vector(Temp1,cout);cout << endl;
	 cin.get();
	 cout << "\n Un-normalized Left eigen vectors  (in columns)" << endl;
	 ostream_vec_vector(LEigenVectors,cout);cout << endl;
	 cin.get();*/

	//Check if the normalization was correct by computing L.R, should be Identity matrix
	vector< vector<picalctype> > Check1;
	Check1.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) Check1[i].resize(Mut_AlleleNbr,0.0);

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) Check1[i][j]+=LEigenVectors[i][k]*REigenVectors[k][j];


	//Normalization of the left eigenvector (as in CalculsMatricielPourGSMborné_PiFRRL2012+PiSD2000.nb)
	//we first compute the normalization matrix as L.R
	//allocate memory because the inversion procedure needs pointers
	picalctype** Norm;
	Norm=new picalctype*[Mut_AlleleNbr];
	for(int i=0;i<Mut_AlleleNbr;i++) Norm[i]=new picalctype[Mut_AlleleNbr];

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) Norm[i][j]=0.0;

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) Norm[i][j]+=LEigenVectors[i][k]*REigenVectors[k][j];




	//we then compute the normalized Left eigenvectir matrix Inv(Norm).L
	vector< vector<picalctype> > LNorm;
	LNorm.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) LNorm[i].resize(Mut_AlleleNbr,0.0);

	inversion(Norm, Mut_AlleleNbr);

	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) LNorm[i][j]+=Norm[i][k]*LEigenVectors[k][j];


	//Check if the normalization was correct by computing Lnorm.R, should be Identity matrix
	vector< vector<picalctype> > Check;
	Check.resize(Mut_AlleleNbr);
	for(int i=0;i<Mut_AlleleNbr;i++) Check[i].resize(Mut_AlleleNbr,0.0);
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++)
			for(int k=0;k<Mut_AlleleNbr;k++) Check[i][j]+=LNorm[i][k]*REigenVectors[k][j];

	//cout << "\n Check matrix :" << endl;
	//ostream_vec_vector(Check,cout);cout << endl;
	//cin.get();

	//Check
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) {
			if(i==j) {
				if(fabs(Check[i][j]-1.0)>10*numeric_limits<picalctype>::epsilon()) {
					cerr << "Problem 1 in normalizing LeftEigenVectors of the mutation matrix" << endl;
					cerr << "I exit." << endl;
					if(cinGetOnError) cin.get();
				}
			} else {
				if(fabs(Check[i][j])>10*numeric_limits<picalctype>::epsilon()) {
					cerr << "Problem 2 in normalizing LeftEigenVectors of the mutation matrix" << endl;
					cerr << "I exit." << endl;
					if(cinGetOnError) cin.get();
				}
			}

		}

	//we take the normalized matrix as the left eigenvector matrix for further computations
	for(int i=0;i<Mut_AlleleNbr;i++)
		for(int j=0;j<Mut_AlleleNbr;j++) LEigenVectors[i][j]=LNorm[i][j];



	//Free memory
	for(int i=0;i<Mut_AlleleNbr;i++) delete[] Norm[i];
	delete[] Norm;

	if(DebugDG or DebugPiSMM) {
		PrintMut();
		cout << "\n REigenVectors matrix :" << endl;
		ostream_vec_vector(REigenVectors,cout);cout << endl;
		cout << "\n LEigenVectors matrix :" << endl;
		ostream_vec_vector(LEigenVectors,cout);cout << endl;
		cout << "\n EigenValues matrix :" << endl;
		ostream_vector(EigenValues,cout);cout << endl;
		//cin.get();
	}

	return 0;
}


int CMutMod::PrintStation()
{int i;
parstype poub;

poub=Station[0];
for(i=1;i<Mut_AlleleNbr;i++)
	if(fabs(poub-Station[i])>numeric_limits<parstype>::epsilon()) {
		cout << "poub=" << poub << " and Station[" << i << "]=" << Station[i] << "fabs(poub-Station[i])=" << fabs(poub-Station[i]) << endl;
		if(cinGetOnError) cin.get();
		break;
	}
if(i==Mut_AlleleNbr) {
	cout << "Stationary distribution of allelic states is uniforme on [1 - " << Mut_AlleleNbr << "];\n\n" << endl;
	return 0;
	}
 else {
 	cout << "Stationary distribution of allelic states is not uniforme on [1 - " << Mut_AlleleNbr << "];" << endl;
 	cout << "I exit because only uniform distribution are currently considered..." << endl;
	exit(-1);

 }
return(0);
}



//------------------------------------------------------
//----  Class CMigMod

//constructeur
CMigMod::CMigMod(){
MigPSON=0;//nombre de pop totales, equiv de PopSampledOrNot mais membre
PopMergedNbr=0;
if (asymptoBool) DeuxPiSurNx=0;
#ifdef ASYMPTO
DeuxPiSurNx=0;
#endif
init_file_et_critere=-1; //
//costable.reserve(0); //pas pour valarray ?
Mab.reserve(0);
Ma.reserve(0);
PopSize.reserve(0);
AncPopSize.reserve(0);
ChangeTime.reserve(0);
PopMergedTab.reserve(0);
MinChangeTime=numeric_limits<scaledTimeType>::infinity();
InAncStablePopbool=false;
PrevChangeTime=-666;
}


#ifdef NGIVEN


int CN_known::calcule_Fourier_converge(int& GeoSpan) {
	lncharfn2.resize(MigPSON); //en fait j'utilise jusqu'[`a] PSON/2 ? (i.e. ii<MigPSON/2+1) ?
	lncharfn2[0]=0;
	{//block local variable
		cumultype temp;
		for(int ii=1;ii<MigPSON;ii++) {
		temp=costable[ii];
		temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp));
	//ggg=DispPars[1];
		lncharfn2[ii]=2*log(1-(1-temp)*DispPars[0]/(2*MigPSON*Nhaploid));
	//Real Life Proba of dispersal mmm=disppars[0]/(2*nx*Nhaploid);
//cout<<lncharfn2[ii]<<endl;getchar();
		}
	} //fin block
//computes Fst Ne... assuming N is known
// reuses init_file_et_critere <>-1...
vector<double> pcoal0,pcoalMax,nope0,nopeMax;
int blocklength=1000,tt=1;
double local,sumct0,sumctMax,denom=1,critere;
//cout<<DispPars[0]/(2*MigPSON*Nhaploid)<<" "<<DispPars[1]<<endl;

FSurUnMoinsF=0;
	for(int ii=1;ii<MigPSON;ii++){
		local=exp(lncharfn2[ii]); //could use symmetry to save a very few computs...
		FSurUnMoinsF+=local/(1-local);
	}
	FSurUnMoinsF/=(Nhaploid*MigPSON);
	InvAsymptoNe=MigPSON*Nhaploid*(1+FSurUnMoinsF);

#ifdef ASYMPTO_PAR_FST
sumct0=0;sumctMax=0;
	for(;;tt++) {
		if(tt>pcoal0.capacity())	{
			pcoal0.reserve(tt+blocklength);
			pcoalMax.reserve(tt+blocklength);
			nope0.reserve(tt+blocklength);
			nopeMax.reserve(tt+blocklength);
//			cout<<"+";cout.flush();
			}
////dist 0
		local=circularFourierinv(0,tt);
		nope0[tt-1]=local;
// stores pcoal0[tt-1]
		for(int jj=1;jj<tt;jj++) local-=pcoal0[jj-1]*nope0[tt-jj-1];
		pcoal0.push_back(local/Nhaploid); //C_{0,t} est le terme pcoal0[t-1]
// computes \sum_{t=1}^{t=tt} C_{0,t}
		sumct0+=pcoal0[tt-1];
////dist Max
//		local=circularFourierinv(GeoSpan,tt);
		local=circularFourierinv(2,tt);
		nopeMax[tt-1]=local;
// stores pcoalMax[tt-1]
		for(int jj=1;jj<tt;jj++) local-=pcoalMax[jj-1]*nopeMax[tt-jj-1];
		pcoalMax.push_back(local/Nhaploid); //C_{distmax,t} est le terme pcoalMax[t-1]
// computes \sum_{t=1}^{t=tt} C_{distmax,t}
		sumctMax+=pcoalMax[tt-1];
		local=pcoalMax[tt-1]-pcoal0[tt-1];
		if (local>0) {
			critere=(pcoalMax[tt-1]*sumct0-pcoal0[tt-1]*sumctMax)/local;
//cout<<" ("<<tt<<","<<critere<<") ";
			if (critere<1.01||tt>100*blocklength) break;
		}
	}
//cout<<endl<<tt<<endl;
//getchar();
scaled_time_limit=(scaledTimeType) tt/(MigPSON*Nhaploid);
//cout<<endl<<GeoSpan<<" "<<tt<<" "<<scaled_time_limit<<endl;cout.flush();
#endif


#ifdef ASYMPTO_PAR_TAUX_COAL
	for(;;tt++) {
		if(tt>pcoal.capacity())	{pcoal.reserve(tt+blocklength);cout<<"+"<<critere;cout.flush();}
		local=circularFourierinv(0,tt);
		for(int jj=1;jj<tt;jj++) local-=pcoal[jj-1]*circularFourierinv(0,tt-jj);
		pcoal.push_back(local/Nhaploid); //C_{0,t} est le terme pcoal[t-1]
		critere=InvAsymptoNe*pcoal[tt-1]/denom;
//		cout<<tt<<" "<<critere<<" "<<denom<<" "<<pcoal[tt-1]<<endl;getchar();
		if (critere<5||tt>100*blocklength) break;
		denom-=pcoal[tt-1]; //1-Sum C_{0,t}
	}
cout<<endl<<tt<<endl;
init_file_et_critere=tt; //shouldn't do that
#endif

#ifdef ASYMPTO_PAR_SIGMA
init_file_et_critere=2*MigPSON*Nhaploid/Nsigma2();
cout<<init_file_et_critere<<endl; //shouldn't do that
#endif
	return 0;
}


cumultype CN_known::circularFourierinv(const int dx,const int gener){
//devrait etre appel['e]e par circularFourierinv(dx,nx,Disp_Pars,gener)
//nx is lattice size, dx is geo distance
cumultype temp=1; // c'est exp(lncharfn2[0]*gener);....
	for(int ii=1;ii<MigPSON/2;ii++) temp+=2*exp(lncharfn2[ii]*gener)*costable[(dx*ii)%MigPSON];
	if(MigPSON%2==0) temp+=exp(gener*lncharfn2[MigPSON/2])*costable[(dx%2)*MigPSON/2];
	return temp/=MigPSON;
}// fin circularfourierinv */
//Nhaploid est en principe le nombre haploid par deme

/*cumultype CMigMod::charfuncpower2t(const int dx,const int gener){
// puisance 2 gener pour gener generations....
//devrait etre appel['e]e par charfuncpower2t(dx,nx=PSON,disppars,gener)
//cumultype temp=cos(dx*DeuxPiSurNx);
cumultype temp=costable[dx];
temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp)); //ggg=DispPars[1];
temp=1-(1-temp)*DispPars[0]/(2*MigPSON*Nhaploid); //Real Life Proba of dispersal mmm=disppars[0]/(2*nx*Nhaploid);
return exp(2*gener*log(temp));
} //fin def charfuncpower2t */

#endif //NGIVEN



// Mab backward rates : propto probability of coming from deme b
int CMigMod::MakeMatrixSS(int& PopSampledOrNot,const vector<parstype>& Disp_Pars){

//cerr<<"debut CMigMod::MakeMatrixSS";getchar();
//ostream_vector(Disp_Pars,cerr);getchar();
/* Creates the DIG Mab matrix;
at THIS point the main diagonal is always left with zero's everywhere

(1) whether we consider local scaling or not, at THIS point the parameters must be
scaled by total population size to match the definition of Mab.

(2) in the initial version of the linabsbool case
emigrants that went beyong the lattice were lost
=> the actual migration rate was lower than the user-declared one.
This is unavoidable to some extent: edgy demes must have lower emig/immig than
central ones. The difference between actual and user-declared rates
was negligible for central demes except when g->1. In the latter case it became
difficult to assign a meaning to the results.

SO: the new version of the linabsbool case is normalized such that central demes
have actual migration rate = the user-declared one
*/
	int a,b,dx,dy,dim1max,dim2max;

	cumultype tmpx,tmpy;
	DispPars.resize(Disp_Pars.size());
	// copy in CMigMod of the ALWAYS global-scaled parameters
	copy(Disp_Pars.begin(),Disp_Pars.end(),DispPars.begin());
	MigPSON=PopSampledOrNot; //sets MigPSON, variable membre de CMigMod
	//nb c'est un double mais il serait suspect qu'il atteigne <double>::max():
	init_file_et_critere=numeric_limits<scaledTimeType>::max();  // uses asympto approx after infinite time except if...
	if (AsymptoPerDispRateBool) { //non mis a jour pour D2IBD
/* this must be t_gener m (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_gener/N_T m N_T (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_scaled DispPars[0] (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_scaled = disp_rate_control_param * MigPSON/[DispPars[0] (sigma²|m)]*/
/* hence critere = disp_rate_control_param * MigPSON/[DispPars[0] (sigma²|m)]*/
//	init_file_et_critere=disp_rate_control_param*MigPSON*(1.-DispPars[1])/(sqrt(1.+DispPars[1]));
		init_file_et_critere=disp_rate_control_param*MigPSON*(1.-DispPars[1])*(1.-DispPars[1])/(1.+DispPars[1]);
		init_file_et_critere/=DispPars[0];
	}
	if (asymptoBool) { //non mis a jour pour D2IBD
		DeuxPiSurNx=2*PI/MigPSON;
		costable.resize(MigPSON);
		for(long int ii=0;ii<MigPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);
		limit_FSurUnMoinsF=0;
		{//block local variable
			cumultype temp;
			for(int ii=1;ii<MigPSON;ii++) {
			temp=costable[ii];
			temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp));
			temp=1/((1-temp)*DispPars[0]);
			// c'est par ex 1/((1-cos(...))*disp_proba*2*nx*Nhaploid);
			limit_FSurUnMoinsF+=temp;
			}
		} //fin block
	}
#ifdef ASYMPTO	// dans tous les cas on a besoin du Fst asymptotique
#ifdef ASYMPTO_PAR_DISP_EVENTS
//2*MigPSON/sigma en 1D (sigma2 en 2D !!!)
	init_file_et_critere= (int) (disp_events_control_param*MigPSON*(1.-DispPars[1])/sqrt(1.+DispPars[1]));
#endif
#ifdef ASYMPTO_PAR_DISP_RATE
/* this must be t_gener m (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_gener/N_T m N_T (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_scaled DispPars[0] (sigma²|m)=disp_rate_control_param * MigPSON*/
/* i.e. t_scaled = disp_rate_control_param * MigPSON/[DispPars[0] (sigma²|m)]*/
/* hence critere = disp_rate_control_param * MigPSON/[DispPars[0] (sigma²|m)]*/
//	init_file_et_critere=disp_rate_control_param*MigPSON*(1.-DispPars[1])/(sqrt(1.+DispPars[1]));
	init_file_et_critere=disp_rate_control_param*MigPSON*(1.-DispPars[1])*(1.-DispPars[1])/(1.+DispPars[1]); //1D seulemnt...
	init_file_et_critere/=DispPars[0];
#endif
	DeuxPiSurNx=2*PI/MigPSON;
	costable.resize(MigPSON);
	for(long int ii=0;ii<MigPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);
/*ancienne version stupide
	for(int ii=0;ii<=MigPSON/2;ii++)
		for(int jj=0;jj<=MigPSON/2;jj++) costable[ii*jj]=cos(ii*jj*DeuxPiSurNx);
	for(int ii=MigPSON/2+1;ii<=MigPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);*/
	limit_FSurUnMoinsF=0;
	{//block local variable
		cumultype temp;
		for(int ii=1;ii<MigPSON;ii++) {
		temp=costable[ii];
		temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp));
	//ggg=DispPars[1];
		temp=1/((1-temp)*DispPars[0]);
	// c'est par ex 1/((1-cos(...))*disp_proba*2*nx*Nhaploid);
		limit_FSurUnMoinsF+=temp;
		}
	} //fin block
#endif //ASYMPTO
/***************** regular case, geometric dispersal ************/
	if (DispPars[1]>1.0||DispPars[1]<0) {
	    cout <<"Impossible geometric dispersal parameter... Exiting"<<endl;
	    ostream_vector(DispPars,cout);
	    exit(-1);
    }
    // first pass on relative values
	Mab.resize(MigPSON);
	Ma.resize(MigPSON);
//	if (D2IBDbool) {
	    dim1max=geoInfo.xBins;
	    dim2max=geoInfo.yBins;
	    if((dim1max*dim2max)!=MigPSON) {
	        cerr<<"(!) From MakeMatrixSS: (dim1max*dim2max)!=MigPSON."<<endl;
	        cerr<<dim1max<<" * "<<dim2max<<" < "<<MigPSON<<". I Exit";
	        if (cinGetOnError) cin.get();
	        exit(-1);
        }
/*    } else {
        dim1max=MigPSON;
        dim2max=1;
    }*/
    a=0;
    int dimmax=max(dim1max,dim2max);
    vector<cumultype> exptable(dimmax+1,1.); /*mig from 0 to dimmax steps (circular model allows dimmax)*/
    /* Note that exptable[0]=1
        This means that the coeff of kpar will be the block distance, even on the axes dx=0 or dy=0.
        all the Nm_{x,y} will be of the same order. This is not a product of one dimensional distributions each taken in the coalescent limit.
    */
    if (dimmax>0) {
      exptable[1]=max(DispPars[1],numeric_limits<parstype>::epsilon()); // we want to avoid 0/0 when g->0; but still need exptable[1]/exptable[0]->0 when g->0;
    } else {
        cerr << "dimmax=0 in MakeMatrixSS..." << endl;
        if (cinGetOnError) cin.get();
        exit(-1);
	}
    for (int dd=2;dd<dimmax+1;dd++) exptable[dd]=exptable[dd-1]*exptable[1];
	for(int xpos=0;xpos<dim1max;xpos++) { // note that DispPars[0] does not matter in this loop
	   for(int ypos=0;ypos<dim2max;ypos++) {
		Ma[a]=0.0;
		b=0;
		for(int xxpos=0;xxpos<dim1max;xxpos++){
   		  Mab[a].resize(MigPSON,0);
		  for(int yypos=0;yypos<dim2max;yypos++){
			if(a!=b) {
//			    tmpx=1.;tmpy=1.;
			    if(linabsbool) {
                   dx=abs(xpos-xxpos);
                   dy=abs(ypos-yypos);
			    }
			    else {
			       dx=std::min(abs(xpos-xxpos),abs(xxpos-xpos));
			       dy=std::min(abs(ypos-yypos),abs(yypos-ypos));
                } //distance on circular array
			    tmpx=exptable[dx];
			    tmpy=exptable[dy];
	   		    // default linabsbool is true
			    if(!linabsbool) { // NOT linabsbool
				   tmpx+=exptable[dim1max-dx];
				   tmpy+=exptable[dim2max-dy]; //remind exptable[0]=1
			    }
			    Mab[a][b]=tmpx*tmpy;
//cerr<<a<<" "<<b<<" "<<Mab[a][b]<<" "<<tmpx<<" "<<tmpy;getchar();
                Ma[a]+=Mab[a][b];
               //on a linear habitat the max Ma should approach 2*\sum_1^{max} g^k\approx 2g/(1-g)
            }
            b++;
		  }// yypos
		}// xxpos
		a++;
       } // for ypos ...
	} // for xpos ...

	// seeks maximum (over pops 'a') migration rate and deduces rescaling
	stable_sort(Ma.begin(),Ma.end());

//cout<<(*Ma.rbegin())<<" "<<DispPars[0]<<" "<<DispPars[1]<<" "<<Mab[0][1];getchar();
	double renorm=DispPars[0]/(*Ma.rbegin()); //2 *N_T* m / row max
//cout<<renorm;getchar();

//cout<<DispPars[0]<<" "<<DispPars[1];getchar();
    //rescales everything
	for(a=0;a<MigPSON;a++) {
		Ma[a]=0.0;
		for(b=0;b<MigPSON;b++){
			if(a!=b) {
//cout<<a<<" "<<b<<" "<<Mab[a][b];getchar();
                Mab[a][b]*=renorm;
//cout<<a<<" "<<b<<" "<<Mab[a][b];getchar();
                Ma[a]+=Mab[a][b];
//cout<<Ma[a]<<endl;
            }
		}// for b ...MigPSON
//cout<<a<<" "<<Ma[a];getchar();
	} // for a ...MigPSON
//ostream_vec_vector(Mab,cout); getchar();  // affichage matrice
return(0);
}  //fin def MakeMatrixSS

//rempli la matrice Mab et les vecteurs Ma pour dispersion arbitraire pour mod[`e]les Npops
// a 0 sur la diagonale
// Mab backward rates : propto probability of coming from deme b
int CMigMod::MakeMatrixNpop(int& PopSampledOrNot,const vector<parstype>& Disp_Pars){
	int a,b;
	DispPars.resize(Disp_Pars.size());
	copy(Disp_Pars.begin(),Disp_Pars.end(),DispPars.begin());//DispPars= m12, m13,.. m21, m23 ... = tous les taux de mig pour Npop
	//cout<<"MakeMatrix->Disp_Pars[0]="<<Disp_Pars[0]<<", Disp_Pars[1]="<<Disp_Pars[1]<<endl;//affichage a adapter pour >2 pops
	//cout<<"MakeMatrix->DispPars[0]="<<DispPars[0]<<", DispPars[1]="<<DispPars[1]<<endl<<endl;
	MigPSON=PopSampledOrNot; //sets MigPSON, variable membre de CMigMod = total number of populations
	init_file_et_critere=numeric_limits<scaledTimeType>::max();  // uses asympto approx after infinite time except if...

	if (AsymptoPerDispRateBool) {
		/* this must be t_gener m (sigma²|m)=disp_rate_control_param * lPSON*/
		/* i.e. t_gener/N_T m N_T (sigma²|m)=disp_rate_control_param * lPSON*/
		/* i.e. t_scaled DispPars[0] (sigma²|m)=disp_rate_control_param * lPSON*/
		/* i.e. t_scaled = disp_rate_control_param * lPSON/[DispPars[0] (sigma²|m)]*/
		/* hence critere = disp_rate_control_param * lPSON/[DispPars[0] (sigma²|m)]*/
		/*	init_file_et_critere=disp_rate_control_param*lPSON*(1.-DispPars[1])/(sqrt(1.+DispPars[1]));*/ //vieux

		cout<<"(!) ASYMPTO per dispersal rate not implemented for the Npop model, No ASYMPTO will be used"<<endl;

		//impl['e]mentation FR pour IBD, pas adapt['e] a Npop
		//init_file_et_critere=disp_rate_control_param*lPSON*(1.-DispPars[1])*(1.-DispPars[1])/(1.+DispPars[1]);
		//init_file_et_critere/=DispPars[0];
	}
	if (asymptoBool) {
		cout<<"(!) ASYMPTO have not been adapted to Npop model (Asymptotic Fst is not implemented for Npop model)"<<endl;
		cout<<"No ASYMPTO will be considered."<<endl;
		asymptoBool=false;

		//impl['e]mentation FR pour IBD, pas adapt['e] a Npop
		//DeuxPiSurNx=2*PI/lPSON;
		//costable.resize(lPSON);
		//for(long int ii=0;ii<lPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);
		//limit_FSurUnMoinsF=0;
		//{//block local variable
		//	cumultype temp;
		//	for(int ii=1;ii<lPSON;ii++) {
		//		temp=costable[ii];
		//		temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp));
		//		temp=1/((1-temp)*DispPars[0]);
		//		// c'est par ex 1/((1-cos(...))*disp_proba*2*nx*Nhaploid);
		//		limit_FSurUnMoinsF+=temp;
		//	}
		//} //fin block
	}

/*//impl['e]mentation FR pour IBD, pas adapt['e] a Npop
#ifdef ASYMPTO	// dans tous les cas on a besoin du Fst asymptotique
#ifdef ASYMPTO_PAR_DISP_EVENTS
//2*lPSON/sigma en 1D (sigma2 en 2D !!!)
	init_file_et_critere= (int) (disp_events_control_param*lPSON*(1.-DispPars[1])/sqrt(1.+DispPars[1]));
#endif
#ifdef ASYMPTO_PAR_DISP_RATE
// this must be t_gener m (sigma²|m)=disp_rate_control_param * lPSON
// i.e. t_gener/N_T m N_T (sigma²|m)=disp_rate_control_param * lPSON
// i.e. t_scaled DispPars[0] (sigma²|m)=disp_rate_control_param * lPSON
// i.e. t_scaled = disp_rate_control_param * lPSON/[DispPars[0] (sigma²|m)]
// hence critere = disp_rate_control_param * lPSON/[DispPars[0] (sigma²|m)]
//	init_file_et_critere=disp_rate_control_param*lPSON*(1.-DispPars[1])/(sqrt(1.+DispPars[1]));//vieux

	init_file_et_critere=disp_rate_control_param*lPSON*(1.-DispPars[1])*(1.-DispPars[1])/(1.+DispPars[1]);
	init_file_et_critere/=DispPars[0];
#endif
	DeuxPiSurNx=2*PI/lPSON;
	costable.resize(lPSON);
	for(long int ii=0;ii<lPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);

	//ancienne version stupide
	//for(int ii=0;ii<=lPSON/2;ii++)
	//	for(int jj=0;jj<=lPSON/2;jj++) costable[ii*jj]=cos(ii*jj*DeuxPiSurNx);
	//for(int ii=lPSON/2+1;ii<=lPSON;ii++) costable[ii]=cos(ii*DeuxPiSurNx);

	limit_FSurUnMoinsF=0;
	{//block local variable
		cumultype temp;
		for(int ii=1;ii<lPSON;ii++) {
		temp=costable[ii];
		temp=(1-DispPars[1])*(temp-DispPars[1])/(1+DispPars[1]*(DispPars[1]-2.0*temp));
	//ggg=DispPars[1];
		temp=1/((1-temp)*DispPars[0]);
	// c'est par ex 1/((1-cos(...))*disp_proba*2*nx*Nhaploid);
		limit_FSurUnMoinsF+=temp;
		}
	} //fin block
#endif //ASYMPTO
*/

	for(a=0;a<MigPSON;a++) {
		Mab.resize(a+1);
		Ma.resize(a+1);
		Ma[a]=0.0;
		for(b=0;b<MigPSON;b++){
			Mab[a].resize(b+1,0);
			if(a!=b) {
				Mab[a][b]=Disp_Pars[a*(MigPSON-1) + b - (b>a ? 1 : 0)];
				Ma[a]+=Mab[a][b];
			}
			else Mab[a][b]=0.0;
		}// for b ...MigPSON
	} // for a ...MigPSON

//ostream_vec_vector(Mab,cout); getchar();  // affichage matrice
return(0);
}  //fin def MakeMatrixNpop

//pour OnePop et SplitModel
int CMigMod::MakeOnePop() {

	DispPars.resize(0);
	MigPSON=1; //sets MigPSON, variable membre de CMigMod = total number of populations
	init_file_et_critere=numeric_limits<scaledTimeType>::max();  // uses asympto approx after infinite time except if...

	if (AsymptoPerDispRateBool) {
		cout<<"(!) ASYMPTO per dispersal rate not implemented for the Npop model, No ASYMPTO will be used"<<endl;
	}
	if (asymptoBool) {
		cout<<"(!) ASYMPTO have not been adapted to Npop model (Asymptotic Fst is not implemented for Npop model)"<<endl;
		cout<<"No ASYMPTO will be considered"<<endl;
		asymptoBool=false;
	}
Mab.resize(1);
Mab[0].resize(1);
Mab[0][0]=0.0;
Ma.resize(1);
Ma[0]=0.0;
PopSize.resize(1);
PopSize[0]=1.0;

return(0);
}  //fin def MakeOnePop

float CMigMod::Nsigma2() {
// not used, not tested
return ((1.+DispPars[1])/exp(2*log(1.-DispPars[1]))*DispPars[0]/(2.*MigPSON));
// stepping: m=2*N_S*v ici N_S=n_d*N
}

int CMigMod::PrintMig(){
cout << "\tMigModSettings :\n\tThere are/is " << MigPSON << " population(s) exchanging migrants using the following " ;//pour verifs changements ancestraux du nombre de pops
cout << "\tMigration Matrix is : " << endl;
ostream_vec_vector(Mab,cout);cout << endl;
//pour changements ancestraux du nombre de pops
cout << "\t" << PopMergedNbr << " population(s) already merged to Pop0, they are :" ;
for(int a=0;a<PopMergedNbr;a++) cout << "Pop" << PopMergedTab[a] ;
cout << endl;
return(0);
}



//fait un vecteur PopSize toutes egales si IBD, prends les valeurs des paramètres si Npop
int CMigMod::MakePopSize(std::vector<parstype> PopSizeTab){
int a;
pascumultype Sum=0.0;

PopSize.resize(MigPSON);
for(a=0;a<MigPSON;a++) { // must use the global variable if the class mbr var is not def.
	if(DemographicModel=="Npop" || DemographicModel=="IM") PopSize[a]=PopSizeTab[a];
	 else PopSize[a]=1.0/MigPSON;//IBD
    if(PopSize[a]<=0.0) {
        cerr<<"(!) Problem when calculating relative population sizes under Npop model"<< endl;
        cerr<<"(!) Relative population size is negative PopSize[" << a << "]="<<PopSize[a]<<endl;
        cerr<<"(!) I exit. "<<endl;
        if (cinGetOnError) cin.get();
        exit(-1);
    }
}
Sum=0.0;
for(a=0;a<MigPSON;a++) Sum+=PopSize[a];

if(fabs(Sum-1.0)>1000*numeric_limits<pascumultype>::epsilon()) { //RL042016 was 1E-5
	cerr<<"(!) Problem when calculating relative population sizes under Npop model"<< endl;
    cerr<<"(!) Sum of relative population sizes is not 1.0 but "<<Sum<< endl;
    cerr<<"fabs(Sum-1.0)="<<fabs(Sum-1.0) << " > numeric_limits<pascumultype>::epsilon()="<<numeric_limits<pascumultype>::epsilon()<<". I exit"<<endl;
    for(a=0;a<MigPSON;a++) cerr<<"PopSize[a]="<<PopSize[a]<<endl;
	if (cinGetOnError) cin.get();
	exit(-1);
}


return(0);

}


int CMigMod::PrintPopSize(){
cout << "\tPopulation Sizes are :" << endl;
ostream_vector(PopSize,cout);cout << endl;
return(0);
}

//pour splitmodel : fait un vecteur AncPopSize [`a] partir des valeures de param[`e]tres AncPopSizeTab
int CMigMod::MakeAncPopSizeChangeTime(vector<parstype> AncPopSizeTab,vector<scaledTimeType> ChangeTimeTab){
scaledTimeType Tmin=numeric_limits<scaledTimeType>::max();

for(unsigned int a=0;a<ChangeTimeTab.size();a++) if(ChangeTimeTab[a]<Tmin) Tmin=ChangeTimeTab[a];
PrevChangeTime=-666;
MinChangeTime=Tmin;
if(Tmin<numeric_limits<scaledTimeType>::infinity()) InAncStablePopbool=false;
 else InAncStablePopbool=true;
//for(int a=0;a<ChangeTimeTab.size();a++) cout << "ChangeTimeTab[" << a << "]=" << ChangeTimeTab[a] << endl;
//cout << "MinChangeTime=" << MinChangeTime << endl;
//cout << "PrevChangeTime=" << PrevChangeTime << endl;
//getchar();
if(DemographicModel=="IM") {
    for(int a=0;a<MigPSON-1;a++) { // must use the global variable if the class mbr var is not def.
	   ChangeTime.resize(a+1);
	   ChangeTime[a]=ChangeTimeTab[a];
	   AncPopSize.resize(a+1);
	   if(a==MigPSON-2) AncPopSize[a]=1.0;
	    else AncPopSize[a]=AncPopSizeTab[a];
    }
    ChangeTime.push_back(numeric_limits<pascumultype>::infinity());
} else {//for OnePop with varaible size
    ChangeTime.resize(ChangeTimeTab.size());
	for(unsigned int a=0;a<ChangeTime.size();a++) ChangeTime[a]=ChangeTimeTab[a];
	AncPopSize.resize(0);
}
//PrintChangeTime();
return(0);
}

//pour IM, OnePopVarSize et OnePopFounderFlush model
//remet a jour le vecteur ChangeTime[] au d['e]but d'un run (il a pu etre modifi['e] par le run pr['e]c['e]dent)
int CMigMod::ResetChangeTime(vector<scaledTimeType> ChangeTimeTab){
int a;
scaledTimeType Tmin=numeric_limits<scaledTimeType>::max();

PopMergedNbr=0;
MinChangeTime=numeric_limits<scaledTimeType>::infinity();
for(a=0;a < ( (int) ChangeTimeTab.size() );a++) if(ChangeTimeTab[a]<Tmin) Tmin=ChangeTimeTab[a];
PrevChangeTime=-666;
if(Tmin<numeric_limits<scaledTimeType>::infinity()) InAncStablePopbool=false;
 else InAncStablePopbool=true;
MinChangeTime=Tmin;

if(DemographicModel=="IM") {
    for(a=0;a<MigPSON-1;a++) { // must use the global variable if the class mbr var is not def.
        ChangeTime.resize(a+1);
        ChangeTime[a]=ChangeTimeTab[a];
    }
    ChangeTime.push_back(numeric_limits<pascumultype>::infinity());
} else {//for OnePop with varaible size
	ChangeTime.resize(ChangeTimeTab.size());
	for(a=0;a< ( (int) ChangeTime.size() );a++) ChangeTime[a]=ChangeTimeTab[a];
}
//PrintChangeTime();
return(0);
}

//pour IM, OnePopVarSize et OnePopFounderFlush
int CMigMod::PrintChangeTime(){
if((DemographicModel=="IM" && MigPSON==1) || ((DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush") && !(MinChangeTime<numeric_limits<scaledTimeType>::infinity()))) {
  cout << "\nThere is no more size change/divergence times because we are in the ancestral population;" << endl;
} else {
  cout << "\nPrintChangeTime()   -> All Times of demographic change are :";
  ostream_vector(ChangeTime,cout);cout << endl;
}
return (0);
}

//RL pour IM
int CMigMod::PrintAncPopSize(){
cout << "\tRelative Ancestral population Sizes are :" << endl;
ostream_vector(AncPopSize,cout);cout << endl;
return (0);
}

//check if migration is reversible Mab=)Ma*Mb
int CMigMod::CheckM(){
int a,b;
cumultype temp=0.0,sum=0.0,poub;

x.resize(MigPSON);y.resize(MigPSON);

//2 pops is really always the mpim case
if(MigPSON==2){
	temp=Mab[0][1]+Mab[1][0];
	y[0]=Mab[1][0]/temp;
	y[1]=Mab[0][1]/temp;
	x[0]=temp;
	x[1]=temp;
#ifdef DEBUG
	if(DebugDG){
		cout << "Check Mig->" << endl;
		cout << "x[0]->x[" << MigPSON-1 << "] : " << endl;
		for(b=0;b<MigPSON;b++) cout << x[b] << " ";
		cout << endl;
		cout << "y[0]->y[" << MigPSON-1 << "] : " << endl;
		for(b=0;b<MigPSON;b++) cout << y[b] << " ";
		cout << endl;
		}
#endif
	return(0);
	}


for(b=1;b<MigPSON;b++){
	if(b==1) a=MigPSON-1; else a=1;
	y[b]=poub=Mab[a][b]/Mab[a][0];//contain yb/y0
	}
for(b=1;b<MigPSON;b++) temp+=poub=y[b];//temp is (1-y0)/y0
y[0]=1.0/(1.0+temp);
for(b=1;b<MigPSON;b++) y[b]*=poub=y[0];
for(a=1;a<MigPSON;a++) x[a]=poub=Mab[a][0]/y[0];
x[0]=poub=Mab[0][MigPSON-1]/y[MigPSON-1];
for(a=0;a<MigPSON;a++)
	for(b=0;b<MigPSON;b++)
		if(a!=b){
			if( fabs(Mab[a][b]-x[a]*y[b]) > numeric_limits<cumultype>::epsilon()) return 0;
			}
for(b=0;b<MigPSON;b++) sum+=poub=y[b];
if(fabs(sum-1.0)>numeric_limits<cumultype>::epsilon()) {
	cout << "\n bug with y[b]'s, which sum to ";
	cout << sum << endl;
	if (cinGetOnError) cin.get();
	exit(-1);
	}
#ifdef DEBUG
if(DebugDG){
	cout << "Check Mig->" << endl;
	cout << "x[0]->x[" << MigPSON-1 << "] : " << endl;
	for(b=0;b<MigPSON;b++) cout << x[b] << " ";
	cout << endl;
	cout << "y[0]->y[" << MigPSON-1 << "] : " << endl;
	for(b=0;b<MigPSON;b++) cout << y[b] << " ";
	cout << endl;
	}
#endif
return(0);
}

//check if stepping stone migration or not
int CMigMod::CheckMSmm(){
int a,Ssm;
cumultype rate;//the migration rate, should be equal for all pop if stepping stone

if(MigPSON<=2) {return(0);}
rate=Mab[0][1];

Ssm=1;
for(a=1;a<MigPSON-1;a++)//part de 1 et jusuqe state-1 pour eviter les bords
	if(Mab[a][a]==0.0){
		if(Mab[a-1][a]==rate && Mab[a][a+1]==rate) ;
		 else {Ssm=0; break;}
		}
	  else {Ssm=0; break;}

if(Ssm){
	//v['e]rifier les effets de bords :
	if((Mab[0][1]==Mab[0][MigPSON-1])&&(Mab[MigPSON-1][0]==Mab[MigPSON-1][MigPSON-2])) ;
 		else Ssm=0;
}

return(Ssm);
}

//Change Mig model to take into account the fusion of 2 populations (in the Split model)
int CMigMod::MergePop(int Sink,int PopMerged,int PopSampledOrNot,vector<parstype> Disp_Pars,vector<parstype> AncPopSize){
int a,b,aa,bb,i;
pascumultype Sum=0.0;
scaledTimeType Tmin=numeric_limits<scaledTimeType>::max();

#ifdef DEBUG
if(DebugSplit) cout << "Migmod::PopMerge() is merging populations " << Sink << " and " << PopMerged << ";"<< endl;
#endif

PopMergedNbr++;
PopMergedTab.resize(PopMergedNbr);
PopMergedTab[PopMerged-1]=PopMerged;
init_file_et_critere=numeric_limits<scaledTimeType>::max();  // uses asympto approx after infinite time except if...
for(a=0;a< ( (int) ChangeTime.size() );a++) if(ChangeTime[a]<Tmin && ChangeTime[a]>=MinChangeTime) Tmin=ChangeTime[a];
PrevChangeTime=MinChangeTime;
MinChangeTime=Tmin;
MigPSON=PopSampledOrNot; //sets MigPSON after the fusion of 2 pops, variable membre de CMigMod = total number of populations
//on recopy les ancien taux de migration sauf pour les pops regroup['e]
DispPars.resize(MigPSON*(MigPSON-1));
if(MigPSON==1) {//si il ne reste qu'une seule pop
if(DebugSplit) cout << "New demographic model has only one population;" << endl;
//	Model="OnePop";
	Mab.resize(1);
	Mab[0].resize(1);
	Mab[0][0]=0.0;
	Ma.resize(1);
	Ma[0]=0.0;
	PopSize[Sink]=1.0;
	MinChangeTime=numeric_limits<scaledTimeType>::infinity();
	InAncStablePopbool=true;
}
else {//si il reste plusieur pops
     //ci dessous truc bizarre, d'ou ca vient? a virer? PRB RL
	//for(a=0;a<MigPSON;a++)
InAncStablePopbool=false;
copy(Disp_Pars.begin(),Disp_Pars.end(),DispPars.begin());//DispPars= m12, m13,.. m21, m23 ... = tous les taux de mig pour Npop
//cout<<"MergePop->Disp_Pars[0]="<<Disp_Pars[0]<<", Disp_Pars[1]="<<Disp_Pars[1]<<endl;//affichage a adapter pour >2 pops
//cout<<"MergePop->DispPars[0]="<<DispPars[0]<<", DispPars[1]="<<DispPars[1]<<endl<<endl;
#ifdef DEBUG
if(DebugSplit) cout << "New demographic model has " << MigPSON << " populations;" << endl;
#endif
for(a=0;a<MigPSON;a++) {
		Mab.resize(a+1);
		Ma.resize(a+1);
		Ma[a]=0.0;
		for(b=0;b<MigPSON;b++){
			Mab[a].resize(b+1,0);
			if(a!=b) {
				aa=a;bb=b;
				for(i=0;i<PopMergedNbr;i++) {
					if(a>=PopMergedTab[i]) aa++;
					if(b>=PopMergedTab[i]) bb++;
				}
				Mab[a][b]=Disp_Pars[aa*(MigPSON-1) + b - (bb>aa ? 1 : 0)];
				Ma[a]+=Mab[a][b];
			}
			else Mab[a][b]=0.0;
		}// for b ...MigPSON
	} // for a ...MigPSON


	Sum=0.0;
	for(a=0;a<MigPSON;a++) {
		aa=a;
		for(i=0;i<PopMergedNbr;i++)	if(a>=PopMergedTab[i]) aa++;
		if(a!=Sink)	Sum+=PopSize[aa];
	}
	for(a=0;a<MigPSON;a++) { // must use the global variable if the class mbr var is not def.
		PopSize.resize(a+1);
		aa=a;
		for(i=0;i<PopMergedNbr;i++)	if(a>=PopMergedTab[i]) aa++;
		if(a==Sink) Sum/=AncPopSize[PopMergedTab[PopMergedNbr-1]];
		if(DemographicModel=="Npop" || DemographicModel=="IM") {//Npop
			PopSize[a]=PopSize[aa]/Sum;
		}
			else {
				cout << "!!! Problem when merging Population (time reversible split) !!!" << endl;
				cout << "!!! this can not be done under a IBD model, but only for the NPop model" << endl;
				if (cinGetOnError) cin.get();
				exit(-1);
			}
	}

	Sum=0.0;
	for(a=0;a<MigPSON;a++) Sum+=PopSize[a];
	if(fabs(Sum-1.0)>numeric_limits<pascumultype>::epsilon()) { //RL042016 was 1E-5
		cout<<"(!) Problem when calculating relative population sizes under Npop model"<< endl;
		cout<<"(!) Sum of relative population sizes is not 1.0 but "<<Sum<<". I exit"<<endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
}//fin else(onepop)
#ifdef DEBUG
if(DebugSplit) cout << "Migmod::PopMerge() set next split event at time " << MinChangeTime << ";"<< endl;
#endif
return 0;
}


//-------------------------------------------------------
//--------class CSample


CSample::CSample(CSample* Sample){
Size=0;
PopSampledOrNot=Sample->PopSampledOrNot;
alleleIndices.resize(Sample->alleleIndices.size());
copy(Sample->alleleIndices.begin(),Sample->alleleIndices.end(),alleleIndices.begin());
Sam_AlleleNbr=Sample->Sam_AlleleNbr;
Effectif.resize(Sample->Effectif.size()); // on devine que c'est PopSampledOrNot mais... idem pour les lignes suivantes
//for(vector<vector<int> >::iterator a=Effectif.begin();a<Effectif.end();a++) (*a).resize(Sam_AlleleNbr);
for(unsigned int ii=0;ii<Sample->Effectif.size();ii++) Effectif[ii].resize(Sample->Effectif[ii].size());
PopEffectif.resize(Sample->PopEffectif.size());
StateEffectif.resize(Sample->StateEffectif.size());
AllelicRange.resize(Sample->AllelicRange.size());
proposalCorrectionFactor=Sample->proposalCorrectionFactor;//for alternative FR mixed PI's, 25012011
PIjabool=false;//for alternative FR mixed PI's, indicate if the current PI computation coresponds to the PIja computation or not, 25012011
}


CSample::CSample(){
//int a;
Size=0;
locusNum=1;
runNum=0;
AllelicRange.resize(2);
//Effectif.resize(Mig->PopSampledOrNot);
//for(a=0;a<Mig->PopSampledOrNot;a++) Effectif[a].resize(Mut->Mut_AlleleNbr);
//PopEffectif.resize(Mig->PopSampledOrNot);
}

ptrToMemberFn setPiCalcFnPtr(string locPiSolver) { //FR->FR appeler differentes fns en fn de g ?
       if (IBDbool) {
          if (cmp_nocase(locPiSolver,"PCG_penta")==0) {
              return(&CSample::lin_abs_sparsified_1D_penta);
          } else if (cmp_nocase(locPiSolver,"PCG_island")==0) {
              return(&CSample::sparsified);
          } else return(&CSample::PicalcPIMLDLsym);
       }
       else if (mutationModel == "ISM" || mutationModel == "SNP")
    	   return(&CSample::PiCalcISM);
	   else {
          if(cmp_nocase(locPiSolver,"SMM2popDGLR05")==0) return(&CSample::PiCalcTwoPopSmmDG2002);
            else if (cmp_nocase(locPiSolver,"PiPim")==0) return(&CSample::PiCalcPimDG2002);
                else if (cmp_nocase(locPiSolver,"PiTwoPop")==0) return(&CSample::PiCalcTwoPopDG2002);
                    else if (cmp_nocase(locPiSolver,"SymDirect")==0) return(&CSample::PicalcPIMLDLsym);
                        else if (locPiSolver.substr(0,6)=="OnePop") return(&CSample::PiCalcOnePop);
                            else {
                                cerr<<"(!) From setPiCalcFnPtr(...): invalid locPiSolver \""<<locPiSolver<<"\";";
                                if (cinGetOnError) cin.get();
                                exit(-1);
                            }
        }
}


//lit le fichier echantillon et rempli toutes cxaracteristiques de Sample
//attention ecriture du fichier echantillon differente selon le modele
//=special si SMM avec bcp d'alleles
/***** attention il y a deux versions de GetSample()  ******/

//calcule le nombre d'all[`e]les pr['e]sent au locus ->parametre de MutMod = option NonEmptyStates
// sinon prend tout les ['e]tats all['e]liques possibles pr['e]cis['e]s dans l'['e]chantillon (meme si vides) = option allowsEmptyColumns (necessaires pour faires des tests de proba d'	 et pour SMM)
int CSample::GetSample(string FileName,const int locAlleleNbr){
// read file in re_dg format // OR the global ProcessedLoci
/* A T T E N T I O N
non seulement d'['e]ventuels new
mais TOUS les resize de vecteurs membres doivent avoir leur ['e]quivalent dans CSample::CSample(CSample* Sample).
Des new seraient un probl[`e]me pour le copy constructor aussi.
*/
//std::cerr<<"GetSample(string FileName,";getchar();
int a,b,j,State,pos_last_subsample=-1,nbElementsFirstRow;
stringstream stst,substst;
string buf;
string::size_type pos;
vector<int> tempStateEffectif,CheckPopEffectif;//pour SMM
vector< vector<int> > tempEffectif;//ajout 16/03/2010 pour tailles alleliques relatives en SMM

generation=0;  // when we read the sample in a file, we're at generation 0
scaled_generation=0;  // when we read the sample in a file, we're at generation 0

//disp_coal_events=0;
events=0;
#ifdef ASYMPTO_PAR_DISP_EVENTS
	disp_events=0;
#endif

Size=0;
nbElementsFirstRow=0;
AllelicRange.resize(2); //pour SMM

ifstream inFile;
inFile.open(FileName.c_str(),ios::in);
if( ! inFile.is_open()) {
	FileName+=".txt";// si on ne trouve pas <nameroot><n> on cherche <nameroot><n>.txt
    inFile.clear();
	inFile.open(FileName.c_str(),ios::in);
	if(!inFile.is_open()) {
		cerr << "Unable to open file : " << FileName << " in CSample::GetSample();" << endl;
		cerr << "I exit." << endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
}

if(mutationModel=="PIM"){
    	a=0; //ligne du fichier=pop
    	do	{
            getline(inFile,buf);
    		if(buf.length()==0) break; //ligne vide
    		//else

    		Effectif.resize(a+1);
    		PopEffectif.resize(a+1);
    //		cout<<a<<" "<<PopEffectif.size();getchar();
    		PopEffectif[a]=0;
    		j=0; //col du fichier = allele
    	    stst<<buf;
                      while (stst>>buf) { // prend chaque morceau entre espaces
               pos=0;
    		   while (buf[pos]!='\n' && !isdigit(buf[pos])) pos++; // garde "8" ou "8;" pas ";"
    		   buf.erase(0, pos);
    		   if (buf.length()>0) {//found a number
    			  Effectif[a].resize(j+1);
    			  if (a==0) {
                     StateEffectif.resize(j+1);
                     StateEffectif[j]=0;
                  } //FER: test+resize et non reserve
    			  substst<<buf;
                  substst>>Effectif[a][j]; //vire le ";" de "8;"
                  substst.str("");
                  substst.clear();
    			  PopEffectif[a]+=Effectif[a][j];
    			  StateEffectif[j]+=Effectif[a][j];
    			  j++;
    			} // else reached end of line apres un ";"
            } // else plus rien dans la stst
            stst.str("");
            stst.clear();
    //ostream_vector(Effectif[a],cout);getchar();
    		if(PopEffectif[a]>0){
    			Size+=PopEffectif[a];
    			pos_last_subsample=a;
    			}
    		if(allowsEmptyColumns) //Allows null counts; nbElementsFirstRow is "j", the length of the first row
			{ if(a==0) nbElementsFirstRow=j;
				else if(j!=nbElementsFirstRow) { //sub test not logically related to allowsEmptyColumns
					cout << "(!) problem when reading sample file : all pops do not have the same number of possible allelic states (nbr of columns)..." << endl;
					cout << "(!) I exit." << endl;
					if (cinGetOnError) cin.get();
					exit(-1);
				}
			}
    		a++;
        }while(!inFile.eof());
//rajout FR 04/2010 GivenK n'avait pas d'effet sur ad hoc files....
	   if (locAlleleNbr> ( (int) StateEffectif.size() ) ) {
	       StateEffectif.resize(locAlleleNbr,0);
    	   for(vector<vector<int> >::iterator it=Effectif.begin();it!=Effectif.end();it++) it->resize(locAlleleNbr,0);
	   }
}//fin if ==PIM
else {//attention le fichier est completement diff['e]rent pour le SMM/GSM...

	a=0;
	do {
	    getline(inFile,buf);
    } while(buf.length()==0);
	//lit la premiere ligne = les tailles d'echantillon par pop
	do	{
		while((buf[0]==' ')||(buf[0]=='\t')) {buf.erase(0,1);}//vire les blancs
		if((buf.length()>0)&&(buf[0]!=';')&&(buf[0]!='\n')) {
			pos=min(buf.find(' '),min(buf.find('\t'),buf.length()));
			PopEffectif.resize(a+1);
			PopEffectif[a]=atoi(buf.substr(0,pos).c_str());
			Size+=PopEffectif[a];
			a++;
			buf.erase(0,pos);
		}
		}while((buf.length()>0)&&(buf[0]!=';')&&(buf[0]!='\n'));

    //cout << a << endl;
    //for(b=0;b<a;b++) cout << "First line gives an effectif for pop " << b << " of : " << PopEffectif[b] << endl;
	//pour le SMM le nombre d'alleles est connu d'avance
	StateEffectif.resize(locAlleleNbr,0);
	tempStateEffectif.resize(locAlleleNbr,0);
	Effectif.resize(a);
	tempEffectif.resize(a);
	for(b=0;b<a;b++) {Effectif[b].resize(locAlleleNbr,0);tempEffectif[b].resize(locAlleleNbr,0);}
	CheckPopEffectif.resize(a,0);
	pos_last_subsample=a;

	// a partir de la on lit vraiment l'['e]chantillon
	b=0;
	b--;
	do {if(cmp_nocase(buf.substr(0,3),"pop")==0) {b++;CheckPopEffectif[b]=0;}//nouvelle pop due a la ligne "pop"
	    if(b>0) if(CheckPopEffectif[b-1]!=PopEffectif[b-1]) {
            cout << "(!) Sample size indicated in the first lines of " << FileName << " for pop "<< b-1 << " is " << PopEffectif[b-1] << endl ;
            cout << "(!) But sample size computed from each represented allelic state is  " << CheckPopEffectif[b-1] << endl;
            cout << "(!) Check Input File format for file " << FileName << endl;
            cout << "(!) I exit." << endl;
            if (cinGetOnError) cin.get();
    		exit(-1);
        }
	    newpop:
		do {//on continue la lecture apres la premiere ligne,
			getline(inFile,buf);
			while((buf[0]==' ')||(buf[0]=='\t')) {buf.erase(0,1);}//vire les blancs
			if(cmp_nocase(buf.substr(0,3),"pop")==0) {// et on trouve ['e]ventuellement unn pop.
                if(inFile.eof()) break;
				if( b>- 1 && (CheckPopEffectif[b]!=PopEffectif[b])) {
					cout << endl;
					cout << "(!) problem when reading sample file" << endl;
					cout << "(!) Effectif of pop : " << b << " is written : " << PopEffectif[b] << endl;
					cout << "(!) but found to be : " << CheckPopEffectif[b] << endl;
					cout << "(!) Check you sample file. I exit." << endl;
					if (cinGetOnError) cin.get();
					exit(-1);
				}
				if(cmp_nocase(buf.substr(0,3),"pop")==0) {//nouvelle pop due a la ligne "pop"
					b++;
					//cout << b<< endl;
					CheckPopEffectif[b]=0;
				}
				goto newpop;
			}
			//maintenant on prend les tailles et les alleles
			if(buf.length()==0) break;
			while((buf[0]==' ')||(buf[0]=='\t')) {buf.erase(0,1);}//vire les blancs
			pos=min(buf.find(' '),min(buf.find('\t'),buf.length()));
			State=atoi(buf.substr(0,pos).c_str());
			//on prends ls valeures lues, puis on fera une transfo pour etre au milieu des bornes du SMM (0-givenK ou 0-locAlleleNbr)
			j= State;
			//cout << "Get Sample read state = " << j << endl;
			if(j>locAlleleNbr-1) {
                cout << "(!) Too large alleles detected in the sample." << endl;
				cout << "	an allele of size " << j << " is detected in sample file '"<< FileName << "'." << endl;
				cout << "	compared to the largest allelic state allowed for mutation model (SMM or GSM) =  (= Allele number - 1)" << locAlleleNbr << endl;
                cout << "(!) check input file or change the number of allelic states to be considered" << endl;
                cout << "\n(!) I exit." << endl;
                if(cinGetOnError) cin.get();
                exit(-1);
            }
			buf.erase(0,pos);
			while((buf[0]==' ')||(buf[0]=='\t')) {buf.erase(0,1);}//vire les blancs
			pos=min(buf.find(' '),min(buf.find('\t'),buf.length()));
			tempEffectif[b][j]=atoi(buf.substr(0,pos).c_str());
			//cout << "Get Sample read effectif for state " << j   << " in pop " << b << " is " << Effectif[b][j] << endl;
			CheckPopEffectif[b]+=tempEffectif[b][j];
			tempStateEffectif[j]+=tempEffectif[b][j];
			buf.erase(0,pos);
		}while(!inFile.eof());
		if(b==0 || b==(a-1)) if(CheckPopEffectif[b]!=PopEffectif[b]) {
            cout << "(!) Sample size indicated in the first lines of " << FileName << " for pop "<< b << " is " << PopEffectif[b] << endl ;
            cout << "(!) But sample size compiuted from each represented allelic state is  " << CheckPopEffectif[b] << endl;
            cout << "(!) Check Input File format for file " << FileName << endl;
            cout << "(!) I exit." << endl;
            if (cinGetOnError) cin.get();
    		exit(-1);
        }
	}while(!inFile.eof());

//on cherche le min et max des alleles pr['e]sents
	int minAll=locAlleleNbr;
	int maxAll=0;
	int itState=0;
	for(vector<int>::iterator it=tempStateEffectif.begin();it!=tempStateEffectif.end();it++) {
		if((*it)>0) {
			if(itState<minAll) minAll=itState;
			if(itState>maxAll) maxAll=itState;
		}
		itState++;
	}

//maintenant on fait une translation des tailles all['e]liques pour que l'['e]chantillon soit au milieu des bornes de SMM
	int itPop=0;
	for(vector< vector<int> >::iterator it1=tempEffectif.begin();it1!=tempEffectif.end();it1++) {
		int itState=0;
		for(vector<int>::iterator it2=(*it1).begin();it2!=(*it1).end();it2++) {
			int newState=itState + (int) floor((locAlleleNbr - maxAll+minAll)/2);
			if((*it2)>0) { if(newState>locAlleleNbr) {
				cout << "(!) Two large alleles detected in sample compared to the number of states specified for SMM" << endl; //FR->RL cerr et non cout...
				cout << "\n(!) This may not be seen directly from your sample file, \nbecause the programm add (GivenK -maxAlleleSize+minAlleleSize)/2 \nto each allele length for correct bound considerations" << endl;
                cout << "\n(!) check input file or change the number of allelic states for SMM/GSM" << endl;
				cout << "\n(!) The number of allelic states for SMM/GSM should be at least 2 times the highest allele size present in the sample" << endl;
                cout << "\n(!) I exit." << endl;
                if(cinGetOnError) cin.get();
                exit(-1);

			} else {
				Effectif[itPop][newState]=(*it2);
				StateEffectif[newState]+=(*it2);
			}
		    }
			itState++;
		}
		itPop++;
	}

}//fin SMM


    {	int ii=0;
        if (pos_last_subsample==-1) {
   	        cerr<<"From CSample::GetSample(string,int): 'pos_last_subsample' not evaluated. I exit"<<endl;
	        if (cinGetOnError) cin.get();
	        exit(-1);
        }
    	while(ii<pos_last_subsample && PopEffectif[ii]==0) ii++;
        GeoSpan=pos_last_subsample-ii;
    //    cout<<ii<<" "<<pos_last_subsample<<" "<< GeoSpan;getchar();
    }
    PopSampledOrNot=a;


//ostream_vec_vector(Effectif,cerr);
/* Different ways to have empty columns:
   (1) allowsEmptyColumns := settings files mean empty columns in ad hoc file is OK
   (2) sequenceGivenK.size()>0 :=
   (a) columns may have been added beyond those in the ad hoc file or beyond alleles present in Genepop file
   or
   (b) SMM model now always has sequenceGivenK.size()>0.

Otherwise we chack for empty columns.
    */
    if (allowsEmptyColumns || sequenceGivenK.size()>0) {
        Sam_AlleleNbr= (int) StateEffectif.size(); //pour considerer tous les ['e]tats all['e]liqus possibles meme ceux non repr['e]sent['e]s dans l'echantillon   //CM->RL 23.01.14
  } else { // else there should be no null count in the table and we check this at the same time as setting Sam_AlleleNbr.
        int nullcounts= (int) count(StateEffectif.begin(),StateEffectif.end(),0); //CM->RL 23.01.14
    	if (nullcounts>0) { // may be due to using are_dg files rather than re_dg files...
    	        cerr<<"From CSample::GetSample(string,int): some allele has null total count. "<<endl;
    	        ostream_vec_vector(Effectif,cerr);
			cerr<<"\n Use option AllelicStates=AllStates or GivenK=XX if you really mean this. Otherwise check data file "<<FileName<<".\nI exit.";
	        if (cinGetOnError) cin.get();
	        exit(-1);
        } else Sam_AlleleNbr= (int) StateEffectif.size();//CM->RL 23.01.14
    }


/* 12/2005
PIs=new pirestype*[Sam_AlleleNbr];
for (int i=0; i<Sam_AlleleNbr; i++) {PIs[i]=new pirestype[a];}
*/
//cerr<<"from GetSample: Sam_AlleleNbr,StateEffectif="<<Sam_AlleleNbr<<","<<StateEffectif.size()<<endl;
inFile.close();
return(0);

}

//lit le fichier echantillon et rempli toutes cxaracteristiques de Sample

//attention ecriture du fichier echantillon differente selon le modele
//=special si SMM avec bcp d'alleles

//version pour ProcessedLoci
//
int CSample::GetSample(CProcessedLocus* locptr, int locAlleleNbr,bool& alleleNbrChecked){
// reads in a ProcessedLocus
/* A T T E N T I O N
non seulement d'['e]ventuels new
mais TOUS les resize de vecteurs membres doivent avoir leur ['e]quivalent dans CSample::CSample(CSample* Sample).
Des new seraient un probl[`e]me pour le copy constructor aussi.
*/

// FR: merged code for pim or not.
// FR: !!!!! R A P H : je comprend pas grand chose au code SMM
// mon idee c'est que le CSample final a autant de colonnes que d'all[`e]les pr['e]sents ou non
// c'est lecas pour mon code pim mais pas clairement pour le code SMM.

int ligne,allit,nAlleles,nPops,alleleIndex;// a->pop(=ligne en PIM mais pas en SMM, changer le nom...) , j->allit
int pos_last_subsample=-1;
vector<int> CheckPopEffectif;//pour SMM

    generation=0;  // not always true !!
    scaled_generation=0;  // not always true !!

    //disp_coal_events=0;
    events=0;
#ifdef ASYMPTO_PAR_DISP_EVENTS
	disp_events=0;
#endif

    Size=0;
    AllelicRange.resize(2); //pour SMM
    nPops= (int) locptr->alleleCounts.size();
    nAlleles= (int) locptr->alleleCounts[0].size(); //NOT VALID WITH SEQUENTIAL SAMPLES ?
    PopEffectif.resize(0); // two lines to ensure all are filled with 0's
    PopEffectif.resize(nPops,0);
    StateEffectif.resize(0); // idem
    if ((mutationModel != "PIM") && (mutationModel != "ISM") && (mutationModel != "SNP"))
    	StateEffectif.resize(locAlleleNbr,0);//a virer
	else
		StateEffectif.resize(nAlleles,0);//RL->FR FR: should also work for !pim, RL: not for SMM or GSM...
    alleleIndices.resize(locptr->alleleIndices.size());
    //copy alleles indices from ProcessedLocus to CSample
    copy(locptr->alleleIndices.begin(),locptr->alleleIndices.end(),alleleIndices.begin());
    //cout << "nPops=" << nPops << endl;
    Effectif.resize(nPops);
    ligne=0;

    //boucle sur pops sampled or not = ligne (une ligne en KAM/PIM correspond en efet [`a] une pop, mais pas en SMM)

    for (vector<vector<int> >::iterator it=locptr->alleleCounts.begin();it!=locptr->alleleCounts.end();it++) {

        if (mutationModel == "PIM") {
			Effectif[ligne].resize(nAlleles,0); // conveniently fill with 0's...
			//copy from ProcessedLocus to CSample
			copy(it->begin(),it->end(),Effectif[ligne].begin());
			//ostream_vector(Effectif[ligne],cout);getchar();

			allit=0;

			//boucle sur alleles sampled or not
			for (vector<int>::iterator jt=Effectif[ligne].begin();jt!=Effectif[ligne].end();jt++) {
				//cout<<"ICI "<<(*jt);

				// FR: for pim the above loop goes over all alleles present or not (cf code for nAlleles); but for smm ? RL : special procedure below for SMM
				// any ghost allele has been previously added in IBDcrunchLocTable
				alleleIndex=allit;
				PopEffectif[ligne]+=(*jt);
				StateEffectif[alleleIndex]+=(*jt);
				allit++; //IMP: runs from 0 to K-1, exits with value K
			}

		}
        else if (mutationModel == "ISM" || mutationModel == "SNP") {
        	Effectif[ligne].resize(nAlleles, 0); // conveniently fill with 0's...
        	//copy from ProcessedLocus to CSample
        	copy(it->begin(), it->end(), Effectif[ligne].begin());

        	allit = 0;
        	//	Loop over alleles sampled or not
        	for (vector<int>::iterator jt = Effectif[ligne].begin(); jt != Effectif[ligne].end(); jt++) {
        		// CBR: N.B. the immediately global "alleleCounts" loop covers all the current AND ancestral haplotypes under ISM
        		alleleIndex = allit;
        		PopEffectif[ligne] += (*jt);
        		StateEffectif[alleleIndex] += (*jt);
        		allit++; //IMP: runs from 0 to N-1 (where N = the no. of haplotypes)
        	}
        }
        else { //SMM or GSM
			Effectif[ligne].resize(locAlleleNbr,0); // conveniently fill with 0's... for SMM
			//cout << "ligne=" << ligne << "Effectif[Ligne]=" ;
            //ostream_vector(Effectif[ligne],cout); cout << endl;


			//Old code, not working?
			/*int minAll=sequenceGivenK[std::min(args.locus-1,int(sequenceGivenK.size())-1)]; //hhhh trouver l'equiv de args.locus
			int maxAll=0;
			//on doit chercher les min et max pour avoir les tailles relatives
			for(std::vector<int >::iterator it2=alleleIndices.begin();it2!=alleleIndices.end();it2++) {
				if((*it2)<minAll && (*it2)>0) minAll=(*it2);
				if((*it2)>maxAll) maxAll=(*it2);
			}
			*/

			//new code : debuggage merdique, on voit pas les velaures de minall et max all mais code verifie RL le 24/01/2014
			int maxAll=0;
            //cout << "alleleIndices" << endl;
            //ostream_vector(alleleIndices,cout);cout << endl;
            //cout << "locptr->alleleIndices" << endl;
            //ostream_vector(locptr->alleleIndices,cout);cout << endl;
            //fflush(stdout);

			//on doit chercher les min et max pour avoir les tailles relatives
			for(std::vector<int >::iterator it2=locptr->alleleIndices.begin();it2!=locptr->alleleIndices.end();it2++) {
				//cout << "(*it2)=" << (*it2) << "; maxAll=" << maxAll << endl;
                if((*it2)>maxAll) maxAll=(*it2);
			}
			int minAll=maxAll;
			//on doit chercher les min et max pour avoir les tailles relatives
			for(std::vector<int >::iterator it2=locptr->alleleIndices.begin();it2!=locptr->alleleIndices.end();it2++) {
				//cout << "(*it2)=" << (*it2) << "; minAll=" << minAll << endl;
				if((*it2)<minAll && (*it2)>0) minAll=(*it2);
			}
            int locstepsize=finalSMMstepSizes[locptr->locus-1];
            if(!ForceGivenKbool) {
                while( ( (maxAll - minAll)/locstepsize + 11) > locAlleleNbr) {
                    if(!alleleNbrChecked) {
                        cout << "\n(!) From GetSample(CProcessedLocus*,int) : \nLocus "<< locptr->locus << " has been found with more (or almost the same number of) alleles = " << ((maxAll - minAll)/locstepsize + 1) << endl;
                        cout << "than specified (by default or in the setting file, ie. " << locAlleleNbr << ")." << endl;
                        cout << "The smallest allele at this locus is " << minAll << " and the largest is " << maxAll << endl;
                        cout << "Migraine automatically added 10 possible states to the number of states detected for this loci." << endl;
                    }
                    locAlleleNbr=(maxAll - minAll)/locstepsize + 11;
                    if(!(sequenceGivenK.size()>0)) sequenceGivenK.resize(nloci);
                    else if(sequenceGivenK.size()==1) sequenceGivenK.resize(nloci,sequenceGivenK[0]); //fill with default values for all loci
                    sequenceGivenK[std::min(locptr->locus-1,int(sequenceGivenK.size())-1)]=locAlleleNbr;//then compute locus specific value and store it
                    Effectif[ligne].resize(locAlleleNbr);
                    StateEffectif.resize(locAlleleNbr);

                    if(!alleleNbrChecked) {
                        cout << "Total number of possible states is now " << locAlleleNbr << " for this locus." << endl;

                        if((locptr->locus) == nloci) {
                            cout << "\n\n\nFinal message for automatic allelic bounds..." << endl;
                            cout << "For all loci of the data file, the sequence of the number of possible states per locus" << endl;
                            cout << "is the following (you can use it in the settings file to avoid previous messages):" << endl;
                            cout << "AllelicBounds =";
                            for (int i=0;i<nloci-1;i++) cout << " " << sequenceGivenK[i] << ",";
                            cout << " " << sequenceGivenK[nloci-1] << endl;
                            cout << "\nStepsizes were also check and recomputed to fit the data :" << endl;
                            cout << "StepSizes =";
                            for (int i=0;i<nloci-1;i++) cout << " " << finalSMMstepSizes[i] << ",";
                            cout << " " << finalSMMstepSizes[nloci-1] << endl << endl << endl;
                        }

                    }

                }
            } else {
                while( ( (maxAll - minAll)/locstepsize + 1) > locAlleleNbr) {
                    if(!alleleNbrChecked) {
                        cout << "\n(!) From GetSample(CProcessedLocus*,int) : \nLocus "<< locptr->locus << " has been found with more  (or almost the same number of) alleles = " << ((maxAll - minAll)/locstepsize + 1) << endl;
                        cout << "than specified in the setting file (ie. " << locAlleleNbr << ")." << endl;
                        cout << "The smallest allele at this locus is " << minAll << " and the largest is " << maxAll << endl;
                        cout << "Migraine considers that the number of states detected for this locus is the total possible number of states." << endl;
                    }
                    locAlleleNbr=(maxAll - minAll)/locstepsize + 1;
                    if(!(sequenceGivenK.size()>0)) sequenceGivenK.resize(nloci);
                    else if(sequenceGivenK.size()==1) sequenceGivenK.resize(nloci,sequenceGivenK[0]); //fill with default values for all loci
                    sequenceGivenK[std::min(locptr->locus-1,int(sequenceGivenK.size())-1)]=locAlleleNbr;//then compute locus specific value and store it
                    Effectif[ligne].resize(locAlleleNbr,0);
                    StateEffectif.resize(locAlleleNbr);
                    if(!alleleNbrChecked) {
                        cout << "Total number of possible states is now " << locAlleleNbr << " for this locus." << endl;

                        if((locptr->locus) == nloci) {
                            cout << "\n\n\nFinal message for automatic allelic bounds..." << endl;
                            cout << "For all loci of the data file, the sequence of the number of possible states per locus" << endl;
                            cout << "is the following (you can use it in the settings file to avoid previous messages):" << endl;
                            cout << "AllelicBounds =";
                            for (int i=0;i<nloci-1;i++) cout << " " << sequenceGivenK[i] << ",";
                            cout << " " << sequenceGivenK[nloci-1] << endl;
                            cout << "\nStepsizes were also check and recomputed to fit the data :" << endl;
                            cout << "StepSizes =";
                            for (int i=0;i<nloci-1;i++) cout << " " << finalSMMstepSizes[i] << ",";
                            cout << " " << finalSMMstepSizes[nloci-1] << endl << endl << endl;
                        }

                    }

                }
            }
            if((locptr->locus) == nloci) alleleNbrChecked=true;
            allit=0;
			//boucle sur alleles sampled or not
			for (vector<int>::iterator jt=(*it).begin();jt!=(*it).end();jt++) {
				//cout<<"ICI "<<(*jt);

				//for SMM the above loop goes also over all alleles present or not
				//but not from Effectif as it does not have the same length than locptr->alleleCounts
				//all sizes are then adjusted for relative allele size according to what is donne when reading the adhoc format
				//state=locptr->alleleIndices[allit];
				//alleleIndex= (int) floor(locAlleleNbr/2) + state; //RL : a modifier, voir comment prendre les bornes (StatesNumber=givenK) en compte (sym / allele moyen?)
				if((*jt)>0) {//RL : necessaire car les classes vides n'ont pas d'indice coh['e]rent.
#ifdef DEBUG
					if(DebugGpSample) {
						cout << "locptr->alleleIndices[allit=" << allit << "]=" << locptr->alleleIndices[allit] << "; locAlleleNbr=" << locAlleleNbr << "; maxAll=" << maxAll << ", minAll=" << minAll << "; locstepsize=" << locstepsize <<  endl;
						cout << "(*jt)=alleleCounts[pop]=" << (*jt) << endl;
					}
#endif
					alleleIndex=(locAlleleNbr- (maxAll + minAll)/locstepsize)/2;
#ifdef DEBUG
					if(DebugGpSample) {
						cout << "alleleIndex=(locAlleleNbr- (maxAll + minAll)/locstepsize)/2;=" << alleleIndex << endl;
					}
#endif

					alleleIndex+=locptr->alleleIndices[allit]/locstepsize;// pour etre au milieu des bornes; comme avec les fichiers adhoc
					//alleleIndex=locptr->alleleIndices[allit]-minAll + (int) floor((locAlleleNbr - maxAll + minAll)/2);// pour etre au milieu des bornes; comme avec les fichiers adhoc
#ifdef DEBUG
					if(DebugGpSample) {
						cout << "alleleIndex(+=locptr->alleleIndices[allit]/locstepsize=" << locptr->alleleIndices[allit]/locstepsize << ")=" << alleleIndex << endl;
					}
#endif
					if(alleleIndex<0) {
						cerr << "(!) problem in GetSample(CProcessedLocus*,int) : A locus has more alleles than the number of possible alleles specified in the settings file." << endl;
                        cerr << "Locus : " << locptr->locus << endl;
                        cerr << "Alleleindex : " << alleleIndex << endl;
                        cerr << "locAlleleNbr : " << locAlleleNbr << endl;
                        cerr << "locstepsize : " << locstepsize << "; minAll=" << minAll << " and maxAll=" << maxAll << endl;
						cerr << "(!) I exit." << endl;
						if (cinGetOnError) cin.get();
						exit(-1);
					}
					Effectif[ligne][alleleIndex]+=(*jt);
					StateEffectif[alleleIndex]+=(*jt);
					PopEffectif[ligne]+=(*jt);
#ifdef DEBUG
					if(DebugGpSample) {
						cout << "effectif[" << ligne << "][" << alleleIndex << "]=" << Effectif[ligne][alleleIndex] << endl;
						cout << "StateEffectif[" << alleleIndex << "]=" << StateEffectif[alleleIndex] << endl << endl;
					}
#endif
				}
				allit++; //IMP: runs from 0 to K-1, exits with value K
			}


		}//end SMM or GSM

    		if(PopEffectif[ligne]>0){
			Size+=PopEffectif[ligne];
			pos_last_subsample=ligne;
		}
		if (ligne>0 && Effectif[ligne].size()!=Effectif[ligne-1].size()) {
					cerr << "(!) problem in GetSample(CProcessedLocus*,int) : all pops do not have the same number of possible allelic states (nbr of columns)..." << endl;
					cerr << "(!) I exit." << endl;
					if (cinGetOnError) cin.get();
					exit(-1);
        }
        ligne++;
    } // end loop on iterator

    if (pos_last_subsample==-1) {
		cout << "(!) problem in GetSample(CProcessedLocus*,int): no positive PopEffectif[ligne]" << endl;
		cout << "(!) I exit." << endl;
		if (cinGetOnError) cin.get();
		exit(-1);
    }
    // ici on a fini de traduire les fichiers ad hoc ou les processedLoci.
    /** on g[`e]re quelques autres variables:
        GeoSpan, PopSampledOrNot, le linear solver, le nb d'alleles du modele mut
    */

    {	int ii=0;
    	while(ii<pos_last_subsample && PopEffectif[ii]==0) ii++;
        GeoSpan=pos_last_subsample-ii;
    //    cout<<ii<<" "<<pos_last_subsample<<" "<< GeoSpan;getchar();
    }

    PopSampledOrNot=ligne; //should be alleleCounts.size ?!

    /** determines Sam_AlleleNbr for mutation model */
    if ((mutationModel == "PIM") || (mutationModel == "ISM") || (mutationModel == "SNP")) {
       if (allowsEmptyColumns || sequenceGivenK.size()>0) { // null counts allowed...
          Sam_AlleleNbr= (int) StateEffectif.size();//CM->RL 23.01.14
       } else { // null counts not allowed: we check there are none.
			int nullcounts= (int) count(StateEffectif.begin(),StateEffectif.end(),0);//CM->RL 23.01.14
			if (nullcounts>0) { // may be due to using are_dg files rather than re_dg files...
    	        cerr<<"From CSample::GetSample(CProcessedLocus*,int): specified allele has null total count.";
    	        cerr<<"This is not yet handled.";
    	        if (cinGetOnError) cin.get();
    	        exit(-1);
			} else Sam_AlleleNbr= (int) StateEffectif.size();//CM->RL 23.01.14
        }
    } else {
        Sam_AlleleNbr=locAlleleNbr; //In SMM GetSample is called with locAlleleNbr=GivenK
    }

    nZero.assign(PopSampledOrNot, 0);
return(0);
}

int CSample::AddSample(vector<CProcessedLocus>::iterator PLptr) {// adds back (ancestral) CSample into a preallocated CProcessedLocus
// this must be followed by a GetSample()

int intposInPL;
vector<int>::iterator pos;
//CProcessedLocus *PLptr=&(ProcessedLoci[locus-1]);
vector<int> *PLall=&(PLptr->alleleIndices);
vector<vector<int> > *PLcount=&(PLptr->alleleCounts);

if (Effectif.size()!=PLcount->size()) {
   cerr<<"(!) From AddSample(): the two tables have different numbers of rows";
   cerr<<"("<<Effectif.size()<<" vs "<<PLptr->alleleCounts.size()<<").";
   if (cinGetOnError) cin.get();
   exit(-1);
}

//adds counts from a CSample to a processedLocus.
    stringstream stst;
    stst<<"AddSample("<<PLptr->fileName<<")";
    PLptr->fileName=stst.str();
    // iteration over CSample content
    for (unsigned int CSit=0;CSit<alleleIndices.size();CSit++) {
        // seeks whether allele in CSample is in ProcessedLocus
        if ((pos=find(PLall->begin(),PLall->end(),alleleIndices[CSit]))==PLall->end()) { //new allele
            for (unsigned int popit=0;popit<Effectif.size();popit++) {
                //appends one column
                ((*PLcount)[popit]).push_back(Effectif[popit][CSit]);
                PLall->push_back(alleleIndices[CSit]);
            }
        } else { // preexisting allele
            intposInPL= (int)  ( pos - ( PLall->begin()) ); // RL->FR code un peu bizarre avec les iterateurs transformés en int ...the column in CProcessedLocus as integer indice
            for (unsigned int popit=0;popit<Effectif.size();popit++) {
                //adds content of columns
                (*PLcount)[popit][intposInPL]+=Effectif[popit][CSit];
            }
        }
    }
return 0;
}


int CSampleWout::new_L_etc() {
// dynamic arrays NOT members of CSample
#ifdef BUG_NOT_MINE
	D_.resize(PopSampledOrNot);
	v_.resize(PopSampledOrNot);
	L_.resize(PopSampledOrNot);
	for (int i=0; i<PopSampledOrNot; i++) {L_[i].resize(PopSampledOrNot);}
    bvec.resize(PopSampledOrNot);
    PIs.resize(Sam_AlleleNbr);
	altPIs.resize(Sam_AlleleNbr);
    for (int i=0; i<Sam_AlleleNbr; i++) {PIs[i].resize(PopSampledOrNot);altPIs[i].resize(PopSampledOrNot);}
    Mmat.resize(PopSampledOrNot);
    for (int i=0;i<PopSampledOrNot;i++) Mmat[i].resize(PopSampledOrNot);
#else
	D_ =new picalctype[PopSampledOrNot];
	v_=new picalctype[PopSampledOrNot];
	L_=new picalctype*[PopSampledOrNot];
	for (int i=0; i<PopSampledOrNot; i++) {L_[i]=new picalctype[PopSampledOrNot];}
    bvec=new pirestype[PopSampledOrNot];
    PIs=new pirestype*[Sam_AlleleNbr];
	altPIs=new pirestype*[Sam_AlleleNbr];
    for (int i=0; i<Sam_AlleleNbr; i++) {PIs[i]=new pirestype[PopSampledOrNot];altPIs[i]=new pirestype[PopSampledOrNot];}
    Mmat=new picalctype*[PopSampledOrNot];
    for (int i=0;i<PopSampledOrNot;i++) Mmat[i]=new picalctype[PopSampledOrNot];
#endif

return 0;
}

int CSampleWithGolub::new_L_etc() {
// dynamic arrays NOT members of CSample
#ifdef BUG_NOT_MINE
	D_.resize(PopSampledOrNot);
	v_.resize(PopSampledOrNot);
	L_.resize(PopSampledOrNot);
	for (int i=0; i<PopSampledOrNot; i++) {L_[i].resize(PopSampledOrNot);}
    bvec.resize(PopSampledOrNot);
    PIs.resize(Sam_AlleleNbr);
	altPIs.resize(Sam_AlleleNbr);
    for (int i=0; i<Sam_AlleleNbr; i++) {PIs[i].resize(PopSampledOrNot);altPIs[i].resize(PopSampledOrNot);}
    Mmat.resize(PopSampledOrNot);
    for (int i=0;i<PopSampledOrNot;i++) Mmat[i].resize(PopSampledOrNot);
#else
	D_ =new picalctype[PopSampledOrNot];
	v_=new picalctype[PopSampledOrNot];
	L_=new picalctype*[PopSampledOrNot];
	for (int i=0; i<PopSampledOrNot; i++) {L_[i]=new picalctype[PopSampledOrNot];}
    bvec=new pirestype[PopSampledOrNot];
    PIs=new pirestype*[Sam_AlleleNbr];
	altPIs=new pirestype*[Sam_AlleleNbr];
    for (int i=0; i<Sam_AlleleNbr; i++) {PIs[i]=new pirestype[PopSampledOrNot];altPIs[i]=new pirestype[PopSampledOrNot];}
    Mmat=new picalctype*[PopSampledOrNot];
    for (int i=0;i<PopSampledOrNot;i++) Mmat[i]=new picalctype[PopSampledOrNot];
#endif
	D_A=new picalctype[PopSampledOrNot]; //Diagonal de la matrice A
	D_M=new picalctype[PopSampledOrNot]; //Diagonale dans M=LDL' (pentadiag algo) ou autre diag
	ligne=new picalctype[PopSampledOrNot];
	gamma=new picalctype[PopSampledOrNot-1];
	delta=new picalctype[PopSampledOrNot-2];
	Golubx=new picalctype[PopSampledOrNot];
	Golubz=new picalctype[PopSampledOrNot];
	Golubr=new picalctype[PopSampledOrNot];
	Golubp=new picalctype[PopSampledOrNot];
	GolubAp=new picalctype[PopSampledOrNot];
	haut=new int[PopSampledOrNot];
	bas=new int[PopSampledOrNot];



return 0;
} //fin new_L_etc()

int CSampleWout::delete_L_etc() {
// dynamic arrays NOT members of CSample
#ifdef BUG_NOT_MINE
	D_.resize(0);
	v_.resize(0);
	L_.resize(0);
    bvec.resize(0);
    PIs.resize(0);
	altPIs.resize(0);
    Mmat.resize(0);
#else
    for (int i=0;i<PopSampledOrNot;i++) delete[] Mmat[i];
    delete[] Mmat;
	for (int i=0; i<PopSampledOrNot; i++) delete[] L_[i];
	delete[] L_;
	delete[] v_;
    delete[] D_;
    delete[] bvec;
    for (int i=0; i<Sam_AlleleNbr; i++) delete[] PIs[i];
    delete[] PIs;
	for (int i=0; i<Sam_AlleleNbr; i++) delete[] altPIs[i];
    delete[] altPIs;
#endif
return 0;
}

int CSampleWithGolub::delete_L_etc() {
// dynamic arrays NOT members of CSample
#ifdef BUG_NOT_MINE
	D_.resize(0);
	v_.resize(0);
	L_.resize(0);
    bvec.resize(0);
    PIs.resize(0);
	altPIs.resize(0);
    Mmat.resize(0);
#else
    for (int i=0;i<PopSampledOrNot;i++) delete[] Mmat[i];
    delete[] Mmat;
	for (int i=0; i<PopSampledOrNot; i++) delete[] L_[i];
	delete[] L_;
	delete[] v_;
    delete[] D_;
    delete[] bvec;
    for (int i=0; i<Sam_AlleleNbr; i++) delete[] PIs[i];
    delete[] PIs;
	for (int i=0; i<Sam_AlleleNbr; i++) delete[] altPIs[i];
    delete[] altPIs;
#endif
	delete[] D_A;
    delete[] D_M;
    delete[] ligne;
    delete[] gamma;
    delete[] delta;
    delete[] Golubx;
    delete[] Golubz;
    delete[] Golubr;
    delete[] Golubp;
    delete[] GolubAp;
    delete[] haut;
    delete[] bas;
return 0;
}


int CSample::Print(){
cout << "Sample :" << endl;
if(Sam_AlleleNbr<30) {
	for(int a=0;a<PopSampledOrNot;a++){
		cout << "pop:" << a << endl;
		ostream_vector(Effectif[a],cout);
		cout << ":" << PopEffectif[a] << endl;
	}
} else {
	for(int a=0;a<PopSampledOrNot;a++){
		cout << "pop:" << a ;
		for(int j=0;j<Sam_AlleleNbr;j++)
			if(Effectif[a][j]>0) cout << "(" <<j << " : " << Effectif[a][j] << ") " ;
		cout << "totalpop:" << PopEffectif[a] << endl;
		}
	}
//cout << endl;
return 0;
}

void CSample::PrintSeq() {
	cout << "CurrentSample->mutPathMatrix = \n";
	for (size_t i = 0; i < mutPathMatrix.size(); i++) {
		for (size_t j = 0; j < mutPathMatrix[i].size(); j++) {
			cout << mutPathMatrix[i][j] << " ";
			if (mutPathMatrix[i][j] == 0)
				break;
		}
		cout << "\n";
	}
	cout << "CurrentSample->siteMutCountVec = \n";
	for (size_t j = 0; j < siteMutCountVec.size(); j++)
		cout << siteMutCountVec[j] << " ";
	cout << "\n";
	if (HobolthISM) {
		cout << "CurrentSample->DmVec = \n";
		for (size_t j = 0; j < DmVec.size(); j++)
			cout << DmVec[j] << " ";
		cout << "\n";
	}
	cout << "\n";
}

//RL : ajout necessaire pour SMM
//ajuste le plus petit et le plus grand allele represente dans l'echantillon pour SMM
int CSample::GetAllelicRange(int flag){
int min,max;

min=Sam_AlleleNbr;
max=-1;
for(int a=0;a<PopSampledOrNot;a++) {
	if(flag==0) for(size_t i=0,found=0; i<Effectif[a].size() && found==0; i++){
	if(Effectif[a][i]>0) {
		if(min > (int) i) min= (int) i;//CM->RL 23.01.14
		found=1;
		break;
		}
	}
	if(flag==1) for(size_t i=(Effectif[a].size() - 1),found=0; found==0; i--) {
	if(Effectif[a][i]>0) {
		if(max < (int) i) max= (int) i;//CM->RL 23.01.14
		found=1;
		break;
		}
	}
}

if(flag==0) AllelicRange[0]=min;
if(flag==1) AllelicRange[1]=max;

//Print();
//cout << AllelicRange[0] << " : " << AllelicRange[1] << endl;

//cin.get();

#ifdef DEBUG
if(AllelicRange[0]<0 || AllelicRange[1]>Sam_AlleleNbr)
    cout << "Problem in SMM state Number :  min=" << AllelicRange[0] << " and max=" << AllelicRange[1] << endl;
#endif

return 0;
}

scaledTimeType ExpIntensityCDF(cumultype random, const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut) {

    cumultype PopSizeRatio;
    scaledTimeType temp,result,TimeFactor;

    if(mutationModel=="SNP"){
        if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG;
        else PopSizeRatio=Mut->AncThetaDIG;
    } else {
        if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG/Mut->ThetaDIG;
        else PopSizeRatio=Mut->AncThetaDIG/Mut->ThetaDIG;
    }

    if(!PopSizeScaleForTimebool) TimeFactor=1/Mut->ThetaDIG;// to get the time in unit of Tg/2Ngenes from values in unit of µ (To be checked RL 032009)
     else TimeFactor=1;

#ifdef DEBUG
if(DebugBisection) {
    cout << "\n\t\tExpIntensityCDF->random=" << random << endl;
    cout << "\t\tExpIntensityCDF->SampleSize=" << SampleSize << endl;
    cout << "\t\tExpIntensityCDF->current time*TimeFactor=" << currentTime << endl;
	cout << "\t\tExpIntensityCDF->current time=" << currentTime/TimeFactor << endl;
    cout << "\t\tExpIntensityCDF->previousTime*TimeFactor=" << previousTime << endl;
	cout << "\t\tExpIntensityCDF->previousTime=" << previousTime/TimeFactor << endl;
	cout << "\t\tExpIntensityCDF->Mig->PrevChangeTime*TimeFactor=" << Mig->PrevChangeTime*TimeFactor << endl;
	cout << "\t\tExpIntensityCDF->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
    cout << "\t\tExpIntensityCDF->Mig->MinChangeTime*TimeFactor=" << Mig->MinChangeTime*TimeFactor << endl;
	cout << "\t\tExpIntensityCDF->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
    if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpIntensityCDF->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
    cout << "\t\tExpIntensityCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
    cout << "\t\tExpIntensityCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
	cout << "\t\tExpIntensityCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
    cout << "\t\tExpIntensityCDF->PopSizeRatio=" << PopSizeRatio << endl;
    fflush(stdout);

}
#endif
if(pow((long double)(PopSizeRatio),(currentTime-Mig->PrevChangeTime*TimeFactor)/(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor))>=numeric_limits<cumultype>::max()) return(1.0-random);
else {
    temp=(SampleSize-1.0)*(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor)*(pow((long double)(PopSizeRatio),(currentTime-Mig->PrevChangeTime*TimeFactor)/(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor))

                                              -pow((long double)(PopSizeRatio),(previousTime-Mig->PrevChangeTime*TimeFactor)/(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor)));
    if(temp>=numeric_limits<cumultype>::max() || std::isnan(temp)) return(1.0-random);
    temp+=pow((long double)(PopSizeRatio),(currentTime+previousTime-2*Mig->PrevChangeTime*TimeFactor)/(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor))*(currentTime-previousTime)*(Mig->Ma[0]+Mut->ThetaDIG)*log(PopSizeRatio);
    if(temp>=numeric_limits<cumultype>::max() || std::isnan(temp)) return(1.0-random);//cout << "log(PopSizeRatio)=" << log(PopSizeRatio) << endl;
    //if(temp>=numeric_limits<cumultype>::max() || std::isnan(temp)) cout << "temp2=" << temp << endl;
    temp*=SampleSize*pow((long double)(PopSizeRatio),-(currentTime+previousTime-2*Mig->PrevChangeTime*TimeFactor)/(Mig->MinChangeTime*TimeFactor-Mig->PrevChangeTime*TimeFactor))/log(PopSizeRatio);
    if(temp>=numeric_limits<scaledTimeType>::max() || std::isnan(temp)) {
        cout << "\t\tExpIntensityCDF->temp is NaN or > numeric_limits<cumultype>::max()" << endl;
        cout << "\t\tExpIntensityCDF() returns 1.0 - random = " << 1.0-random << endl;
        return(1.0-random);
    }
}
result=(scaledTimeType) 1.0-exp(-temp)-random;
if(fabs(result)<numeric_limits<scaledTimeType>::epsilon()) result=numeric_limits<scaledTimeType>::epsilon();
#ifdef DEBUG
if(DebugBisection) {
    cout << "\t\tExpIntensityCDF->temp=" << temp << endl;
    cout << "\t\tExpIntensityCDF->1.0-exp(-temp)=" << 1.0-exp(-temp) << endl;
    cout << "\t\tExpIntensityCDF->return(1.0-exp(-temp)-random)=" << result << endl;
}
#endif
if(std::isnan(result) || (fabs(result)<numeric_limits<scaledTimeType>::epsilon() && 1.0-exp(-temp)!=random)) {
    cout << "\n\t\tExpIntensityCDF->numeric_limits<scaledTimeType>::epsilon()=" << numeric_limits<scaledTimeType>::epsilon() << endl;
	cout << "\t\tExpIntensityCDF->random=" << random << endl;
    cout << "\t\tExpIntensityCDF->SampleSize=" << SampleSize << endl;
    cout << "\t\tExpIntensityCDF->current time*TimeFactor=" << currentTime << endl;
	cout << "\t\tExpIntensityCDF->current time=" << currentTime/TimeFactor << endl;
	cout << "\t\tExpIntensityCDF->previousTime*TimeFactor=" << previousTime << endl;
    cout << "\t\tExpIntensityCDF->previousTime=" << previousTime/TimeFactor << endl;
    if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpIntensityCDF->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
    cout << "\t\tExpIntensityCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
    cout << "\t\tExpIntensityCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
	cout << "\t\tExpIntensityCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
    cout << "\t\tExpIntensityCDF->PopSizeRatio=" << PopSizeRatio << endl;
    cout << "\t\tExpIntensityCDF->temp=" << temp << endl;
    cout << "\t\tExpIntensityCDF->return(1.0-exp(-temp)-random)=result=" << result << endl;
    fflush(stdout);
    //if (cinGetOnError) cin.get();
}
    return(result);
}

scaledTimeType ExpIntensityCDF2(cumultype random, const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut) {

    cumultype PopSizeRatio;
    scaledTimeType temp,result,term1,term2,TimeFactor;

    if(mutationModel=="SNP"){
        if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG;
        else PopSizeRatio=Mut->AncThetaDIG;
    } else {
            if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG/Mut->ThetaDIG;
            else PopSizeRatio=Mut->AncThetaDIG/Mut->ThetaDIG;
        }

    if(!PopSizeScaleForTimebool) TimeFactor=1/Mut->ThetaDIG;// to get the time in unit of Tg/2Ngenes from values in unit of 2µ (To be checked RL 032009)
     else TimeFactor=1;

#ifdef DEBUG
	if(DebugPopVarSize && false) {
		cout << "\n\t\tExpIntensityCDF2->random=" << random << endl;
		cout << "\t\tExpIntensityCDF2->SampleSize=" << SampleSize << endl;
		cout << "\t\tExpIntensityCDF2->current time*TimeFactor=" << currentTime << endl;
		cout << "\t\tExpIntensityCDF2->current time=" << currentTime/TimeFactor << endl;
		cout << "\t\tExpIntensityCDF2->previousTime*TimeFactor=" << previousTime << endl;
		cout << "\t\tExpIntensityCDF2->previousTime=" << previousTime/TimeFactor << endl;
		cout << "\t\tExpIntensityCDF2->Mig->PrevChangeTime*TimeFactor=" << Mig->PrevChangeTime*TimeFactor << endl;
		cout << "\t\tExpIntensityCDF2->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tExpIntensityCDF2->Mig->MinChangeTime*TimeFactor=" << Mig->MinChangeTime*TimeFactor << endl;
		cout << "\t\tExpIntensityCDF2->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
        if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpIntensityCDF2->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tExpIntensityCDF2->PopSizeRatio=" << PopSizeRatio << endl;
		fflush(stdout);

	}
#endif
	term1=(pow((long double)(PopSizeRatio),(previousTime-Mig->PrevChangeTime*TimeFactor)/TimeFactor/(Mig->MinChangeTime-Mig->PrevChangeTime))
		   -pow((long double)(PopSizeRatio),(currentTime-Mig->PrevChangeTime*TimeFactor)/TimeFactor/(Mig->MinChangeTime-Mig->PrevChangeTime)));
	if( term1>=numeric_limits<cumultype>::max() || std::isnan(term1)) {
		cout << "\t\tExpIntensityCDF2->term1 is NaN or > numeric_limits<cumultype>::max()=" << term1 << endl;
		cout << "\t\tExpIntensityCDF2() returns 1.0 - random = " << 1.0-random << endl;
		return(1.0-random);

	} else {
		term2=term1*SampleSize*(SampleSize-1.0)*(Mig->MinChangeTime-Mig->PrevChangeTime)*TimeFactor;
		if(term2>=numeric_limits<cumultype>::max() || std::isnan(term2)) {
			cout << "\t\tExpIntensityCDF2->term2 is NaN or > numeric_limits<cumultype>::max()" << term2 << endl;
			cout << "\t\tExpIntensityCDF2() returns 1.0 - random = " << 1.0-random << endl;
			return(1.0-random);
		} else temp=term2*pow((long double)(PopSizeRatio),-(currentTime+previousTime-2*Mig->PrevChangeTime*TimeFactor)/TimeFactor/(Mig->MinChangeTime-Mig->PrevChangeTime))/log(PopSizeRatio);
		if(temp>=numeric_limits<scaledTimeType>::max() || std::isnan(temp)) {
			cout << "\t\tExpIntensityCDF2->temp is NaN or > numeric_limits<cumultype>::max()" << endl;
			cout << "\t\tExpIntensityCDF2->term1=" << term1 << endl;
			cout << "\t\tExpIntensityCDF2->term2=" << term2 << endl;
			cout << "\t\tExpIntensityCDF2->temp=" << temp << endl;
			cout << "\t\tExpIntensityCDF2() returns 1.0 - random = " << 1.0-random << endl;
			return(1.0-random);
		}
	}
	result=1.0-exp(temp)-random;
	if(fabs(result)<numeric_limits<scaledTimeType>::epsilon()) result=numeric_limits<scaledTimeType>::epsilon();
#ifdef DEBUG
	if(DebugPopVarSize && false) {
		cout << "\t\tExpIntensityCDF2->term1=" << term1 << endl;
		cout << "\t\tExpIntensityCDF2->term2=" << term2 << endl;
		cout << "\t\tExpIntensityCDF2->temp=" << temp << endl;
		cout << "\t\tExpIntensityCDF2->1.0-exp(temp)=" << 1.0-exp(temp) << endl;
		cout << "\t\tExpIntensityCDF2->return(1.0-exp(temp)-random)=" << result << endl;
	}
#endif
	if(std::isnan(result) || (fabs(result)<numeric_limits<scaledTimeType>::epsilon() && 1.0-exp(temp)!=random)) {
		cout << "\n\t\tExpIntensityCDF2->random=" << random << endl;
		cout << "\t\tExpIntensityCDF2->SampleSize=" << SampleSize << endl;
		cout << "\t\tExpIntensityCDF2->current time*TimeFactor=" << currentTime << endl;
		cout << "\t\tExpIntensityCDF2->current time=" << currentTime/TimeFactor << endl;
		cout << "\t\tExpIntensityCDF2->previousTime*TimeFactor=" << previousTime << endl;
		cout << "\t\tExpIntensityCDF2->previousTime=" << previousTime/TimeFactor << endl;
        if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpIntensityCDF2->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tExpIntensityCDF2->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tExpIntensityCDF2->PopSizeRatio=" << PopSizeRatio << endl;
		cout << "\t\tExpIntensityCDF2->temp=" << temp << endl;
		cout << "\t\tExpIntensityCDF2->return(1.0-exp(temp)-random)=" << result << endl;
		fflush(stdout);
		//if (cinGetOnError) cin.get();
	}
    return(result);
}


scaledTimeType ExpInverseIntensityCDF(cumultype random, const int SampleSize,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut) {

    cumultype PopSizeRatio;
    scaledTimeType temp,term1,term2,term3,term4,term41,term42,term5,result,TimeFactor;

    if(mutationModel=="SNP"){
        if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG;
        else PopSizeRatio=Mut->AncThetaDIG;
    } else {
        if(DemographicModel=="OnePopFounderFlush") PopSizeRatio=Mut->FounderThetaDIG/Mut->ThetaDIG;
        else PopSizeRatio=Mut->AncThetaDIG/Mut->ThetaDIG;
    }

    if(!PopSizeScaleForTimebool) TimeFactor=1/Mut->ThetaDIG;// to get the time in unit of Tg/2Ngenes from values in unit of 2µ (To be checked RL 032009)
     else TimeFactor=1;

	scaledTimeType VarSizeDuration=(Mig->MinChangeTime-Mig->PrevChangeTime)*TimeFactor;
	scaledTimeType RelativePrevioustime=previousTime-Mig->PrevChangeTime*TimeFactor;
#ifdef DEBUG
	if(DebugPopVarSize && false) {
		cout << "\n\t\tExpInvCDF->random=" << random << endl;
		cout << "\n\t\tExpInvCDF->TimeFactor=" << TimeFactor << endl;
		cout << "\t\tExpInvCDF->SampleSize=" << SampleSize << endl;
		cout << "\t\tExpInvCDF->previousTime*TimeFactor=" << previousTime << endl;
		cout << "\t\tExpInvCDF->previousTime=" << previousTime/TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->PrevChangeTime*TimeFactor=" << Mig->PrevChangeTime*TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tExpInvCDF->Mig->MinChangeTime*TimeFactor=" << Mig->MinChangeTime*TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
		cout << "\t\tExpInvCDF->Mig->VarSizeDuration*TimeFactor=" << VarSizeDuration << endl;
		cout << "\t\tExpInvCDF->Mig->VarSizeDuration=" << VarSizeDuration/TimeFactor << endl;
        if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpInvCDF->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tExpInvCDF->PopSizeRatio=" << PopSizeRatio << endl;
		fflush(stdout);

	}
#endif
	term1=pow((long double)(PopSizeRatio),RelativePrevioustime/VarSizeDuration);
	term2=log(1.-random);
	term3=log(PopSizeRatio);
	term41=term1*term2*term3;
	term42=VarSizeDuration*(SampleSize*(SampleSize-1.0));
	term4=1+(term1*term2*term3)/term42;
	term5=log(term4);
	if(std::isnan(term1) || term1>=numeric_limits<scaledTimeType>::max()) {
		cout << "\t\tExpInvCDF (pow(PopSizeRatio,PrevTime/T)) is infinity or NaN :" << term1 << endl;
		cout << "\t\tExpInvCDF -> PopSizeRatio=" << PopSizeRatio << endl;
		cout << "\t\tExpInvCDF -> RelativePrevioustime=" << RelativePrevioustime << endl;
		cout << "\t\tExpInvCDF -> VarSizeDuration=" << VarSizeDuration << endl;
		cout << "\t\tExpInvCDF returns (1.0-random)=" << (1.0-random) << endl;
		if(cinGetOnError) {
			cin.get();
			exit(-1);
		}
		return(1.0-random);
	} else if(std::isnan(term2) || fabs(term2)>=numeric_limits<scaledTimeType>::max()) {
		cout << "\t\tExpInvCDF result is infinity (log(1-random))" << endl;
		if(cinGetOnError) {
			cin.get();
			exit(-1);
		}
		return(1.0-random);
	} else {
		temp=VarSizeDuration*term5/log(PopSizeRatio);
	}
	result=previousTime-temp;//minus because we invert the term 4 inside the ln() compared to mathematica computations
#ifdef DEBUG
	if(DebugPopVarSize && false) {
		cout << "\t\tExpInvCDF->term1=" << term1 << endl;
		cout << "\t\tExpInvCDF->term2=" << term2 << endl;
		cout << "\t\tExpInvCDF->term3=" << term3 << endl;
		cout << "\t\tExpInvCDF->term41=" << term41 << endl;
		cout << "\t\tExpInvCDF->term42=" << term42 << endl;
		cout << "\t\tExpInvCDF->term4=" << term4 << endl;
		cout << "\t\tExpInvCDF->term5=" << term5 << endl;
		cout << "\t\tExpInvCDF->temp=" << temp << endl;
		cout << "\t\tExpInvCDF->result=previousTime-temp=" << result << endl;
	}
#endif
	if(std::isnan(result) || fabs(result)<numeric_limits<cumultype>::epsilon()) {
		cout << "std::isnan(result)=" << std::isnan(result) << endl;
		cout << "fabs(result)=" << fabs(result) << endl;
		cout << "numeric_limits<cumultype>::epsilon()=" << numeric_limits<cumultype>::epsilon() << endl;
		cout << "\n\t\tExpInvCDF->random=" << random << endl;
		cout << "\n\t\tExpInvCDF->TimeFactor=" << TimeFactor << endl;
		cout << "\t\tExpInvCDF->SampleSize=" << SampleSize << endl;
		cout << "\t\tExpInvCDF->previousTime*TimeFactor=" << previousTime << endl;
		cout << "\t\tExpInvCDF->previousTime=" << previousTime/TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->PrevChangeTime*TimeFactor=" << Mig->PrevChangeTime*TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tExpInvCDF->Mig->MinChangeTime*TimeFactor=" << Mig->MinChangeTime*TimeFactor << endl;
		cout << "\t\tExpInvCDF->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
		cout << "\t\tExpInvCDF->Mig->VarSizeDuration*TimeFactor=" << VarSizeDuration << endl;
		cout << "\t\tExpInvCDF->Mig->VarSizeDuration=" << VarSizeDuration/TimeFactor << endl;
        if(DemographicModel=="OnePopFounderFlush")     cout << "\t\tExpInvCDF->Mut->FounderThetaDIG=" << Mut->FounderThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tExpInvCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tExpInvCDF->PopSizeRatio=" << PopSizeRatio << endl;
		cout << "\t\tExpInvCDF->term1=" << term1 << endl;
		cout << "\t\tExpInvCDF->term2=" << term2 << endl;
		cout << "\t\tExpInvCDF->term3=" << term3 << endl;
		cout << "\t\tExpInvCDF->term41=" << term41 << endl;
		cout << "\t\tExpInvCDF->term42=" << term42 << endl;
		cout << "\t\tExpInvCDF->term4=" << term4 << endl;
		cout << "\t\tExpInvCDF->term5=" << term5 << endl;
		cout << "\t\tExpInvCDF->temp=" << temp << endl;
		cout << "\t\tExpInvCDF->result=previousTime-temp=" << result << endl;
		fflush(stdout);
		if (cinGetOnError) cin.get();
	}
    return(result);
}



scaledTimeType LogisticIntensityCDF(cumultype random, const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut) {

    cumultype PopSizeRatio;
	scaledTimeType temp,result;

    if(mutationModel=="SNP") PopSizeRatio=Mut->AncThetaDIG; else PopSizeRatio=Mut->AncThetaDIG/Mut->ThetaDIG;


#ifdef DEBUG
	if(DebugBisection) {
		cout.precision(20);
		cout << "\n\t\tLogisticIntensityCDF->random=" << random << endl;
		cout << "\t\tLogisticIntensityCDF->SampleSize=" << SampleSize << endl;
		cout << "\t\tLogisticIntensityCDF->current time=" << currentTime << endl;
		cout << "\t\tLogisticIntensityCDF->previousTime=" << previousTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->LogisticGrowthRate=" << Mig->LogisticGrowthRate << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tLogisticIntensityCDF->PopSizeRatio=" << PopSizeRatio << endl;
		fflush(stdout);

	}
#endif
	temp=(exp(- Mig->LogisticGrowthRate*(currentTime-Mig->PrevChangeTime))-exp(- Mig->LogisticGrowthRate*(previousTime-Mig->PrevChangeTime)))*(SampleSize-1.0)*(PopSizeRatio-1)/Mig->LogisticGrowthRate;
	if(temp>=numeric_limits<cumultype>::max() || std::isnan(temp)) {
#ifdef DEBUG
		cout << "\t\ttemp1=" << temp << endl;
		if(cinGetOnError) cin.get();
#endif
		return(1.0-random);
	}
	temp+=-(currentTime-previousTime)*(SampleSize-1.0+PopSizeRatio*(Mig->Ma[0]+Mut->ThetaDIG));
	temp*=SampleSize/PopSizeRatio;
#ifdef DEBUG
	if(DebugBisection) cout << "\t\ttemp before exp()=" << temp << endl;
#endif
	if(temp>=numeric_limits<scaledTimeType>::max() || std::isnan(temp)) {

		cout << "\n\t\ttemp>=numeric_limits<scaledTimeType>::max() || std::isnan(temp)" << endl;
		cout << "\n\t\tLogisticIntensityCDF->random=" << random << endl;
		cout << "\t\tLogisticIntensityCDF->SampleSize=" << SampleSize << endl;
		cout << "\t\tLogisticIntensityCDF->current time=" << currentTime << endl;
		cout << "\t\tLogisticIntensityCDF->previousTime=" << previousTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->LogisticGrowthRate=" << Mig->LogisticGrowthRate << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->MinChangeTime=" << Mig->MinChangeTime << endl;
		cout << "\t\tLogisticIntensityCDF->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tLogisticIntensityCDF->PopSizeRatio=" << PopSizeRatio << endl;
		cout << "\t\tLogisticIntensityCDF->temp is << epsilon() or NaN or > numeric_limits<cumultype>::max() =" << temp << endl;
		cout << "\t\tLogisticIntensityCDF->exp(temp)=" << exp(temp) << endl;
		cout << "\t\tLogisticIntensityCDF() returns 1.0 - random = " << 1.0-random << endl;
		//if(cinGetOnError) cin.get();

		return(1.0-random);
	}
	result=1.0-exp(temp)-random;
#ifdef DEBUG
	if(DebugBisection) {
		cout << "\t\tLogisticIntensityCDF Normal Ending->temp=" << temp << endl;
		cout << "\t\tLogisticIntensityCDF Normal Ending->1.0-exp(-temp)=" << 1.0-exp(-temp) << endl;
		cout << "\t\tLogisticIntensityCDF Normal Ending->return(1.0-exp(-temp)-random)=" << result << endl;
	}
	if((result>0.0 && currentTime==0.0) || (std::isnan(result) || (fabs(result)<numeric_limits<scaledTimeType>::epsilon() && 1.0-exp(-temp)!=random))) {
		cout << "\n\t\tLogisticIntensityCDF Problem->random=" << random << endl;
		cout << "\t\tLogisticIntensityCDF Problem->SampleSize=" << SampleSize << endl;
		cout << "\t\tLogisticIntensityCDF Problem->current time=" << currentTime << endl;
		cout << "\t\tLogisticIntensityCDF Problem->previousTime=" << previousTime << endl;
		cout << "\t\tLogisticIntensityCDF Problem->Mig->LogisticGrowthRate=" << Mig->LogisticGrowthRate << endl;
		cout << "\t\tLogisticIntensityCDF Problem->Mig->PrevChangeTime=" << Mig->PrevChangeTime << endl;
		cout << "\t\tLogisticIntensityCDF Problem->Mut->AncThetaDIG=" << Mut->AncThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF Problem-F->Mut->ThetaDIG=" << Mut->ThetaDIG << endl;
		cout << "\t\tLogisticIntensityCDF Problem->Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		cout << "\t\tLogisticIntensityCDF Problem->PopSizeRatio=" << PopSizeRatio << endl;
		cout << "\t\tLogisticIntensityCDF Problem->temp=" << temp << endl;
		cout << "\t\tLogisticIntensityCDF Problem->return(1.0-exp(-temp)-random)=" << result << endl;
		fflush(stdout);
		//if (cinGetOnError) cin.get();
	}
#endif
    return(result);
}


scaledTimeType bisection_search(scaledTimeType (*func)(cumultype random, const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut),cumultype random,const int SampleSize,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut,scaledTimeType x1,scaledTimeType x2) {
// Pour que (*func) puisse acceder des variables membres d'une classe
// il faut d['e]clarer (*func) comme une fonction friend
// et dans la-dite fonction il faut pouvoir affecter les membres [`a] une instantiation donn['e]e (eg instantiationPtr->membre)
// pour cela j'utilise un pointeur instantiationPtr vers cette instantiation, d['e]fini au niveau global
// ce ptr doit etre d['e]clar['e] apr[`e]s la lecture de Krig.h, il est donc d['e]clar['e] dans Krig.cpp
// et extern dans Krig.h
// on ne peut le mettre dans Krigmain.cpp/Krigmain.h car Krigmain.cpp -> Krig.h ->gr.h ->Krigmain.h
// et alors l'extern dans Krigmain.h serait lu avant la lecture de d['e]claration de classe dans Krig.h
// (NB qr.h pas tr[`e]s d['e]placable car la d['e]claration de classe dans Krig.h fait r['e]f [`a] la classe CQR).
// Et voila le pourquoi du ptr and Krig.cpp et des fonctions friend.
//
//R: function (x1, x2, f, tol = 1e-07, niter = 25, f.extra = NA, upcross.level = 0)
// rtbis, Numerical recipes
//Using bisection, find the root of a function func known to lie between x1 and x2. The root,
//returned as rtbis, will be refined until its accuracy is +/-xacc.
    const scaledTimeType xacc=0.000001*previousTime+numeric_limits<scaledTimeType>::epsilon()*(abs(x1)+abs(x2))/2;//numeric_limits<scaledTimeType>::epsilon()*(abs(x1)+abs(x2))/2; //suggestion Num. Rec.
    const int maxit=-2*int(log(numeric_limits<scaledTimeType>::epsilon())/log(2.));
    int j,compt;
    scaledTimeType dx,f,fmid,xmid,rtb;
    f=(*func)(random,SampleSize,x1,previousTime,Mig,Mut);

	if(f>=0) {
		cout << "Bisection search gives f(" << x1 << ")=" << f << endl;
		cout << "returning scaled_generation=" << previousTime << "+epsilon() instead" << endl;
		return(previousTime+numeric_limits<scaledTimeType>::epsilon());
	}
    fmid=(*func)(random,SampleSize,x2,previousTime,Mig,Mut);
	if(DebugBisection) {
	cout << "Bisection->accuracy=" << xacc << endl;
	cout << "Bisection->x1=" << x1 << " -> f=" << f << endl;
	cout << "Bisection->x2=" << x2 << " -> fmid=" << fmid << endl;
	//if(cinGetOnError) cin.get();
	}
    compt=0;
    while(f*fmid >= 0.0) {
        if(compt>9) {
            cout<<"\n\t(!) After " << compt << " iterations From bisection_search() :\n\tRoot must be bracketed for bisection. ";
            cout<<"\tf(" << x1 << ")= " << f << " and f(" << x2 << ")=" << fmid << endl;;
        }
        //if (cinGetOnError) cin.get();
        //exit(-1);
        x2*=10;
        fmid=(*func)(random,SampleSize,x2,previousTime,Mig,Mut);
        if(compt>9) cout<<"\tx2 was multiplied by 10 and f(" << x2 << ")=" << fmid  << endl;;
        compt++;
    }
	if(DebugBisection && compt>0) {
		cout << "Bisection->x2 is now=" << x2 << endl;
		cout << "Bisection->fmid is now=" << fmid << endl;
		//if(cinGetOnError) cin.get();
	}

    if(compt>10) cout << endl;
    rtb = f < 0.0 ? (dx=x2-x1,x1) : (dx=x1-x2,x2); //Orient the search so that f>0
/*std::cout<<x1<<" ";
std::cout<<x2<<" ";
std::cout<<dx<<" ";
std::cout<<rtb;getchar();*/
    for (j=1;j<=maxit;j++) { //lies at x+dx.
    fmid=(*func)(random,SampleSize,xmid=rtb+(dx *= 0.5),previousTime,Mig,Mut); //Bisection loop.
    if (fmid <= 0.0) rtb=xmid;
    if (fabs(dx) < xacc || fmid == 0.0) return rtb;
    }
    if (f*fmid >= 0.0) {
           cout<<"\t\t(!) From bisection_search() : Too many bisections without any result. I must exit. ";
           if (cinGetOnError) cin.get();
           exit(-1);
        }
return(numeric_limits<scaledTimeType>::signaling_NaN());
}

//choisi la pop et le type allelique sur lequel va jouer le changement
//RENVOIT les indices [a][i]
changetype CSample::ChoosePopType(int* p_a, int* p_i,CMigMod* Mig,CMutMod* Mut,bool firstPassbool){
//cout<<"debut CSample::ChoosePopType(int* p_a...)";getchar();
int mini,maxi;
scaledTimeType temp;
cumultype Denom=0.0,term1=0.0;
cumultype cumul=0.0,random,IntensityValue;
const parstype ThetaDIG=Mut->ThetaDIG;
const parstype AncThetaDIG=Mut->AncThetaDIG;
const parstype FounderThetaDIG=Mut->FounderThetaDIG;
//cumultype AlternativeDenom=0.0;
scaledTimeType (*IntensityCDFPtr)(cumultype random,const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType (*IntensityCDFPtr2)(cumultype random,const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType (*InverseIntensityCDFPtr)(cumultype random,const int SampleSize,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType BisectionStartLo,BisectionStartHi,Rate,TimeFactor;


//calcul l'overall rate D(n) (section 4.1.1 p21)
//il y a une difference avec l'eq p21 : on ne somme pas le terme de migration sur les pop
//mais ca me semble plus coherent que sur le manuscript...
/* Weight, scaled by not counting mutations j -> j */
if( !firstPassbool || ( (DemographicModel!="OnePopVarSize" && DemographicModel!="OnePopFounderFlush")
     || ( (DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush") && (VarSizeFunction=="Discrete"
							|| (VarSizeFunction=="Exponential" && (Mig->PrevChangeTime==-666 || (Mig->PrevChangeTime!=-666 && Mig->MinChangeTime==numeric_limits<scaledTimeType>::infinity())))
							|| (VarSizeFunction=="Logistic" && !Mig->InAncStablePopbool))) ) ) {
    if(PopSampledOrNot==1) {
			term1=(PopEffectif[0]-1)/Mig->PopSize[0]+ThetaDIG;
#ifdef DEBUG
		//avirer a terme, RL->RL
        if(DebugChoosePopType || std::isnan(term1)) {
            cout << "ChoosePopType->term1=" << term1 << ";" ;
            cout << "   (PopEffectif[0]-1) / Mig->PopSize[0] + ThetaDIG = " << (PopEffectif[0]-1) << " " << Mig->PopSize[0] << " " << ThetaDIG << endl;
        }
#endif
			Denom=term1*PopEffectif[0];
	}
	  else for(int a=0;a<PopSampledOrNot;a++) {
		Denom+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
//	    if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) AlternativeDenom+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
	}
#ifdef DEBUG
		//avirer a terme, RL->RL
    if(DebugChoosePopType || std::isnan(Denom)) {
        cout << "ChoosePopType->Denom=" << Denom << ";" ;
        cout << "   PopEffectif[0] = " << PopEffectif[0] << endl;
    }
#endif

} else {
	if(VarSizeFunction=="Exponential") {IntensityCDFPtr=&ExpIntensityCDF;IntensityCDFPtr2=&ExpIntensityCDF2;InverseIntensityCDFPtr=&ExpInverseIntensityCDF;}
	else if(VarSizeFunction=="Logistic") {IntensityCDFPtr=&LogisticIntensityCDF;}
else {
	cout << "Probleme with IntensityCDFPtr " << endl;
	cout << "Check procedure ChoosePop&Type(); End of the program..." << endl;
	if (cinGetOnError) cin.get();
	exit(-1);
	}

}


/*#ifdef ASYMPTO_PAR_FST
scaled_generation+=(-log(alea())/Denom); // the time in unit of 2 \Ntot generations
#endif
#ifdef ASYMPTO_PAR_SCALED_RATE
scaled_generation+=(-log(alea())/Denom); // the time in unit of 2 \Ntot generations
#endif	*/

if(firstPassbool && ( DemographicModel=="IM" || DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush")) {
//time computation for IM and varsize models
	do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());
	//Remember that for OnePopFounderFlush Nanc during continuous var size phase is equal to Nfounder for code simplicity (but not for readibilty...) RL 052013, need to check the threshold affect, the best solution would be to remove it if it has no effect on computation times
    if( ((DemographicModel=="OnePopVarSize" && fabs((AncThetaDIG-ThetaDIG)/ThetaDIG)>epsilonOPVSChange)  || (DemographicModel=="OnePopFounderFlush"  && fabs((FounderThetaDIG-ThetaDIG)/ThetaDIG)>epsilonOPVSChange)) && ( (VarSizeFunction=="Exponential" &&  Mig->PrevChangeTime!=-666 && !Mig->InAncStablePopbool)//exponential continuous change in population size
							|| (VarSizeFunction=="Logistic" && Mig->MinChangeTime==numeric_limits<scaledTimeType>::infinity()))) {//logistic continuous change in population size

#ifdef DEBUG
        if(DebugBisection) {
			cout << "VarSizeFunction = " << VarSizeFunction << ";" << endl;
			cout << "scaled_generation = " << scaled_generation << ";" << endl;
		}
#endif

		if(VarSizeFunction=="Logistic") {
			BisectionStartLo=scaled_generation;
			BisectionStartHi=10.0*scaled_generation;
		} else {
			BisectionStartLo=scaled_generation;
			BisectionStartHi=Mig->MinChangeTime;
		}

		if(VarSizeFunction=="Logistic") {  // old, slow bisection method
			scaled_generation=bisection_search(IntensityCDFPtr,random,Size,scaled_generation,Mig,Mut,BisectionStartLo,BisectionStartHi);
			//cout << "random=" << random << "; scaled_generation=" << scaled_generation << endl;
		} else {
			if(!PopSizeScaleForTimebool) TimeFactor=1/ThetaDIG;// to get the time in unit of Tg/2Ngenes from values in unit of 2µ (To be checked RL 032009)
				else TimeFactor=1;

			//Tirage t mut+mig (constant rate)
			do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());
			for(int a=0;a<PopSampledOrNot;a++) Rate=(Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
			scaled_generationOthers=scaled_generation*TimeFactor-log( (scaledTimeType) 1.-random)/Rate;// the time in unit of 2 \Ntot generations of a mutation or mig occurence
#ifdef DEBUG
			if(DebugPopVarSize) {
				cout << "\n\trandomOthers=" << random << endl;
				cout << "\tRate=" << Rate << endl;
				cout << "\tscaled(Tg/2Ngenes)_generationOthers=" << scaled_generationOthers << endl;
			}
#endif


			//Tirgae T coa (time dependant rate)
			do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());
            //cout << "Random" << random << endl;
            //cout << "IntensityCDFPtr2(random,Size,Mig->MinChangeTime,scaled_generation,Mig,Mut)=" << IntensityCDFPtr2(random,Size,Mig->MinChangeTime,scaled_generation,Mig,Mut)  << endl;
			if(IntensityCDFPtr2(random,Size,Mig->MinChangeTime*TimeFactor,scaled_generation*TimeFactor,Mig,Mut)>0){
				scaled_generationCoa=InverseIntensityCDFPtr(random,Size,scaled_generation*TimeFactor,Mig,Mut);
			} else scaled_generationCoa=Mig->MinChangeTime*TimeFactor;//just sup than MinChange Time so that we are at the end of the change

			if(!(scaled_generationCoa>=Mig->MinChangeTime*TimeFactor && scaled_generationOthers>=Mig->MinChangeTime*TimeFactor)) {
				if(scaled_generationCoa>scaled_generationOthers) scaled_generation=scaled_generationOthers;
				 else scaled_generation=scaled_generationCoa;
			} else scaled_generation=Mig->MinChangeTime*TimeFactor;
#ifdef DEBUG
			if(DebugPopVarSize) {
				cout << "\tscaled_generationCoa=" << scaled_generationCoa << endl;
				cout << "\t->scaled_generation=" << scaled_generation << endl;
			}
#endif

		} //end else du if(VarSizeFunction=="Logistic") {  // old, slow bisection method


		if(!PopSizeScaleForTimebool) scaled_generation=scaled_generation*ThetaDIG;// the time in unit of µ (To be checked RL 032009)

        //for continuous change in population size, IntensityValue is the density of the population size intensity function given current time
        IntensityValue= (cumultype) 1.;
        if(mutationModel=="SNP") {
            if(DemographicModel=="OnePopFounderFlush") {
                IntensityValue=pow((long double) FounderThetaDIG,(long double) (-(scaled_generation - Mig->PrevChangeTime)/(Mig->MinChangeTime-Mig->PrevChangeTime)));
                Mig->PopSize[0]=1/IntensityValue;//ApplyIntensityFunction(0,IntensityValue);
            } else {
                if(VarSizeFunction=="Exponential") IntensityValue=pow((long double) AncThetaDIG,(long double) (-(scaled_generation - Mig->PrevChangeTime)/(Mig->MinChangeTime-Mig->PrevChangeTime)));
                else if(VarSizeFunction=="Logistic") IntensityValue=(1.0+(AncThetaDIG-1.0)*exp( -Mig->LogisticGrowthRate*(scaled_generation - Mig->PrevChangeTime)))/(AncThetaDIG);
                Mig->PopSize[0]=1/IntensityValue;//ApplyIntensityFunction(0,IntensityValue);
            }

        } else {
            if(DemographicModel=="OnePopFounderFlush") {
                IntensityValue=pow((long double) FounderThetaDIG/ThetaDIG,(long double) (-(scaled_generation - Mig->PrevChangeTime)/(Mig->MinChangeTime-Mig->PrevChangeTime)));
                Mig->PopSize[0]=1/IntensityValue;//ApplyIntensityFunction(0,IntensityValue);
            } else {
                if(VarSizeFunction=="Exponential") IntensityValue=pow((long double) AncThetaDIG/ThetaDIG,(long double) (-(scaled_generation - Mig->PrevChangeTime)/(Mig->MinChangeTime-Mig->PrevChangeTime)));
                else if(VarSizeFunction=="Logistic") IntensityValue=(1.0+(AncThetaDIG/ThetaDIG-1.0)*exp( -Mig->LogisticGrowthRate*(scaled_generation - Mig->PrevChangeTime)))/(AncThetaDIG/ThetaDIG);
                Mig->PopSize[0]=1/IntensityValue;//ApplyIntensityFunction(0,IntensityValue);
            }

        }


		term1=(PopEffectif[0]-1)/Mig->PopSize[0]+ThetaDIG;
		Denom=term1*PopEffectif[0];
#ifdef DEBUG
        if(DebugChoosePopType || std::isnan(Denom)) {
            cout << "ChoosePopType->Denom=" << term1 << ";" ;
            cout << "   PopEffectif[0] * ( (PopEffectif[0]-1) / Mig->PopSize[0] + ThetaDIG )= " << PopEffectif[0];
            cout << " " << (PopEffectif[0]-1) << " " << Mig->PopSize[0] << " " << ThetaDIG << endl;
        }
#endif

        //		if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) AlternativeDenom=((PopEffectif[0]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[0]+ThetaDIG)*PopEffectif[0];
#ifdef DEBUG
        if(DebugPopVarSize) {
           cout << "\n\tSample->scaled_generation is " << scaled_generation << " and MinChangeTime is " << Mig->MinChangeTime << ";" << endl;
		   cout << "\t PrevChangeTime is " << Mig->PrevChangeTime << ";" << endl;
		   cout << "\t IntensityValue=" << IntensityValue << endl;
		   cout << "\t Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		   cout << "\t Theta/IntensityValue/2/0.001=" << ThetaDIG/IntensityValue/2/0.001 << endl;
        }
#endif
    } else {//constant or discrete change in population size
        temp=(-log( (scaledTimeType) random)/Denom);// the time in unit of 2 \Ntot generations for discrete changes or constant population sizes
        if(!PopSizeScaleForTimebool) scaled_generation+=temp*ThetaDIG;// the time in unit of 4µ (To be checked RL 032009)
        else scaled_generation+=temp; // the time in unit of 2 \Ntot generations
    }
#ifdef DEBUG
	if(DebugChoosePopType || DebugSplit || DebugPopVarSize) cout << "\nChoosePopType->scaled_generation=" << scaled_generation << " (PrevChangeTime=" << Mig->PrevChangeTime << " and MinChangeTime=" << Mig->MinChangeTime << ");" << endl;
    if(scaled_generation==numeric_limits<scaledTimeType>::max()) {//a priori pcq random==0
         cout << "Problem in ChoosePopType, demograpphic change or split event found with scaled_generation==numeric_limits<scaledTimeType>::max()=" << scaled_generation << endl;
         cout << "random is =" << random << " and temp (time since the previous event) = " << temp <<  endl;
    }
#endif
	if(scaled_generation>=Mig->MinChangeTime && !std::isinf(Mig->MinChangeTime)) {
#ifdef DEBUG
        if(Mig->MinChangeTime==numeric_limits<scaledTimeType>::max()) {//a priori pcq random==0
            cout << "Problem in ChoosePopType, demograpphic change or split event found with MinChangeTime=" << Mig->MinChangeTime << endl;
            cout << "PrevChangeTime=" << Mig->PrevChangeTime << endl;
			cout << "scaled_generation=" << scaled_generation << endl;
        }
        if(DebugSplit || DebugPopVarSize) {
           cout << "\nChoosePopType() found a demographic change or a split event;" << endl;
           cout << "\tSample->scaled_generation is " << scaled_generation << ", MinChangeTime is " << Mig->MinChangeTime << " and PrevChangeTime is " << Mig->PrevChangeTime << ";" << endl;
           cout << "\t Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
        }
#endif
		scaled_generation=Mig->MinChangeTime;
#ifdef DEBUG
		if(DebugSplit || DebugPopVarSize) cout << "\tSample->scaled_generation is now set to " << scaled_generation << ";" << endl;
#endif
		return scaled_generation;
	}
} else if (firstPassbool && (timeNeededBool || (TMRCABool && !(DemographicModel=="IM" || DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush")))) {/*if IM else*/
//exp deviate with mean Nhaploid*PSON/Denom. Numerical recipes ß7.2
	if(!PopSizeScaleForTimebool) scaled_generation+=(-log( (scaledTimeType) alea())/Denom)*ThetaDIG;// the time in unit of 1/µ
	else scaled_generation+=(-log( (scaledTimeType) alea())/Denom); // the time in unit of \2*Ntot generations
//cout<<"scaled gener= "<<scaled_generation;getchar();
} else {
//cout<<"timeNeededBool= "<<timeNeededBool;getchar();
}

//ajout RL pour SMM et GSM, sinon c'est tres lent car beaucoup d'['e]tats possibles mais non repr['e]sent['e]s
if(mutationModel=="SMM" or mutationModel=="GSM") {
	mini=AllelicRange[0];
	maxi=AllelicRange[1];
	}
else {
	mini=0;
	maxi=Mut->Mut_AlleleNbr-1; 

	}

//cherche la pop et l'allele qui sera chang['e] (eq. 4.12 p23)
//NOter que le denominateur est simplifié par n_a compared with DIG's formulas
while(true) {
random=alea();
#ifdef DEBUG
if(DebugChoosePopType) cout << "\n ChoosePopType->Random=" << random << endl;
#endif

if(PopSampledOrNot==1) {
	cumultype term2=term1/Denom;
#ifdef DEBUG
    if(DebugChoosePopType || std::isnan(term2)) {
        cout << "ChoosePopType->term1=" << term2 << ";" ;
        cout << "   PopEffectif[0] = " << PopEffectif[0] << endl;
    }
#endif

	for(int i=mini;i<=maxi;i++){
		if(Effectif[0][i]>0){// terme r_a n_{aj}/D(n) de DIG04ii (2.12)
			/*if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) cumul+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/AlternativeDenom;
			 else*/ cumul+=term2*Effectif[0][i]; // terme r_a n_{aj}/D(n) de DIG04ii (2.12)
#ifdef DEBUG
            if(DebugChoosePopType || std::isnan(cumul)) {
                cout << "ChoosePopType->cumul=" << cumul << ";" ;
                if(std::isnan(cumul)) cout << "   PopEffectif[0] = " << PopEffectif[0] << endl;
            }
#endif
			//cerr<<a<<" "<<i<<" "<< Mig->PopSize[a]<<" "<<Mig->Ma[a]<<" "<<Denom<< endl;getchar();
			if(cumul>random){
				*p_a=0;*p_i=i;
				return -666;
			}
		}//end if(Effectif[a][i]>0)
	}//end for(int i=mini;i<=maxi;i++)
} else for(int a=0;a<PopSampledOrNot;a++){
		for(int i=mini;i<=maxi;i++){
			if(Effectif[a][i]>0){// terme r_a n_{aj}/D(n) de DIG04ii (2.12)
				/*if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) cumul+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/AlternativeDenom;
				 else*/ cumul+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/Denom; // terme r_a n_{aj}/D(n) de DIG04ii (2.12)

				//cerr<<a<<" "<<i<<" "<< Mig->PopSize[a]<<" "<<Mig->Ma[a]<<" "<<Denom<< endl;getchar();
#ifdef DEBUG
                if(DebugChoosePopType || std::isnan(cumul)) {
                    cout << "ChoosePopType->cumul=" << cumul << ";" ;
                    if(std::isnan(cumul)) {
                        cout << "  ((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/Denom; = " << (PopEffectif[a]-1)  << " " ;
                        cout << Mig->PopSize[a] << " " << Mig->Ma[a] << " " << ThetaDIG  << " " << Effectif[a][i]  << " " << Denom << endl;
                    }
                }
#endif
				if(cumul>random){
					*p_a=a;*p_i=i;
					return -666;
				}
			}//end if(Effectif[a][i]>0)
		}//end for(int i=mini;i<=maxi;i++)
	}// endfor(int a=0;a<PopSampledOrNot;a++)
} //fin while
return(-1);
}

//	CBR (13.05.2013) keeping ONLY the time computation part of CSample::ChoosePopType for IM and varsize models
scaledTimeType CSample::TimeCompute(CMigMod* Mig,CMutMod* Mut,bool firstPassbool){
//cout<<"debut CSample::ChoosePopType(int* p_a...)";getchar();
//int mini,maxi;
scaledTimeType temp;
cumultype Denom=0.0,term1;
//cumultype cumul=0.0,random,IntensityValue;
cumultype random,IntensityValue;
const parstype ThetaDIG=Mut->ThetaDIG;
const parstype AncThetaDIG=Mut->AncThetaDIG;
//cumultype AlternativeDenom=0.0;
scaledTimeType (*IntensityCDFPtr)(cumultype random,const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType (*IntensityCDFPtr2)(cumultype random,const int SampleSize,scaledTimeType currentTime,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType (*InverseIntensityCDFPtr)(cumultype random,const int SampleSize,scaledTimeType previousTime,const CMigMod* Mig,const CMutMod* Mut);
scaledTimeType BisectionStartLo,BisectionStartHi,Rate,TimeFactor;


//calcul l'overall rate D(n) (section 4.1.1 p21)
//il y a une difference avec l'eq p21 : on ne somme pas le terme de migration sur les pop
//mais ca me semble plus coherent que sur le manuscript...
/* Weight, scaled by not counting mutations j -> j */
if( !firstPassbool || ( DemographicModel!="OnePopVarSize"
     || (DemographicModel=="OnePopVarSize" && (VarSizeFunction=="Discrete"
							|| (VarSizeFunction=="Exponential" && (Mig->PrevChangeTime==-666 || (Mig->PrevChangeTime!=-666 && Mig->MinChangeTime==numeric_limits<scaledTimeType>::infinity())))
							|| (VarSizeFunction=="Logistic" && !Mig->InAncStablePopbool))) ) ) {
    if(PopSampledOrNot==1) {
			term1=(PopEffectif[0]-1)/Mig->PopSize[0]+ThetaDIG;
			Denom=term1*PopEffectif[0];
	}
	  else for(int a=0;a<PopSampledOrNot;a++) {
		Denom+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
//	    if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) AlternativeDenom+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
	}
} else {
	if(VarSizeFunction=="Exponential") {IntensityCDFPtr=&ExpIntensityCDF;IntensityCDFPtr2=&ExpIntensityCDF2;InverseIntensityCDFPtr=&ExpInverseIntensityCDF;}
	else if(VarSizeFunction=="Logistic") {IntensityCDFPtr=&LogisticIntensityCDF;}
else {
	cout << "Probleme with IntensityCDFPtr " << endl;
	cout << "Check procedure ChoosePop&Type(); End of the program..." << endl;
	if (cinGetOnError) cin.get();
	exit(-1);
	}

}


/*#ifdef ASYMPTO_PAR_FST
scaled_generation+=(-log(alea())/Denom); // the time in unit of 2 \Ntot generations
#endif
#ifdef ASYMPTO_PAR_SCALED_RATE
scaled_generation+=(-log(alea())/Denom); // the time in unit of 2 \Ntot generations
#endif	*/

if(firstPassbool && ( DemographicModel=="IM" || DemographicModel=="OnePopVarSize")) {
//time computation for IM and varsize models
	do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());

    if(DemographicModel=="OnePopVarSize" && fabs((AncThetaDIG-ThetaDIG)/ThetaDIG)>epsilonOPVSChange && ( (VarSizeFunction=="Exponential" &&  Mig->PrevChangeTime!=-666 && !Mig->InAncStablePopbool)//exponential continuous change in population size
							|| (VarSizeFunction=="Logistic" && Mig->MinChangeTime==numeric_limits<scaledTimeType>::infinity()))) {//logistic continuous change in population size

#ifdef DEBUG
        if(DebugBisection) {
			cout << "VarSizeFunction = " << VarSizeFunction << ";" << endl;
			cout << "scaled_generation = " << scaled_generation << ";" << endl;
		}
#endif

		if(VarSizeFunction=="Logistic") {
			BisectionStartLo=scaled_generation;
			BisectionStartHi=10.0*scaled_generation;
		} else {
			BisectionStartLo=scaled_generation;
			BisectionStartHi=Mig->MinChangeTime;
		}

		if(VarSizeFunction=="Logistic") {  // old, slow bisection method
			scaled_generation=bisection_search(IntensityCDFPtr,random,Size,scaled_generation,Mig,Mut,BisectionStartLo,BisectionStartHi);
			//cout << "random=" << random << "; scaled_generation=" << scaled_generation << endl;
		} else {
			if(!PopSizeScaleForTimebool) TimeFactor=1/ThetaDIG;// to get the time in unit of Tg/2Ngenes from values in unit of 2µ (To be checked RL 032009)
				else TimeFactor=1;

			//Tirage t mut+mig (constant rate)
			do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());
			for(int a=0;a<PopSampledOrNot;a++) Rate=(Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
			scaled_generationOthers=scaled_generation*TimeFactor-log( (scaledTimeType) 1.-random)/Rate;// the time in unit of 2 \Ntot generations of a mutation or mig occurence
#ifdef DEBUG
			if(DebugPopVarSize) {
				cout << "\n\trandomOthers=" << random << endl;
				cout << "\tRate=" << Rate << endl;
				cout << "\tscaled(Tg/2Ngenes)_generationOthers=" << scaled_generationOthers << endl;
			}
#endif


			//Tirage T coa (time dependant rate)
			do {random=alea();} while(random<numeric_limits<cumultype>::epsilon() || (1.0-random)<numeric_limits<cumultype>::epsilon());
			if(IntensityCDFPtr2(random,Size,Mig->MinChangeTime*TimeFactor,scaled_generation*TimeFactor,Mig,Mut)>0){
				//cout << "IntensityCDFPtr2(random,Size,Mig->MinChangeTime,scaled_generation,Mig,Mut)=" << IntensityCDFPtr2(random,Size,Mig->MinChangeTime,scaled_generation,Mig,Mut)  << endl;
				scaled_generationCoa=InverseIntensityCDFPtr(random,Size,scaled_generation*TimeFactor,Mig,Mut);
			} else scaled_generationCoa=Mig->MinChangeTime*TimeFactor;//just sup than MinChange Time so that we are at the end of the change

			if(!(scaled_generationCoa>=Mig->MinChangeTime*TimeFactor && scaled_generationOthers>=Mig->MinChangeTime*TimeFactor)) {
				if(scaled_generationCoa>scaled_generationOthers) scaled_generation=scaled_generationOthers;
				 else scaled_generation=scaled_generationCoa;
			} else scaled_generation=Mig->MinChangeTime*TimeFactor;
#ifdef DEBUG
			if(DebugPopVarSize) {
				cout << "\n\tscaled_generationCoa=" << scaled_generationCoa << endl;
				cout << "\tscaled_generation=" << scaled_generation << endl;
			}
#endif

		} //end else du if(VarSizeFunction=="Logistic") {  // old, slow bisection method


		if(!PopSizeScaleForTimebool) scaled_generation=scaled_generation*ThetaDIG;// the time in unit of 4µ (To be checked RL 032009)

        //for continuous change in population size, IntensityValue is the density of the population size intensity function given current time
        IntensityValue= (cumultype) 1.;
		if(VarSizeFunction=="Exponential") IntensityValue=pow((long double) AncThetaDIG/ThetaDIG,(long double) (-(scaled_generation - Mig->PrevChangeTime)/(Mig->MinChangeTime-Mig->PrevChangeTime)));
		 else if(VarSizeFunction=="Logistic") IntensityValue=(1.0+(AncThetaDIG/ThetaDIG-1.0)*exp( -Mig->LogisticGrowthRate*(scaled_generation - Mig->PrevChangeTime)))/(AncThetaDIG/ThetaDIG);
			Mig->PopSize[0]=1/IntensityValue;//ApplyIntensityFunction(0,IntensityValue);

		term1=(PopEffectif[0]-1)/Mig->PopSize[0]+ThetaDIG;
		Denom=term1*PopEffectif[0];
//		if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) AlternativeDenom=((PopEffectif[0]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[0]+ThetaDIG)*PopEffectif[0];
#ifdef DEBUG
        if(DebugPopVarSize) {
           cout << "\n\tSample->scaled_generation is " << scaled_generation << " and MinChangeTime is " << Mig->MinChangeTime << ";" << endl;
		   cout << "\n\tPrevChangeTime is " << Mig->PrevChangeTime << ";" << endl;
		   cout << "\t IntensityValue=" << IntensityValue << endl;
		   cout << "\t Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
		   cout << "\t Theta/IntensityValue/2/0.001=" << ThetaDIG/IntensityValue/2/0.001 << endl;
        }
#endif
    } else {//constant or discrete change in population size
        temp=(-log( (scaledTimeType) random)/Denom);// the time in unit of 2 \Ntot generations for discrete changes or constant population sizes
        if(!PopSizeScaleForTimebool) scaled_generation+=temp*ThetaDIG;// the time in unit of 4µ (To be checked RL 032009)
        else scaled_generation+=temp; // the time in unit of 2 \Ntot generations
    }
#ifdef DEBUG
	if(DebugChoosePopType || DebugSplit || DebugPopVarSize) cout << "\nChoosePopType->scaled_generation=" << scaled_generation << " (PrevChangeTime=" << Mig->PrevChangeTime << " and MinChangeTime=" << Mig->MinChangeTime << ");" << endl;
    if(scaled_generation==numeric_limits<scaledTimeType>::max()) {//a priori pcq random==0
         cout << "Problem in ChoosePopType, demograpphic change or split event found with scaled_generation==numeric_limits<scaledTimeType>::max()=" << scaled_generation << endl;
         cout << "random is =" << random << " and temp (time since the previous event) = " << temp <<  endl;
    }
#endif
	if(scaled_generation>=Mig->MinChangeTime && !std::isinf(Mig->MinChangeTime)) {
        if(Mig->MinChangeTime==numeric_limits<scaledTimeType>::max()) {//a priori pcq random==0
            cout << "Problem in ChoosePopType, demograpphic change or split event found with MinChangeTime=" << Mig->MinChangeTime << endl;
            cout << "PrevChangeTime=" << Mig->PrevChangeTime << endl;
			cout << "scaled_generation=" << scaled_generation << endl;
        }
#ifdef DEBUG
        if(DebugSplit || DebugPopVarSize) {
           cout << "\nChoosePopType() found a demographic change or a split event;" << endl;
           cout << "\tSample->scaled_generation is " << scaled_generation << ", MinChangeTime is " << Mig->MinChangeTime << " and PrevChangeTime is " << Mig->PrevChangeTime << ";" << endl;
           cout << "\t Mig->PopSize[0]=" << Mig->PopSize[0] << endl;
        }
#endif
		scaled_generation=Mig->MinChangeTime;
#ifdef DEBUG
		if(DebugSplit || DebugPopVarSize) cout << "\tSample->scaled_generation is now set to " << scaled_generation << ";" << endl;
#endif
		return scaled_generation;
	}
} else if (firstPassbool && (timeNeededBool || (TMRCABool && !(DemographicModel=="IM" || DemographicModel=="OnePopVarSize")))) {/*if IM else*/
//exp deviate with mean Nhaploid*PSON/Denom. Numerical recipes ß7.2
	if(!PopSizeScaleForTimebool) scaled_generation+=(-log( (scaledTimeType) alea())/Denom)*ThetaDIG;// the time in unit of 1/µ (To be checked RL 032009)
	else scaled_generation+=(-log( (scaledTimeType) alea())/Denom); // the time in unit of \2*Ntot generations
//cout<<"scaled gener= "<<scaled_generation;getchar();
} else {
//cout<<"timeNeededBool= "<<timeNeededBool;getchar();
}

/*
//ajout RL pour SMM et GSM, sinon c'est tres lent car beaucoup d'['e]tats possibles mais non repr['e]sent['e]s
if(mutationModel=="SMM" or mutationModel=="GSM") {
	mini=AllelicRange[0];
	maxi=AllelicRange[1];
	}
else {
	mini=0;
	maxi=Mut->Mut_AlleleNbr;

	}

//cherche la pop et l'allele qui sera chang['e] (eq. 4.12 p23)
//NOter que le denominateur est simplifié par n_a, compared with DIG's formulas?
while(true) {
random=alea();
#ifdef DEBUG
if(DebugChoosePopType) cout << endl;
if(DebugChoosePopType) cout << "ChoosePopType->Random=" << random << endl;
#endif

if(PopSampledOrNot==1) {
	cumultype term2=term1/Denom;
	for(int i=mini;i<maxi;i++){
		if(Effectif[0][i]>0){// terme r_a n_{aj}/D(n) de DIG04ii (2.12)
			if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) cumul+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/AlternativeDenom;
			 else cumul+=term2*Effectif[0][i]; // terme r_a n_{aj}/D(n) de DIG04ii (2.12)

			//cerr<<a<<" "<<i<<" "<< Mig->PopSize[a]<<" "<<Mig->Ma[a]<<" "<<Denom<< endl;getchar();
#ifdef DEBUG
			if(DebugChoosePopType) cout << "\n ChoosePopType->Cumul=" << cumul << endl;
#endif
			if(cumul>random){
				*p_a=0;*p_i=i;
				return -666;
			}
		}//end if(Effectif[a][i]>0)
	}//end for(int i=mini;i<maxi;i++)
} else for(int a=0;a<PopSampledOrNot;a++){
		for(int i=mini;i<maxi;i++){
			if(Effectif[a][i]>0){// terme r_a n_{aj}/D(n) de DIG04ii (2.12)
				if(AlternativeIS_AncPopSizebool && !Mig->InAncStablePopbool) cumul+=((PopEffectif[a]-1)/(AncThetaDIG/ThetaDIG)+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/AlternativeDenom;
				 else cumul+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/Denom; // terme r_a n_{aj}/D(n) de DIG04ii (2.12)

				//cerr<<a<<" "<<i<<" "<< Mig->PopSize[a]<<" "<<Mig->Ma[a]<<" "<<Denom<< endl;getchar();
#ifdef DEBUG
				if(DebugChoosePopType) cout << "\n ChoosePopType->Cumul=" << cumul << endl;
#endif
				if(cumul>random){
					*p_a=a;*p_i=i;
					return -666;
				}
			}//end if(Effectif[a][i]>0)
		}//end for(int i=mini;i<maxi;i++)
	}// endfor(int a=0;a<PopSampledOrNot;a++)
} //fin while
return(-1);
*/
return 0;
}

// 2e version args iterators
//RL pas au point pour split
int CSample::ChoosePopType(int* p_a, int* p_i,
	vector<vector<int> >::iterator &effa_vec,
	vector<int>::iterator &popeffa,
	vector<int>::iterator &effai,
	vector<pascumultype>::iterator &popsiza,
	vector<pascumultype>::iterator &migmaa,CMigMod* Mig,CMutMod* Mut){
pascumultype Denom=0.0;
cumultype cumul=0.0,random;
const cumultype ThetaDIG=Mut->ThetaDIG;

cout << "(!) The procedure ChoosePopType with vectors is not yet ready to use" << endl;
if (cinGetOnError) cin.get();
exit(-1);

//calcul l'overall rate D(n) (section 4.1.1 p21)
//il y a une difference avec l'eq p21 : on ne somme pas le terme de migration sur les pop
//mais ca me semble plus coherent que sur le manuscript...
/* Weight, scaled by not counting mutations j -> j */
/* ancienne version lisible RENVOYAIT les indices [a][i]
for(int a=0;a<Mig->PopSampledOrNot;a++)
		Denom+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*PopEffectif[a];
//cherche la pop et l'allele qui sera chang['e] (eq. 4.12 p23)
random=alea();
for(int a=0;a<Mig->PopSampledOrNot;a++){
	for(int i=0;i<Mut->Mut_AlleleNbr;i++){
		if(Effectif[a][i]>0){
			cumul+=((PopEffectif[a]-1)/Mig->PopSize[a]+Mig->Ma[a]+ThetaDIG)*Effectif[a][i]/Denom;
			if(cumul>random){
				*p_a=a;*p_i=i;
				return 1;
				}
			}
		}
	}
return -1;
}*/
popsiza=Mig->PopSize.begin();
migmaa=Mig->Ma.begin();
for(popeffa=PopEffectif.begin();popeffa<PopEffectif.end();popeffa++,migmaa++,popsiza++)
		Denom+=(((*popeffa)-1)/(*popsiza)+(*migmaa)+ThetaDIG)*(*popeffa);
//cherche la pop et l'allele qui sera chang['e] (eq. 4.12 p23)
// r['e]initialiser apr[`e]s la boucle
popeffa=PopEffectif.begin();
popsiza=Mig->PopSize.begin();
migmaa=Mig->Ma.begin();
int a=0;
while (true) {
random=alea();
#ifdef DEBUG
if(DebugDG) cout << "Random=" << random << endl;
#endif
for(effa_vec=Effectif.begin();effa_vec<Effectif.end();a++,effa_vec++,popeffa++,migmaa++,popsiza++){
	int i=0;
	for(effai=(*effa_vec).begin();effai<(*effa_vec).end();effai++,i++){
////cout << a << " " << i << " : " << Effectif[a][i] << " " <<*effaj <<endl;
////getchar();
		if((*effai)>0){
			//y a un facteur Effectif[a][i]/Effectif[a] par rapport a l'eq4.12...
			//parce qu'on cherche directement la pop et la type et pas que la pop
			cumul+=(((*popeffa)-1)/(*popsiza)+(*migmaa)+ThetaDIG)*(*effai)/Denom;
			if(cumul>random){
				*p_a=a;*p_i=i;
// a ce stade les iterateurs ont les valeurs qu'il faut
				return -666;
				}
			}
		}
	}
} // fin while
return(-1);
}

int CSample::setMutMod(CMutMod* MutMod1,CMigMod* MigMod1) {
using namespace NS_calclogl;
parstype tmp;

if(mutationModel=="SMM" or mutationModel=="GSM") {//SMM or GSM

	if(mutationModel=="SMM") MutMod1->MakeMatrixSMM(Sam_AlleleNbr,_Theta); //SMM possible avec N=2PopModel, IM, OnePop, OnePopVarSize et OnePopFounderFlush
	 else if(mutationModel=="GSM") MutMod1->MakeMatrixGSM(Sam_AlleleNbr,_Theta,_pGSM);//GSM possible avec  N=OnePop, OnePopVarSize et OnePopFounderFlush

	//cout << "Starting stationnary distribution computation..." << endl;
	tmp=MutMod1->CalculStation();
	if(abs(tmp-1.0) > 10E-6 ) { //calcul la distribution stationnaire
		cout<<"(!) Problem : stationary distribution is not summing to 1.0 :"<<endl;
		cout << setprecision(12) << "(!) Sum - 1.0 = " << tmp-1.0 << "...I exit."<<endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
	//cout << "End of Stationnary distribution computations." << endl;
	//cout << "AncThetaTab[size]=" << _AncThetaTab[_AncThetaTab.size()-1] << endl;
	//getchar();
	MutMod1->ThetaFactor=1;
	GetAllelicRange(0);
	GetAllelicRange(1);
	//getchar();

}
else if (mutationModel == "ISM") {
	MutMod1->Mut_AlleleNbr = Sam_AlleleNbr;
	MutMod1->Station.reserve(Sam_AlleleNbr);
	MutMod1->ThetaDIG = _Theta;
	MutMod1->ThetaFactor = 1;
}
else if (mutationModel == "SNP") {
	MutMod1->Mut_AlleleNbr = Sam_AlleleNbr;
	MutMod1->Station.reserve(Sam_AlleleNbr);
	MutMod1->ThetaDIG = 0.0;
	MutMod1->ThetaFactor = 1;
}
else {//si PIM

	MutMod1->MakeMatrixPIM(Sam_AlleleNbr,_Theta); // not much useful with PIM !! //FR: but this does set the thetaDIG used...
	//cout << "AncThetaTab[size]=" << _AncThetaTab[_AncThetaTab.size()-1] << endl;
	//getchar();
#ifdef PIMDIG
	MutMod1->ThetaFactor=1;
#endif
#ifdef PIMtrue
	MutMod1->ThetaFactor=(1.0*MutMod1->Mut_AlleleNbr)/(1.0*MutMod1->Mut_AlleleNbr-1.0);
#endif

}
	//	matriceSD is now initialised for the IM model (CBR 13.01.2014)
	if ((piOnePopSDbool || piOnePopEigenbool)) {
		if (DemographicModel == "IM") {
//			cout << "Check the SD procedure here, ThetaAnc may not be adequately considered..." << endl;
//			if (cinGetOnError)
//				cin.get();
//			exit(0);
			CalcMatSD(MutMod1, MigMod1, MutMod1->ThetaFactor * _AncThetaTab[_AncThetaTab.size() - 1], true);	//for PiOnePopSD in ancestral population
		}
		else if (DemographicModel.substr(0, 6) == "OnePop")
			CalcMatSD(MutMod1, MigMod1, MutMod1->ThetaFactor * _Theta, true);//pour PiOnePopSD in current population
	}

if(DemographicModel=="OnePopVarSize") {
	if (multipleMarkersBool && (mutationModel == "ISM"))
		MutMod1->AncThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[0] * _Theta / _ThetaMIC); // AncThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
	else
		MutMod1->AncThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[0]; // theta_Anc for !SNP, 1/Nratio=Nanc/N for SNP
} else if(DemographicModel=="OnePopFounderFlush") {
    if (multipleMarkersBool && (mutationModel == "ISM"))
        MutMod1->AncThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[1] * _Theta / _ThetaMIC); // AncThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
     else
        MutMod1->AncThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[1];
    if (multipleMarkersBool && (mutationModel == "ISM"))
            MutMod1->FounderThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[0] * _Theta / _ThetaMIC); // FounderThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
     else
            MutMod1->FounderThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[0];
}

#ifdef DEBUG
    if((PrintLikelihood || DebugDG) && mutationModel!="SNP") {
        cout << "\nPrinting Mutation matrix and stationnary distribution at beginning of a run for debugging :" << endl;
		MutMod1->PrintMut();
		if(mutationModel=="SMM" or mutationModel=="GSM") MutMod1->PrintStation();
    }
#endif
return(0);
} //end setMutMod()



//RL : ajout pour split : regroupe 2 pops
int CSample::MergePop(int Sink,int Source) {
int i,j;

for(j=0;j<Sam_AlleleNbr;j++) Effectif[Sink][j]+=Effectif[Source][j];
PopEffectif[Sink]+=PopEffectif[Source];

//ceci est issu de delete_L_etc()et modifier pour garder toutjours les meme adresses memoire RL
for (int i=0;i<PopSampledOrNot;i++) delete[] Mmat[i];
delete[] Mmat;
for (int i=0; i<PopSampledOrNot; i++) delete[] L_[i];
delete[] L_;
delete[] v_;
delete[] D_;
delete[] bvec;
for (i=0; i<Sam_AlleleNbr; i++) delete[] PIs[i];
delete[] PIs;
for (i=0; i<Sam_AlleleNbr; i++) delete[] altPIs[i];
delete[] altPIs;

PopSampledOrNot--;
Effectif.resize(PopSampledOrNot);
PopEffectif.resize(PopSampledOrNot);

//ceci est issu de new_L_etc() et modifier pour garder toutjours les meme adresses memoire RL
#ifdef largeSPD_TRUE
#ifdef Golubclassmembers // attention delete's tres douteux
	delete D_A,//D_M,
		ligne,//gamma,delta,
			Golubx,Golubz,Golubr,Golubp,GolubAp,haut,bas;
#endif
#endif

Mmat=new picalctype*[PopSampledOrNot];
for (int i=0;i<PopSampledOrNot;i++) Mmat[i]=new picalctype[PopSampledOrNot];
L_=new picalctype*[PopSampledOrNot];
for (i=0; i<PopSampledOrNot; i++) {L_[i]=new picalctype[PopSampledOrNot];}
v_=new picalctype[PopSampledOrNot];
D_ =new picalctype[PopSampledOrNot];
bvec=new pirestype[PopSampledOrNot];
PIs=new pirestype*[Sam_AlleleNbr];
for (i=0; i<Sam_AlleleNbr; i++) {PIs[i]=new pirestype[PopSampledOrNot];}
altPIs=new pirestype*[Sam_AlleleNbr];
for (i=0; i<Sam_AlleleNbr; i++) {altPIs[i]=new pirestype[PopSampledOrNot];}

return 0;
}

// idem for direct solver/PCG
int (CSample::*PicalcfnPtr)(const CMigMod*,const CMutMod*, const int&);
//int (CSample::*InitialPicalcfnPtr)(const CMigMod*,const CMutMod*, const int&);
//pointer to member function PAC/IS: cf Primer+ p. 1071
changetype (CSample::*ChangefnPtr)(CMigMod*,CMutMod*);
//changetype (CSample::*InitialChangefnPtr)(CMigMod*,CMutMod*);


//RL : pour tirage des lign['e]s ancestrales au moment du split
//implementation de la log hypergeometric de cornuet RL 04 2007
double LogComb(int n, int m) {

	double c = 0.0;
	if ((m == 0) || (m == n))
		return c;
	else if (m > n) {
		cerr << "(!) m > n in double LogComb(int n, int m), Please contact the authors." << endl
		     << "Aborting Migraine...Press any key to exit!" << endl;
		if (cinGetOnError)
			cin.get();
		exit(-1);
	}
	else {
		for (int ii = 1; ii <= m; ii++) {
			c += log(float(n - ii + 1) / ii);
		}
		return c;
	}
}

double CSample::LogHypergeom() {
int nn,mm;
double num,den,Result;
vector <int> m;

if(PopSampledOrNot>2) {
	cout << "Split Model is implemented for 2 pops but not more" << endl;
	cout << "LogHypergeom() function must be adapted to consider more than 2 populations" << endl;
	cout << "I exit." << endl;
	if (cinGetOnError) exit(-1);
}
 nn=0;mm=0;num=0.0;
 m.resize(Sam_AlleleNbr);
 for(int a=0;a<PopSampledOrNot;a++) for(int i=0;i<Sam_AlleleNbr;i++) m[i]+=Effectif[a][i];
 for(int i=0;i<Sam_AlleleNbr;i++) {
     if(Effectif[0][i]>0) num+=LogComb(m[i],Effectif[0][i]);
     nn+=Effectif[0][i];mm+=m[i];
 }
 den=LogComb(mm,nn);
 Result=num-den;
 return Result;
 }
//------------------------------------------------------

#ifdef NGIVEN //Cond non suff mais necess...
CN_known::CN_known():CMigMod(){
	Nhaploid=0;
};

CN_known::CN_known(int Nhaploid):CMigMod(){
	this->Nhaploid=Nhaploid;
};


CN_known::CN_known(CMigMod &Mig,int Nhaploid,int& GeoSpan ):CMigMod(Mig){
	this->Nhaploid=Nhaploid;
	calcule_Fourier_converge(GeoSpan);  // pastr[`e]s propre car Mig a pu seulement etre d['e]clar['e]e
};
#endif //NGIVEN

/****************************************************************************/
int CSample::CalcMatSD(const CMutMod *Mut,const CMigMod *Mig, const parstype _ThetaDIG,bool AllocateMemory){
int i,j,k;
//vector< vector<picalctype> > MatA;
// local copy
const int AllNbr=Sam_AlleleNbr;
const int SampleSize=Size;
const parstype ThetaDIG=_ThetaDIG;// RL 06122013 was ThetaDIG=Mut->ThetaDIG;
parstype PopSize;
bool NoSampleSizeLoop=false;

if((DemographicModel=="OnePopVarSize" or DemographicModel=="OnePopFounderFlush") and Mig->PrevChangeTime!=-666 and !Mig->InAncStablePopbool) {
	PopSize=Mig->PopSize[0];
	NoSampleSizeLoop=true;
} else PopSize=1.0;

	if(AlternativeIS_AncPopSizebool || AlternativeIS_FRExpMixAncActPopSizebool) {
		cout << "AlternativeIS function is not implemeted with PiOnePopSD. I exit ..." << endl;
		if(cinGetOnError) cin.get();
		exit(-1);
	}

//MatriceSD.resize(SampleSize+1);
//for(int i=0;i<SampleSize+1;i++) {
//	MatriceSD[i].resize(AllNbr);
//	for(int j=0;j<AllNbr;j++) MatriceSD[i][j].resize(AllNbr);
//}
if(AllocateMemory) {
 //cout << "LA alloc MatriceSD : size=" << SampleSize << endl;
    MatriceSD=new picalctype**[SampleSize+1];//pour calcul des Pi SD OnePop
    for(i=0;i<=SampleSize;i++) {
    	MatriceSD[i]=new picalctype*[AllNbr];
    	for(int j=0;j<AllNbr;j++) MatriceSD[i][j]=new picalctype[AllNbr];
    }
	SDpivec=new picalctype[AllNbr];
	MatA=new picalctype*[AllNbr];
	for(j=0;j<AllNbr;j++) MatA[j]=new picalctype[AllNbr];

}

if(!(AllocateMemory and piOnePopEigenbool)) {
	//RL, attention a cet idice qui commence a 1 et non pas a 0, a modifier RL
	for(i=1;i<=SampleSize;i++) {
		if(!NoSampleSizeLoop or i==SampleSize) {

			if(false) {//RL 022012 : FR solution using R & L eifgenvectors of the mutation matrix, without inversion of the SD matrix
				//takes more time than inversing the matrix!
				vector< vector<picalctype> > tempMat;
				tempMat.resize(AllNbr);
				for(j=0;j<AllNbr;j++) 	tempMat[j].resize(AllNbr);
				picalctype Term1=ThetaDIG/(i/PopSize+ThetaDIG);

				//matrix product R.(I-Theta/(n+Theta).Lambda)^-1.L

				//matrix product (I-Theta/(n+Theta).Lambda)^-1.L
				for(j=0;j<AllNbr;j++)
					for(k=0;k<AllNbr;k++) tempMat[j][k]=1./(1.-Term1*Mut->EigenValues[j])*Mut->LEigenVectors[j][k];

				//matrix product R.temp
				for(j=0;j<AllNbr;j++)
					for(k=0;k<AllNbr;k++) {
						MatA[j][k]=0.0;
						for(int l=0;l<AllNbr;l++) MatA[j][k]+=Mut->REigenVectors[j][l]*tempMat[l][k];
					}

				for(j=0;j<AllNbr;j++) for(k=0;k<AllNbr;k++) MatriceSD[i][j][k]=MatA[j][k]/(PopSize*(i/PopSize+ThetaDIG));

			} else {//avec inversion JMC comme dans SD2001

				for(j=0;j<AllNbr;j++)
					for(k=0;k<AllNbr;k++) {//on rempli la matrice (I-lambda(n)*Pij)
						if(j==k)	MatA[j][k]=1.0-ThetaDIG/(i/PopSize+ThetaDIG)*Mut->Pij[j][k];
						else MatA[j][k]=-ThetaDIG/(i/PopSize+ThetaDIG)*Mut->Pij[j][k];
					}
#ifdef DEBUG
		if(DebugSD) {
			cout << "Remplissage MatA OK :" ;
			cout << "ThetaDIG=" << ThetaDIG << "; samplesize=" << i << ", PopSize=" << PopSize << ", NoSampleSizeLoop=" << NoSampleSizeLoop << endl;
			if(DebugSD2) {
				cout << " et MatA : " << endl;
				//ostream_vec_vector(MatA,cout);cout << endl;
				for(j=0;j<AllNbr;j++)
					for(k=0;k<AllNbr;k++) cout << "\n MatA[" << j << "][" << k << "]=" << MatA[j][k] << endl;
			}
		}

#endif

				inversion(MatA,AllNbr);
				for(j=0;j<AllNbr;j++) for(k=0;k<AllNbr;k++) MatriceSD[i][j][k]=MatA[j][k]/(PopSize*(i/PopSize+ThetaDIG));

			}//end else //avec inversion

#ifdef DEBUG
			if(DebugSD) {
				//aff pour verif de MatriceSD
				for(j=0;j<AllNbr;j++)
					for(k=0;k<AllNbr;k++)
						//printf("\n MatriceSD[%d][%d][%d]=%f",i,j,k,MatriceSD[i][j][k]);
						cout << "\n MatriceSD2[" << i << "][" << j << "][" << k << "]=" << MatriceSD[i][j][k] << endl;
			}
#endif

		}//end if(!NoSampleSizeLoop or i==SampleSize)
	}//end for(i=1;i<=SampleSize;i++)

}


return 0;
} // end CSample::CalcMatSD
/***********************************************************/


//***********************************************************
int CSample::PrintPi(const CMigMod *Mig,const CMutMod *Mut){
register int a,i;
picalctype sum;
const int PSON=PopSampledOrNot; // local copy
bool DebugSigmaPiBool = false;

for(a=0;a<PSON;a++){
	sum=0.0;
	cout << "\nprocedure PrintPI give :" << endl;
	cout << "pop:" << a << endl;
	for(i=0;i<Sam_AlleleNbr;i++){
        (this->*PicalcfnPtr)(Mig,Mut,i);
		if(AlternativeIS_FRExpMixAncActPopSizebool && !Mig->InAncStablePopbool) {
			sum+=altPIs[i][a];
			cout << "\taltPi[pop" << a << "][type" << i << "]=" << altPIs[i][a] << endl;
		} else {
			sum+=PIs[i][a];
			cout << "\tPi[pop" << a << "][type" << i << "]=" << PIs[i][a] << endl;
		}
	}
	if(AlternativeIS_FRExpMixAncActPopSizebool && !Mig->InAncStablePopbool)
		cout << " print pi give -> Sum of >altPi=" << setprecision(10) << sum << endl;
	 else cout << " print pi give -> Sum of >Pi=" << setprecision(10) << sum << endl;
	 cout << setprecision(6);
	 if (sum < 0.99999 || sum > 1.00001)
		 DebugSigmaPiBool = true;
}
#ifdef DEBUG
	 if (DebugSigmaPi && DebugSigmaPiBool) {
		 Print();
		 cerr << "\n\nThe Pi's don't sum to one"
				 "\nFYI : Migraine is currently analysing "
			  << "\nLocus : " << this->locusNum
			  << "\nTree : " << this->runNum + 1
			  << "\nEvent : " << this->events
			  << "\nNow Aborting Migraine..." << endl;
		 if (cinGetOnError)
			 cin.get();
		 exit(-1);
	 }
#endif

return 0;
} //end CSample::PrintPi

//**********************************************************
int CSample::setMigMod(CMigMod* MigMod1) {
using namespace NS_calclogl;

if (MigMod1->init_file_et_critere==-1 || DemographicModel=="IM" || DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush")
{if(DemographicModel.substr(0,6)!="OnePop") {
   //init_file_et_critere must be reset. This will be done
   // either by MakeMatrix... (which must be executed anyway)
   //Caracterisation of MigMod1
	if(DemographicModel=="Npop" || DemographicModel=="IM") MigMod1->MakeMatrixNpop(PopSampledOrNot,Disp_Pars);
	 else {//modele IBD...
	     MigMod1->MakeMatrixSS(PopSampledOrNot,Disp_Pars);
	 }

	MigMod1->MakePopSize(_PopSizeTab);
	// .../...or based on mutation rate (mut effect in MigMod1... pas id['e]al)
	if(AsymptoPerMutRateBool && DemographicModel!="Npop") MigMod1->init_file_et_critere=mut_rate_control_param/_Theta;
	if(AsymptoPerMutRateBool && DemographicModel=="Npop") {
		cout<<"Migraine is not configured for Npop and Asympto...I exit."<<endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
#ifdef ASYMPTO_PAR_MUT_RATE
	if(DemographicModel=="Npop") {
		cout<<"Migraine is not configured for Npop and Asympto...I exit."<<endl;
	    if (cinGetOnError) cin.get();
		exit(-1);
	}
	MigMod1->init_file_et_critere=mut_rate_control_param/_Theta;
#endif
#ifdef NGIVEN
	N_known=CN_known(*MigMod1,NhaploidGiven,GeoSpan);
#endif
#ifdef DEBUG
		if(DebugDG) {
			MigMod1->PrintMig();
			MigMod1->PrintPopSize();
		}
#endif
	if(DemographicModel=="IM") {
		MigMod1->PopMergedNbr=0;
		MigMod1->MakeAncPopSizeChangeTime(_AncPopSizeTab,_ChangeTimeTab);
#ifdef DEBUG
		if(DebugDG) {
			MigMod1->PrintAncPopSize();
			MigMod1->PrintChangeTime();
		}
#endif
	}
} else {//if OnePop
 	  MigMod1->MakeOnePop();
 	  if(DemographicModel=="OnePopVarSize" || DemographicModel=="OnePopFounderFlush") {
            MigMod1->MakeAncPopSizeChangeTime(_AncPopSizeTab,_ChangeTimeTab);
			if(VarSizeFunction=="Logistic") MigMod1->LogisticGrowthRate=_VarSizeShape;
#ifdef DEBUG
		    if(DebugDG) MigMod1->PrintChangeTime();
#endif
      }
}
}
return(0);
} //end CSample::setMigMod

int CSample::DemographicChange(CMigMod* MigMod1,CMutMod* MutMod1) {
using namespace NS_calclogl;
#ifdef DEBUG
				if(scaled_generation>=numeric_limits<scaledTimeType>::max()) {
        			cout << "Problem1 in Split or Variable PopSize model,scaled_generation is at its limit : " << scaled_generation << "." ;
                    cout << "Current sample size is : " << Size << endl;
                    if(cinGetOnError) cin.get();
					exit(-1);
        		}
				if(std::isinf(MigMod1->MinChangeTime) || MigMod1->MinChangeTime<0) {
        			cout << "Problem1 in Split or Variable PopSize model,MigMod1->MinChangeTime is : " << scaled_generation << "." ;
                    cout << "Current sample size is : " << Size << endl;
                    if(cinGetOnError) cin.get();
					exit(-1);
        		}
        		if(DebugSplit || DebugPopVarSize) {
        			cout << "\n\nDemoChange : Configuration before change at time t=" << scaled_generation << ": " ;
        			cout << "ThetaDIG was " << MutMod1->ThetaDIG << endl;
                    if(DemographicModel=="OnePopFounderFlush") cout << "FounderThetaDIG was " << MutMod1->FounderThetaDIG << endl;
        			cout << "AncThetaDIG was " << MutMod1->AncThetaDIG << endl;
        			Print();
        			if(DemographicModel=="IM") {
                        MigMod1->PrintMig();
            			MigMod1->PrintPopSize();
        			    MigMod1->PrintAncPopSize();
                    }
        			MigMod1->PrintChangeTime();
        		}
#endif
    			if(DemographicModel=="IM") {

                    //calculation of the multinomial hypergeometric coefficient for the grouping of the populations
                    MultinomialCoeff=LogHypergeom();
    			    LnLikelihood+=MultinomialCoeff;
    			    //if(r==0) cout << "\nLnLikelihood+=(LogHypergeom= " << MultinomialCoeff << ")   ->LnLikelihood=" << LnLikelihood << endl;

                    //which pop merged and resetting Mut, Mig, Etc...
    			    int a=0;while(MigMod1->ChangeTime[a]!=MigMod1->MinChangeTime) a++;
    			    LineagesPerPopAtDivTime.resize(2);
    			    for(int i=0;i<2;i++) LineagesPerPopAtDivTime[i]=PopEffectif[i];
    			    PopMerged=a+1;
#ifdef DEBUG
    			    if(PopMerged>1) {
        			    cout << "Problem in merging pops : " ;
        			    cout << "Pop " << PopMerged << " merged with Pop0 at time t=" << scaled_generation << endl;
        		    }
#endif
    			    MergePop(0,PopMerged);
    			    MigMod1->MergePop(0,PopMerged,PopSampledOrNot,Disp_Pars,_AncPopSizeTab);

                    MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[MigMod1->PopMergedNbr-1];

                    if(PopSampledOrNot==1) {
                        PicalcfnPtr=setPiCalcFnPtr("OnePop");//si il reste qu'une pop on utilise PiOnePop(SD, DG, ou Eigen (= exFRRL))
    			        if(pacancbool) {
                            ChangefnPtr=&CSample::PACpi;
                            LnLikelihood+=LnMultinomialCoeff();//for PAC on ancestral population
                        }
                    }
                }//end if(DemographicModel=="IM")
                else {//pour OnePopVarSize et OnepopFounderFlush

					MigMod1->PopSize[0]=_PopSizeTab[0];
                    cumultype CurrentChangeTime=MigMod1->MinChangeTime;

					//Logistic, discrete, exponential or linear change (RL : linear is not implemented at all! to do...)
					if(VarSizeFunction!="Logistic") {
                        //1er changement demographiques =
                        //en exponentiel on sort de la pop stable actuelle pour passer en pop variable.
                        //en discret = c'est le changemnet de taille de pops discret
						if(MigMod1->PrevChangeTime==-666) {

                            if(VarSizeFunction=="Discrete") {

                                // Here ThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
                                if (multipleMarkersBool && (mutationModel == "ISM"))
                                    MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[0] * _Theta / _ThetaMIC);
                                else {
                                    if(mutationModel == "SNP") {
                                        MutMod1->ThetaDIG=0.0;
                                        MigMod1->PopSize[0]=_AncThetaTab[0];//remind AncTheta is 1/Nratio for SNP
                                    } else MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[0];
                                }

                                MigMod1->MinChangeTime=numeric_limits<scaledTimeType>::infinity();
                                MigMod1->InAncStablePopbool=true;
                                
                                if (calculQused && !calcQibdtableDoneBool) {//execut'e qu'une fois par point.
                                    // preparation for computation of probabilities of identity by standard matrix algebra
                                    // Here only those computations needed only once for a given parameter point.
                                    if (calculQ.newPars()) {
                                        calculQ.setNh(MigMod1,MutMod1);
                                        calculQ.initMig(MigMod1);
                                        calculQ.eigenanalysis();
                                        picalctype mufactor=1.0;
                                        if(mutationModel=="PIM") mufactor=MutMod1->Mut_AlleleNbr/(MutMod1->Mut_AlleleNbr-1.); // for correction IIS/IBD
                                        calculQ.initMut(MutMod1,mufactor,mutationModel);
                                        calculQ.newPars(false); // prevents further recomputation until a new call to externalfn()
                                    }
                                }


                            } else {//for exponential, linear or logistic
                                MigMod1->MinChangeTime=MigMod1->ChangeTime[1];
                                MigMod1->InAncStablePopbool=false;
                            }
						} else {
                            //2eme changement demographiques en exponentiel/lineaire =  on sort de la pop variable pour passer en pop stable ancestrale.
                            //n'existe pas en discret

							if(DemographicModel=="OnePopFounderFlush") {// on prend le theta anc (apres theta founder dans _AncThetaTab)
                                if (multipleMarkersBool && (mutationModel == "ISM"))
                                    MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[1] * _Theta / _ThetaMIC); // Here ThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
                                else
                                    if(mutationModel == "SNP") {
                                        MutMod1->ThetaDIG=0.0;
                                        MigMod1->PopSize[0]=_AncThetaTab[1];//remind AncTheta is 1/Nratio for SNP
                                    } else MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[1];
                            } else {
                                if (multipleMarkersBool && (mutationModel == "ISM"))
                                    MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*(_AncThetaTab[0] * _Theta / _ThetaMIC); // Here ThetaDIG for ISM needs to be rescaled when multipleMarkersBool=true
                                else { // single marker
                                    if(mutationModel == "SNP") {
                                        MutMod1->ThetaDIG=0.0;
                                        MigMod1->PopSize[0]=_AncThetaTab[0];//remind AncTheta is 1/Nratio for SNP
                                    } else MutMod1->ThetaDIG=(1.0*MutMod1->ThetaFactor)*_AncThetaTab[0];
                                }
                            }

							MigMod1->MinChangeTime=numeric_limits<scaledTimeType>::infinity();
							MigMod1->InAncStablePopbool=true;
							if(pacancbool) {//le passage en PACanc pour la logistique se fait dans calclog().
								ChangefnPtr=&CSample::PACpi;
								LnLikelihood+=LnMultinomialCoeff();//for PAC on ancestral population
							}
							//cout << "\nin anc stable population" << endl;
							if (calculQused && !calcQibdtableDoneBool) {//execut'e qu'une fois par point.
								// preparation for computation of probabilities of identity by standard matrix algebra
								// Here only those computations needed only once for a given parameter point.
								if (calculQ.newPars()) {
									calculQ.setNh(MigMod1,MutMod1);
									calculQ.initMig(MigMod1);
									calculQ.eigenanalysis();
									picalctype mufactor=1.0;
                                    if(mutationModel=="PIM") mufactor=MutMod1->Mut_AlleleNbr/(MutMod1->Mut_AlleleNbr-1.); // for correction IIS/IBD
									calculQ.initMut(MutMod1,mufactor,mutationModel);
									calculQ.newPars(false); // prevents further recomputation until a new call to externalfn()
								}
							}
							if(piOnePopSDbool)  {
								CalcMatSD(MutMod1,MigMod1,/*MutMod1->ThetaFactor*/MutMod1->ThetaDIG,false);//RL 05032012 : /MutMod1->ThetaDIG has already been multiplied by ThetaFactor above
							}
						}
					} else {
						//Logistic change
						if(VarSizeFunction=="Logistic" and MigMod1->PrevChangeTime!=-666) {// RL avant (012012) c'etait if(VarSizeFunction=="Logistic" || MigMod1->PrevChangeTime!=-666)
							//RL : InAncStablePopbool not implemented for logistic,
							//cout << "Check Logistic change in demographicChange(), may not be ready to use..." << endl;
                            //cout << "we may have to remove tne theta factor here..." << endl;
							//if(cinGetOnError) cin.get();
							//exit(0);
							if(piOnePopSDbool) CalcMatSD(MutMod1,MigMod1,MutMod1->ThetaFactor*MutMod1->ThetaDIG,false);//RL enlever le theta factor?? pour PiOnePopSD in the ancestral population
						}
					}

					MigMod1->PrevChangeTime=CurrentChangeTime;
					//if(mutationModel=="SMM" or mutationModel=="GSM") {
                        //SMM or GSM // FR -> RL probaby not necessary here if done at the beginning of a tree and after each mutation
					//	GetAllelicRange(MigMod1,MutMod1,0);
					//	GetAllelicRange(MigMod1,MutMod1,1);
					//}

                }//end if(onepopvarsize || onepopfounderflush)
    			Changedbool=true;
#ifdef DEBUG
                if(scaled_generation>=numeric_limits<scaledTimeType>::max()) {
                    cout << "Problem2 in Split or Variable PopSize model,scaled_generation is at its limit : " << scaled_generation << "." ;
                    cout << "Current sample size is : " << Size << endl;
                    if(cinGetOnError) cin.get();
                    exit(-1);
                }
                if(MigMod1->MinChangeTime<0) {
                    cout << "Problem2 in Split or Variable PopSize model,MigMod1->MinChangeTime is : " << scaled_generation << "." ;
                    cout << "Current sample size is : " << Size << endl;
                    if(cinGetOnError) cin.get();
                    exit(-1);
                }
                if(DebugSplit || DebugPopVarSize) {
        			cout << "Configuration after change : " ;
        			if(DemographicModel=="IM") cout << "Pop " << PopMerged << " merged with Pop0 at time t=" << scaled_generation << endl;
        			if(DemographicModel=="IM") cout << "AncThetaTab[" << MigMod1->PopMergedNbr-1 << "]=" << _AncThetaTab[MigMod1->PopMergedNbr-1] << endl;
        			 else cout << "AncThetaTab[0]=" << _AncThetaTab[0] << endl;
                    if(DemographicModel=="OnePopFounderFlush") cout << "AncThetaTab[1]=" << _AncThetaTab[1] << endl;
        			cout << "ThetaDIG is now=" << MutMod1->ThetaDIG << endl;
                    if(DemographicModel=="OnePopFounderFlush") cout << "FounderThetaDIG is now=" << MutMod1->FounderThetaDIG << endl;
        			cout << "AncThetaDIG is now=" << MutMod1->AncThetaDIG << endl;
        			cout << "PopSize[0] is now=" << MigMod1->PopSize[0] << endl;
					cout << "PrevChangeTime is now=" << MigMod1->PrevChangeTime << endl;
					cout << "MinChangeTime is now=" << MigMod1->MinChangeTime << endl;
        			Print();
        			//MigMod1->PrintMig();
        			//MigMod1->PrintPopSize();
        			//MigMod1->PrintAncPopSize();
        			MigMod1->PrintChangeTime();
        		}
#endif

return(0);
} //end CSample::DemographicChange

int CSample::EssaiSequentialSample() {
using namespace NS_calclogl;
//cout<<"anc. time "<<ancestralScaledTimes[ancEventIt];
//cout<<"event "<<ancEventIt<<" "<<ancestralSuffixes[ancEventIt];
cout<<"ICI il faudrait d['e]faire le changement op['e]r['e] dans l'['e]chantillon ancestral "<<endl;
cout<<"comme dans code RL "<<endl;


               //Play safe: we don't try to guess the correct position in ProcessedLoci
               // Rather we seek CProcessedLocus with logical genepop file name and matching locus number
               {stringstream stst;
                vector<CProcessedLocus>::iterator it=ProcessedLoci.begin();
                    stst<<gp_file<<ancestralSuffixes[ancEventIt]; //reconstructs logical name of genepop file
                    while (it!=ProcessedLoci.end() && !(args.locus==it->locus && stst.str()==it->fileName) ) {
//cout<<endl<<it-ProcessedLoci.begin()<<" "<<args.locus<<" "<<it->locus;getchar();
                        it++;
                    }
                    if (it==ProcessedLoci.end()) {
                        cerr << "(!) Target not found in ProcessedLoci."<< endl;
                        if (cinGetOnError) cin.get();
                        exit(-1);
                    } /* else CProcessedLocus found...*/
//cout<<endl<<it-ProcessedLoci.begin();getchar();

                    //conversion from vector iterator to pointer...
                    CSample::LnHypergeom2tables(&(*it));
                    AddSample(it); // this changes a ProcessedLocus, not CurrentSample
                    unsigned int previousAlleleNbr=Sam_AlleleNbr; // the very first value served to dimension **PIs
                    GetSample(&(*it),localallelenbr,alleleNbrChecked); //this now changes CurrentSample members
                    if (alleleIndices.size()!=previousAlleleNbr) {
                        cerr << "\n(!) Number of allelic types changed in CurrentSample."<< endl;
                        cerr << " Sam_AlleleNbr determines **PIs allocation in new_L_etc..."<< endl;
                        cerr << " Lethal bug, spec. if new length > old length. "<< endl;
                        cerr << " new_L_etc... should be given correct info about allele number."<< endl;
                        if (cinGetOnError) cin.get();
                        exit(-1);
                    } /* else CProcessedLocus found...*/
//Print();
               } // block local variables
// apr[`e]s il lui donner l'heure: (en fait ca devrait etre l'inverse: il doir calculer scaled [`a] partir de real)
               scaled_generation=ancestralScaledTimes[ancEventIt];
               generation=-666666666; //FR something to be done...
		       ancEventIt++;
               beforeLastEvent=(ancEventIt < ( (int) ancestralScaledTimes.size() ) ); //becomes false when last event has been realized
return(0);
} //end CSample::EssaiSequentialSample

int CSample::checkOptions() {
    if(mutationModel!="PIM" && mutationModel!="ISM" && PopSampledOrNot>2) {
		cout<<"(!) Mutational Model specification in settings file=" << mutationModel << "\n or number of populations =" << PopSampledOrNot <<" in the genepop file is incorrect;"<<endl;
		cout<<"(!) SMM and GSM are implemented for the 1-2 pop model w/wout split but not for others (IBD and Npop>2)"<<endl;
		cout<<"exit."<< endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
	if(DemographicModel.substr(0,6)=="OnePop" && PopSampledOrNot>1) {
		cout<<"(!) Incongruence between Demographic Model specification in settings file or sample file;"<<endl;
		cout<<"(!) there is more than one population to be analyzed under the One Population Model"<<endl;
		cout<<"exit."<< endl;
		if (cinGetOnError) cin.get();
		exit(-1);
	}
return(0);
} //end Csample::checkOptions
